#include <math.h>
#include <time.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <values.h>
#include <string.h>
#include <ctype.h>
#include <dir.h>
#include <process.h>
#include <graphics.h>
#include "common.h"
#include "lowlevel.h"

extern void BadExit( const char* Msg);
extern void DoAProcessTimedToBiosClockTick( void);
extern void WriteHandpadStatus( void);
extern void DisplayIn( char* FileName, char* ObjectName);
extern void CalcResponseRowColFromResponse( void);
extern void ChangeMenuAttr_MenuDescr( void);
extern void ProcessMenuSelection( void);
extern void CalcResponseRowColFromResponse( void);
extern void PressKeyToContMsg( const char* Msg);

/* config... */

#define CfgFile "CONFIG.DAT"
#define MaxMs 10

void ReadConfig( void)
{
	/* defaults */
	DefaultBackground = 0;
	DefaultColor = 7;
	TitleColor = 9;
	BorderColor = 1;
	MenuColor = 12;
	DisplayColor = 12;
	SelectColor = 0;
	CurrentColor = 14;
	SelectBackground = 4;
	DisplayOpeningMsgs = 1;
	MoveHsMsgDeg = 10;
	InterfacePath = "C:\\GUIDE\\";
	HandPadPresentFlag = 1;
	IACA_Flag = 0;
	AltLowLimitDeg = 0;
	AltHighLimitDeg = 0;
	AzLowLimitDeg = 0;
	AzHighLimitDeg = 0;
	Siderostat = 0;
	HomeAltDeg = 0;
	HomeAzDeg = 0;
	MsArcsecSec = 300;
	BacklashMsArcsecSec = 500;
	AltFullStepSizeArcsec = 3;
	AzFullStepSizeArcsec = 3;
	RefractFlag = 0;
	AltBacklashArcmin = 0;
	AzBacklashArcmin = 0;
	GuideArcsecSec = 5;
	GuideDragAltArcsecPerMin = 10;
	GuideDragAzArcsecPerMin = 10;
	GuideDragRaArcsecPerMin = 10;
	GuideDragDecArcsecPerMin = 10;
	AutoAltPECSyncOnFlag = 0;
	AutoAltPECSyncLowHighFlag = 1;
	AutoAltPECSyncDirFlag = 0;
	AutoAzPECSyncOnFlag = 0;
	AutoAzPECSyncLowHighFlag = 1;
	AutoAzPECSyncDirFlag = 0;
	FullstepsPerPECArray = 200;
	FRStepSizeArcsec = 60;
	SectoredFRDrive = 1;
	FRStepSpeedMilliSec = 20;
	InvertOutput = 1;
	HsTimerFlag = 1;
	MaxDelay = 1000;
	MinDelay = 300;
	HsDelayX = 2;
	HsRampX = 5;
	InterruptHs = 100;
	HoldReps = 20;
	MaxConsecutiveSlews = 5;
	PWMRepsTick = 35;
	MsDelayX = 6;
	MsPause = 500;
	Ms = 10;
	PWM[0] = 100;
	PWM[1] = 100;
	PWM[2] = 100;
	PWM[3] = 100;
	PWM[4] = 100;
	PWM[5] = 100;
	PWM[6] = 85;
	PWM[7] = 70;
	PWM[8] = 55;
	PWM[9] = 35;
	PPortAddr = 1;
	EncoderString = "NoEncoders";
	EncoderComPort = 0;
	SerialWriteDelayMs = 50;
	AltEncoderCountsPerRev = 8192;
	AzEncoderCountsPerRev = 8192;
	AltEncoderDir = 1;
	AzEncoderDir = 0;
	EncoderErrorThresholdDeg = 0;
	TrackEncoderErrorThresholdDeg = 0;
	MakeEncoderResetLogFile = No;
	LX200ComPort = 0;
	LX200MotionTimeoutSec = 5;
	LX200SlewHs = 10000L;
	Z1Deg = 0;
	Z2Deg = 0;
	Z3Deg = 0;
	LatitudeDeg = 44;
	LongitudeDeg = 123;
	Tz = 8;
	DST = 1;
	TestString = "NoTest";

	Input = fopen( CfgFile, "r");
	if( Input == NULL)
		BadExit( strcat( "Could not open ", CfgFile));

	fscanf( Input, "%s", Name);
	while( !feof( Input))
	{
		/* if 1st char is ';' then goto next line */
		if( Name[0] == ';')
			FReadToNewLine( Input);
		if( (strncmpi( Name, "DefaultBackground", sizeof( Name))) == 0)
			ReadInt( Input, &DefaultBackground);
		if( (strncmpi( Name, "DefaultColor", sizeof( Name))) == 0)
			ReadInt( Input, &DefaultColor);
		if( (strncmpi( Name, "TitleColor", sizeof( Name))) == 0)
			ReadInt( Input, &TitleColor);
		if( (strncmpi( Name, "BorderColor", sizeof( Name))) == 0)
			ReadInt( Input, &BorderColor);
		if( (strncmpi( Name, "MenuColor", sizeof( Name))) == 0)
			ReadInt( Input, &MenuColor);
		if( (strncmpi( Name, "DisplayColor", sizeof( Name))) == 0)
			ReadInt( Input, &DisplayColor);
		if( (strncmpi( Name, "SelectColor", sizeof( Name))) == 0)
			ReadInt( Input, &SelectColor);
		if( (strncmpi( Name, "CurrentColor", sizeof( Name))) == 0)
			ReadInt( Input, &CurrentColor);
		if( (strncmpi( Name, "SelectBackground", sizeof( Name))) == 0)
			ReadInt( Input, &SelectBackground);
		if( (strncmpi( Name, "DisplayOpeningMsgs", sizeof( Name))) == 0)
			ReadFlag( Input, &DisplayOpeningMsgs);
		if( (strncmpi( Name, "MoveHsMsgDeg", sizeof( Name))) == 0)
			ReadDouble( Input, &MoveHsMsgDeg);
		if( (strncmpi( Name, "InterfacePath", sizeof( Name))) == 0)
			ReadString( Input, InterfacePath);
		if( (strncmpi( Name, "HandPadPresentFlag", sizeof( Name))) == 0)
			ReadFlag( Input, &HandPadPresentFlag);
		if( (strncmpi( Name, "IACA_Flag", sizeof( Name))) == 0)
			ReadFlag( Input, &IACA_Flag);
		if( (strncmpi( Name, "AltLowLimitDeg", sizeof( Name))) == 0)
			ReadDouble( Input, &AltLowLimitDeg);
		if( (strncmpi( Name, "AltHighLimitDeg", sizeof( Name))) == 0)
			ReadDouble( Input, &AltHighLimitDeg);
		if( (strncmpi( Name, "AzLowLimitDeg", sizeof( Name))) == 0)
			ReadDouble( Input, &AzLowLimitDeg);
		if( (strncmpi( Name, "AzHighLimitDeg", sizeof( Name))) == 0)
			ReadDouble( Input, &AzHighLimitDeg);
		if( (strncmpi( Name, "Siderostat", sizeof( Name))) == 0)
			ReadFlag( Input, &Siderostat);
		if( (strncmpi( Name, "HomeAltDeg", sizeof( Name))) == 0)
			ReadDouble( Input, &HomeAltDeg);
		if( (strncmpi( Name, "HomeAzDeg", sizeof( Name))) == 0)
			ReadDouble( Input, &HomeAzDeg);
		if( (strncmpi( Name, "MsArcsecSec", sizeof( Name))) == 0)
			ReadInt( Input, &MsArcsecSec);
		if( (strncmpi( Name, "BacklashMsArcsecSec", sizeof( Name))) == 0)
			ReadInt( Input, &BacklashMsArcsecSec);
		if( (strncmpi( Name, "AltFullStepSizeArcsec", sizeof( Name))) == 0)
			ReadDouble( Input, &AltFullStepSizeArcsec);
		if( (strncmpi( Name, "AzFullStepSizeArcsec", sizeof( Name))) == 0)
			ReadDouble( Input, &AzFullStepSizeArcsec);
		if( (strncmpi( Name, "RefractFlag", sizeof( Name))) == 0)
			ReadFlag( Input, &RefractFlag);
		if( (strncmpi( Name, "AltBacklashArcmin", sizeof( Name))) == 0)
			ReadDouble( Input, &AltBacklashArcmin);
		if( (strncmpi( Name, "AzBacklashArcmin", sizeof( Name))) == 0)
			ReadDouble( Input, &AzBacklashArcmin);
		if( (strncmpi( Name, "GuideArcsecSec", sizeof( Name))) == 0)
			ReadInt( Input, &GuideArcsecSec);
		if( (strncmpi( Name, "GuideDragAltArcsecPerMin", sizeof( Name))) == 0)
			ReadDouble( Input, &GuideDragAltArcsecPerMin);
		if( (strncmpi( Name, "GuideDragAzArcsecPerMin", sizeof( Name))) == 0)
			ReadDouble( Input, &GuideDragAzArcsecPerMin);
		if( (strncmpi( Name, "GuideDragRaArcsecPerMin", sizeof( Name))) == 0)
			ReadDouble( Input, &GuideDragRaArcsecPerMin);
		if( (strncmpi( Name, "GuideDragDecArcsecPerMin", sizeof( Name))) == 0)
			ReadDouble( Input, &GuideDragDecArcsecPerMin);
		if( (strncmpi( Name, "AutoAltPECSyncOnFlag", sizeof( Name))) == 0)
			ReadFlag( Input, &AutoAltPECSyncOnFlag);
		if( (strncmpi( Name, "AutoAltPECSyncLowHighFlag", sizeof( Name))) == 0)
			ReadFlag( Input, &AutoAltPECSyncLowHighFlag);
		if( (strncmpi( Name, "AutoAltPECSyncDirFlag", sizeof( Name))) == 0)
			ReadFlag( Input, &AutoAltPECSyncDirFlag);
		if( (strncmpi( Name, "AutoAzPECSyncOnFlag", sizeof( Name))) == 0)
			ReadFlag( Input, &AutoAzPECSyncOnFlag);
		if( (strncmpi( Name, "AutoAzPECSyncLowHighFlag", sizeof( Name))) == 0)
			ReadFlag( Input, &AutoAzPECSyncLowHighFlag);
		if( (strncmpi( Name, "AutoAzPECSyncDirFlag", sizeof( Name))) == 0)
			ReadFlag( Input, &AutoAzPECSyncDirFlag);
		if( (strncmpi( Name, "FullstepsPerPECArray", sizeof( Name))) == 0)
			ReadInt( Input, &FullstepsPerPECArray);
		if( (strncmpi( Name, "FRStepSizeArcsec", sizeof( Name))) == 0)
			ReadDouble( Input, &FRStepSizeArcsec);
		if( (strncmpi( Name, "SectoredFRDrive", sizeof( Name))) == 0)
			ReadFlag( Input, &SectoredFRDrive);
		if( (strncmpi( Name, "FRStepSpeedMilliSec", sizeof( Name))) == 0)
			ReadInt( Input, &FRStepSpeedMilliSec);
		if( (strncmpi( Name, "InvertOutput", sizeof( Name))) == 0)
			ReadInt( Input, &InvertOutput);
		if( (strncmpi( Name, "HsTimerFlag", sizeof( Name))) == 0)
			ReadInt( Input, &HsTimerFlag);
		if( (strncmpi( Name, "MaxDelay", sizeof( Name))) == 0)
			ReadInt( Input, &MaxDelay);
		if( (strncmpi( Name, "MinDelay", sizeof( Name))) == 0)
			ReadInt( Input, &MinDelay);
		if( (strncmpi( Name, "HsDelayX", sizeof( Name))) == 0)
			ReadInt( Input, &HsDelayX);
		if( (strncmpi( Name, "HsRampX", sizeof( Name))) == 0)
			ReadInt( Input, &HsRampX);
		if( (strncmpi( Name, "InterruptHs", sizeof( Name))) == 0)
			ReadInt( Input, &InterruptHs);
		if( (strncmpi( Name, "HoldReps", sizeof( Name))) == 0)
			ReadInt( Input, &HoldReps);
		if( (strncmpi( Name, "MaxConsecutiveSlews", sizeof( Name))) == 0)
			ReadInt( Input, &MaxConsecutiveSlews);
		if( (strncmpi( Name, "PWMRepsTick", sizeof( Name))) == 0)
			ReadInt( Input, &PWMRepsTick);
		if( (strncmpi( Name, "MsDelayX", sizeof( Name))) == 0)
			ReadInt( Input, &MsDelayX);
		if( (strncmpi( Name, "MsPause", sizeof( Name))) == 0)
			ReadInt( Input, &MsPause);
		if( (strncmpi( Name, "Ms", sizeof( Name))) == 0)
			ReadInt( Input, &Ms);
		if( (strncmpi( Name, "PWM[0]", sizeof( Name))) == 0)
			ReadInt( Input, &PWM[0]);
		if( (strncmpi( Name, "PWM[1]", sizeof( Name))) == 0)
			ReadInt( Input, &PWM[1]);
		if( (strncmpi( Name, "PWM[2]", sizeof( Name))) == 0)
			ReadInt( Input, &PWM[2]);
		if( (strncmpi( Name, "PWM[3]", sizeof( Name))) == 0)
			ReadInt( Input, &PWM[3]);
		if( (strncmpi( Name, "PWM[4]", sizeof( Name))) == 0)
			ReadInt( Input, &PWM[4]);
		if( (strncmpi( Name, "PWM[5]", sizeof( Name))) == 0)
			ReadInt( Input, &PWM[5]);
		if( (strncmpi( Name, "PWM[6]", sizeof( Name))) == 0)
			ReadInt( Input, &PWM[6]);
		if( (strncmpi( Name, "PWM[7]", sizeof( Name))) == 0)
			ReadInt( Input, &PWM[7]);
		if( (strncmpi( Name, "PWM[8]", sizeof( Name))) == 0)
			ReadInt( Input, &PWM[8]);
		if( (strncmpi( Name, "PWM[9]", sizeof( Name))) == 0)
			ReadInt( Input, &PWM[9]);
		if( (strncmpi( Name, "PPortAddr", sizeof( Name))) == 0)
			ReadUnsigned( Input, &PPortAddr);
		if( (strncmpi( Name, "EncoderString", sizeof( Name))) == 0)
			ReadString( Input, EncoderString);
		if( (strncmpi( Name, "EncoderComPort", sizeof( Name))) == 0)
			ReadInt( Input, &EncoderComPort);
		if( (strncmpi( Name, "SerialWriteDelayMs", sizeof( Name))) == 0)
			ReadInt( Input, &SerialWriteDelayMs);
		if( (strncmpi( Name, "AltEncoderCountsPerRev", sizeof( Name))) == 0)
			ReadUnsigned( Input, &AltEncoderCountsPerRev);
		if( (strncmpi( Name, "AzEncoderCountsPerRev", sizeof( Name))) == 0)
			ReadUnsigned( Input, &AzEncoderCountsPerRev);
		if( (strncmpi( Name, "AltEncoderDir", sizeof( Name))) == 0)
			ReadFlag( Input, &AltEncoderDir);
		if( (strncmpi( Name, "AzEncoderDir", sizeof( Name))) == 0)
			ReadFlag( Input, &AzEncoderDir);
		if( (strncmpi( Name, "EncoderErrorThresholdDeg", sizeof( Name))) == 0)
			ReadDouble( Input, &EncoderErrorThresholdDeg);
		if( (strncmpi( Name, "TrackEncoderErrorThresholdDeg", sizeof( Name))) == 0)
			ReadDouble( Input, &TrackEncoderErrorThresholdDeg);
		if( (strncmpi( Name, "MakeEncoderResetLogFile", sizeof( Name))) == 0)
			ReadFlag( Input, &MakeEncoderResetLogFile);
		if( (strncmpi( Name, "LX200ComPort", sizeof( Name))) == 0)
			ReadInt( Input, &LX200ComPort);
		if( (strncmpi( Name, "LX200MotionTimeoutSec", sizeof( Name))) == 0)
			ReadInt( Input, &LX200MotionTimeoutSec);
		if( (strncmpi( Name, "LX200SlewHs", sizeof( Name))) == 0)
			ReadLong( Input, &LX200SlewHs);
		if( (strncmpi( Name, "Z1Deg", sizeof( Name))) == 0)
			ReadDouble( Input, &Z1Deg);
		if( (strncmpi( Name, "Z2Deg", sizeof( Name))) == 0)
			ReadDouble( Input, &Z2Deg);
		if( (strncmpi( Name, "Z3Deg", sizeof( Name))) == 0)
			ReadDouble( Input, &Z3Deg);
		if( (strncmpi( Name, "LatitudeDeg", sizeof( Name))) == 0)
			ReadDouble( Input, &LatitudeDeg);
		if( (strncmpi( Name, "LongitudeDeg", sizeof( Name))) == 0)
			ReadDouble( Input, &LongitudeDeg);
		if( (strncmpi( Name, "Tz", sizeof( Name))) == 0)
			ReadInt( Input, &Tz);
		if( (strncmpi( Name, "DST", sizeof( Name))) == 0)
			ReadInt( Input, &DST);
		if( (strncmpi( Name, "TestString", sizeof( Name))) == 0)
			ReadString( Input, TestString);
		fscanf( Input, "%s", Name);
	}
	fclose( Input);
}

/* encoders... */

/* for MGIII, Ouranos, BBox, NGC modes, and StarPort units:
transmit 'Q', receive '+12345<tab>+67890<return>' = total of 14 chars,
+12345 = azimuth, <tab> = decimal 9, +67890 = altitude, <return> = decimal 13;

if 4000 count encoders, then output is from -2000 to +1999, representing
-180 to 180 degrees;

to change resolution, output 'Rxxxxx<tab>yyyyy<return>' where xxxxx is azimuth
and yyyyy is altitude, if resolution > 32767 then counts returned as unsigned,
counts go from 0 to resolution-1, max resolution is 65534, if command is
successful, receive 'R'

some units set resolution by outputting 'Zxxxxx<space>yyyyy' where xxxxx is
resolution in x axis and yyyyy is resolution in y axis; properly formatted 'Z'
command returns "*"; check current configuration by sending 'H', unit will
respond by sending current configuration

for BSeg unit:
transmit 'B' for native mode, receive 'B'<return> if successful;
transmit 'Q', receive 'HHHH<tab>HHHH<tab>HHHH<return> where HHHH is an unsigned
hexidecimal number;

set encoder resolution via jumpers on BSeg PCB */

void InitEncoders( void)
{
	EncoderType = NoEncoders;
	if( strcmpi( EncoderString, NoEncodersStr) == 0)
	{
		EncoderType = NoEncoders;
		EncoderState = NotInitialized;
		printf( "\n%s says no encoders", CfgFile);
	}
	else
	{
		if( MakeEncoderResetLogFile)
		{
			EncoderOutput = fopen( EncoderResetLogFile, "w");
			if( Input == NULL)
				BadExit( strcat( "Could not open ", EncoderResetLogFile));
		}
		if( strcmpi( EncoderString, EncoderBSegStr) == 0)
		{
			EncoderType = EncoderBSeg;
			ResetEncoders_f_ptr = ResetEncodersBSeg;
			ReadEncoders_f_ptr = ReadEncodersBSeg;
			QueryEncoders_f_ptr = QueryEncodersQ;
			InitEncodersBSeg();
		}
		else
			if( strcmpi( EncoderString, EncoderResetViaRStr) == 0)
			{
				EncoderType = EncoderResetViaR;
				ResetEncoders_f_ptr = ResetEncodersResetViaR;
				ReadEncoders_f_ptr = ReadEncodersQ;
				QueryEncoders_f_ptr = QueryEncodersQ;
				InitEncodersResetViaR();
			}
			else
				if( strcmpi( EncoderString, EncoderResetViaZStr) == 0)
				{
					EncoderType = EncoderResetViaZ;
					ResetEncoders_f_ptr = ResetEncodersResetViaZ;
					ReadEncoders_f_ptr = ReadEncodersQ;
					QueryEncoders_f_ptr = QueryEncodersQ;
					InitEncodersResetViaZ();
				}
				else
					if( strcmpi( EncoderString, EncoderNoResetStr) == 0)
					{
						EncoderType = EncoderNoReset;
						ResetEncoders_f_ptr = ResetEncodersNoReset;
						ReadEncoders_f_ptr = ReadEncodersQ;
						QueryEncoders_f_ptr = QueryEncodersQ;
						InitEncodersNoReset();
					}
					else
						if( strcmpi( EncoderString, EncoderMouseStr) == 0)
						{
							EncoderType = EncoderMouse;
							ResetEncoders_f_ptr = ResetEncodersMouse;
							ReadEncoders_f_ptr = ReadEncodersMouse;
							QueryEncoders_f_ptr = QueryEncodersMouse;
							InitEncodersMouse();
						}
						else
							BadExit( strcat( "Bad EncoderString: ", EncoderString));
	}
	if( EncoderComPort < 0 || EncoderComPort > 2)
		BadExit( "EncoderComPort must be 0, 1, or 2");
	if( EncoderType && !AltEncoderCountsPerRev)
		BadExit( "AltEncoderCountsPerRev must be > 0");
	if( EncoderType && !AzEncoderCountsPerRev)
		BadExit( "AzEncoderCountsPerRev must be > 0");

	EncoderTrackOnResetCount = 0;
	EncoderTrackOffResetCount = 0;
	EncoderSlewResetCount = 0;
}

void CloseEncoderResetLogFile( void)
{
	if( MakeEncoderResetLogFile)
		fclose( EncoderOutput);
}

void InitEncodersBSeg( void)
{
	Byte B;
	Flag QuitFlag = No;

	ResetEncoderBox = True;
	printf( "\nUse current encoder BSeg box coordinates (y/n)? ");
	Response = getch();
	if( Response == 'y' || Response == 'Y')
	{
		printf( " yes");
		QueryAndReadEncoders();
		if( EncoderState == Read)
		{
			ResetEncoderBox = False;
			printf( "\nSuccessfully read encoder BSeg box alt: %6ld az: %6ld",
			EncoderCount.A, EncoderCount.Z);
		}
		else
			printf( "\nCould not read encoder BSeg box");
	}
	else
		printf( " no");

	if( ResetEncoderBox)
	{
		if( DisplayOpeningMsgs)
		{
			printf( "\nPress any key after turning on the encoder BSeg box...\n");
			while( !QuitFlag)
			{
				if( ReadSerial( EncoderComPort, &B))
					printf( "%c", B);
				if( KeyStroke)
				{
					QuitFlag = Yes;
					B = getch();
				}
			}
		}
		ResetEncoders_f_ptr();
		/* report results */
		if( DisplayOpeningMsgs)
		{
			if( EncoderState == Read)
				printf( "\nSet encoder BSeg box to native mode");
			else
				printf( "\nCould not set encoder BSeg box to native mode");
		}
		/* get initial encoder counts */
		if( EncoderState == Read)
		{
			QueryAndReadEncoders();
			if( DisplayOpeningMsgs)
				if( EncoderState == Read)
					printf( "\nRead encoder BSeg box");
				else
					printf( "\nCould not read encoder BSeg box");
		}
	}
}

void InitEncodersResetViaR( void)
{
	Byte B;
	Flag QuitFlag = No;

	ResetEncoderBox = True;
	printf( "\nUse current encoder ResetViaR box coordinates (y/n)? ");
	Response = getch();
	if( Response == 'y' || Response == 'Y')
	{
		printf( " yes");
		QueryAndReadEncoders();
		if( EncoderState == Read)
		{
			ResetEncoderBox = False;
			printf( "\nSuccessfully read encoder ResetViaR box alt: %6ld az: %6ld",
			EncoderCount.A, EncoderCount.Z);
		}
		else
			printf( "\nCould not read encoder ResetViaR box");
	}
	else
		printf( " no");

	if( ResetEncoderBox)
	{
		if( DisplayOpeningMsgs)
		{
			printf( "\nPress any key after turning on the encoder ResetViaR box...\n");
			while( !QuitFlag)
			{
				if( ReadSerial( EncoderComPort, &B))
					printf( "%c", B);
				if( KeyStroke)
				{
					QuitFlag = Yes;
					B = getch();
				}
			}
		}
		ResetEncoders_f_ptr();
		/* report results */
		if( DisplayOpeningMsgs)
		{
			if( EncoderState == Read)
				printf( "\nReset encoder ResetViaR box to %u %u counts per revolution",
				AltEncoderCountsPerRev, AzEncoderCountsPerRev);
			else
				printf( "\nCould not set encoder ResetViaR box");
		}
		/* get initial encoder counts */
		if( EncoderState == Read)
		{
			QueryAndReadEncoders();
			if( DisplayOpeningMsgs)
				if( EncoderState == Read)
					printf( "\nRead encoder ResetViaR box");
				else
					printf( "\nCould not read encoder ResetViaR box");
		}
	}
}

void InitEncodersResetViaZ( void)
{
	Byte B;
	Flag QuitFlag = No;

	ResetEncoderBox = True;
	printf( "\nUse current encoder ResetViaZ box coordinates (y/n)? ");
	Response = getch();
	if( Response == 'y' || Response == 'Y')
	{
		printf( " yes");
		QueryAndReadEncoders();
		if( EncoderState == Read)
		{
			ResetEncoderBox = False;
			printf( "\nSuccessfully read encoder ResetViaZ box alt: %6ld az: %6ld",
			EncoderCount.A, EncoderCount.Z);
		}
		else
			printf( "\nCould not read encoder ResetViaZ box");
	}
	else
		printf( " no");

	if( ResetEncoderBox)
	{
		if( DisplayOpeningMsgs)
		{
			printf( "\nPress any key after turning on the encoder ResetViaZ box...\n");
			while( !QuitFlag)
			{
				if( ReadSerial( EncoderComPort, &B))
					printf( "%c", B);
				if( KeyStroke)
				{
					QuitFlag = Yes;
					B = getch();
				}
			}
		}
		ResetEncoders_f_ptr();
		/* report results */
		if( DisplayOpeningMsgs)
		{
			if( EncoderState == Read)
				printf( "\nReset encoder ResetViaZ box to %u %u counts per revolution",
				AltEncoderCountsPerRev, AzEncoderCountsPerRev);
			else
				printf( "\nCould not set encoder ResetViaZ box");
		}
		/* get initial encoder counts */
		if( EncoderState == Read)
		{
			QueryAndReadEncoders();
			if( DisplayOpeningMsgs)
				if( EncoderState == Read)
					printf( "\nRead encoder ResetViaZ box");
				else
					printf( "\nCould not read encoder ResetViaZ box");
		}
	}
}

void InitEncodersNoReset( void)
{
	Byte B;
	Flag QuitFlag = No;

	ResetEncoderBox = True;
	printf( "\nUse current encoder NoReset box coordinates (y/n)? ");
	Response = getch();
	if( Response == 'y' || Response == 'Y')
	{
		printf( " yes");
		QueryAndReadEncoders();
		if( EncoderState == Read)
		{
			ResetEncoderBox = False;
			printf( "\nSuccessfully read encoder NoReset box alt: %6ld az: %6ld",
			EncoderCount.A, EncoderCount.Z);
		}
		else
			printf( "\nCould not read encoder NoReset box");
	}
	else
		printf( " no");

	if( ResetEncoderBox)
	{
		if( DisplayOpeningMsgs)
		{
			printf( "\nPress any key after turning on the encoder NoReset box...\n");
			while( !QuitFlag)
			{
				if( ReadSerial( EncoderComPort, &B))
					printf( "%c", B);
				if( KeyStroke)
				{
					QuitFlag = Yes;
					B = getch();
				}
			}
		}
		/* get initial encoder counts */
		if( EncoderState == Read)
		{
			QueryAndReadEncoders();
			if( DisplayOpeningMsgs)
				if( EncoderState == Read)
					printf( "\nRead encoder NoReset box");
				else
					printf( "\nCould not read encoder NoReset box");
		}
	}
}

void InitEncodersMouse( void)
{
	/* this function calls BadExit() if not successful */
	ResetMouse();
	printf( "\nUsing mouse encoder");
	/* set relative counters to zero */
	GetMousePositionRelative();
	EncoderState = Read;
}

/* sets BSeg to native mode */
void ResetEncodersBSeg( void)
{
	Byte B1 = 0;
	Byte B2 = 0;

	WriteSerial( EncoderComPort, 'B');
	delay( SerialWriteDelayMs);
	ReadSerial( EncoderComPort, &B1);
	ReadSerial( EncoderComPort, &B2);
	if( B1 == 'B' && B2 == Return)
		EncoderState = Read;
	else
		EncoderState = CommError;
}

void ResetEncodersResetViaR( void)
{
	Byte B = 0;

	/* send Rzzzzz<Tab>aaaaa<Return>, if successful, expect 'R' */
	EncStr[0] = 'R';
	EncStr[6] = Tab;
	EncStr[12] = Return;

	BuildEncStrRes();

	for( EncIx = 0; EncIx < MaxEncStr; EncIx++)
	{
		WriteSerial( EncoderComPort, EncStr[EncIx]);
		delay( SerialWriteDelayMs);
	}
	/* get to last char sent */
	while( ReadSerial( EncoderComPort, &B))
		;
	if( B == 'R')
		EncoderState = Read;
	else
		EncoderState = CommError;
}
                
void ResetEncodersResetViaZ( void)
{
	Byte B = 0;

	/* send Zxxxxx<space>yyyyy<Return>, if successful, expect '*' */
	EncStr[0] = 'Z';
	EncStr[6] = ' ';
	EncStr[12] = Return;

	BuildEncStrRes();

	for( EncIx = 0; EncIx < MaxEncStr; EncIx++)
	{
		WriteSerial( EncoderComPort, EncStr[EncIx]);
		delay( SerialWriteDelayMs);
	}
	/* get to last char sent */
	while( ReadSerial( EncoderComPort, &B))
		;
	if( B == '*')
		EncoderState = Read;
	else
		EncoderState = CommError;
}

void ResetEncodersNoReset( void)
{
	EncoderState = Read;
}

void ResetEncodersMouse( void)
{
	GetMousePositionRelative();
	EncoderState = Read;
}

void BuildEncStrRes( void)
{
	unsigned Res;
	int X;

	Res = AzEncoderCountsPerRev;
	X = Res/10000;
	EncStr[1] = '0' + X;
	Res -= X*10000;
	X = Res/1000;
	EncStr[2] = '0' + X;
	Res -= X*1000;
	X = Res/100;
	EncStr[3] = '0' + X;
	Res -= X*100;
	X = Res/10;
	EncStr[4] = '0' + X;
	Res -= X*10;
	EncStr[5] = '0' + Res;

	Res = AltEncoderCountsPerRev;
	X = Res/10000;
	EncStr[7] = '0' + X;
	Res -= X*10000;
	X = Res/1000;
	EncStr[8] = '0' + X;
	Res -= X*1000;
	X = Res/100;
	EncStr[9] = '0' + X;
	Res -= X*100;
	X = Res/10;
	EncStr[10] = '0' + X;
	Res -= X*10;
	EncStr[11] = '0' + Res;
}

void QueryEncodersQ( void)
{
	InitRingBuffer( EncoderComPort);
	if( WriteSerial( EncoderComPort, (Byte) 'Q'))
		EncoderState = ReadReady;
	else
		EncoderState = CommError;
	for( EncIx = 0; EncIx < MaxEnc; EncIx++)
		EncStr[EncIx] = 0;
	EncIx = 0;
}

void QueryEncodersMouse( void)
{
	GetMousePositionRelative();
	EncoderState = ReadReady;
}

/*                   111   1
index: 012345  6  789012   3
char:  +12345<tab>+67890<return> (some use space instead of tab) */

void ReadEncodersQ( void)
{
	char Num[7];

	while( EncIx<MaxEncStr && ReadSerial( EncoderComPort, &EncStr[EncIx++]))
		;
	if( EncIx==MaxEncStr
	&& (EncStr[6]==Tab || EncStr[6]==Blank)
	&& EncStr[13]==Return)
	{
		Num[6] = '\0';
					  
		/* azimuth */
		strncpy( Num, (char*) &EncStr[0], 6);
		EncoderCount.Z = atol( Num);

		/* altitude */
		strncpy( Num, (char*) &EncStr[7], 6);
		EncoderCount.A = atol( Num);

		EncIx = 0;
		EncoderState = Read;

		if( !AltEncoderDir)
			if (EncoderType == EncoderResetViaR && AltEncoderCountsPerRev <= 32767)
				/* encoder counts from - values to + values... */
				EncoderCount.A = -EncoderCount.A;
			else
				/* encoder counts from 0 up... */
				EncoderCount.A = AltEncoderCountsPerRev - EncoderCount.A;
		if( !AzEncoderDir)
			if (EncoderType == EncoderResetViaR && AltEncoderCountsPerRev <= 32767)
				EncoderCount.Z = -EncoderCount.Z;
			else
				EncoderCount.Z = AzEncoderCountsPerRev - EncoderCount.Z;
	}
	else
		EncoderState = NoRead;
}

/*                       1111   1
index: 0123  4  5678  9  0123   4
char:  HHHH<tab>HHHH<tab>HHHH<return> */

/* BSeg box must be jumpered to output 3 encoders (alt, az, field rotation) */
void ReadEncodersBSeg( void)
{
	char Num[7];
	char* EndPtr;

	while( EncIx<MaxEncBSeg && ReadSerial( EncoderComPort, &EncStr[EncIx++]))
		;
	if( EncIx==MaxEncBSeg && EncStr[4]==Tab && EncStr[9]==Tab
	&& EncStr[14]==Return)
	{
		Num[0] = '0';
		Num[1] = 'x';
		Num[6] = '\0';

		/* azimuth */
		strncpy( &Num[2], (char*) &EncStr[0], 4);
		/* 0x10 means that Num is in hex (base 0x10) */
		EncoderCount.Z = strtol( Num, &EndPtr, 0x10);

		/* altitude */
		strncpy( &Num[2], (char*) &EncStr[5], 4);
		EncoderCount.A = strtol( Num, &EndPtr, 0x10);

		EncIx = 0;
		EncoderState = Read;

		if( !AltEncoderDir)
			EncoderCount.A = AltEncoderCountsPerRev - EncoderCount.A;
		if( !AzEncoderDir)
			EncoderCount.Z = AzEncoderCountsPerRev - EncoderCount.Z;
	}
	else
		EncoderState = NoRead;
}

void ReadEncodersMouse( void)
{
	EncoderCount.A += MouseYMickeyRelative;
	if( EncoderCount.A > AltEncoderCountsPerRev)
		EncoderCount.A -= AltEncoderCountsPerRev;
	if( EncoderCount.A < 0L)
		EncoderCount.A += AltEncoderCountsPerRev;

	EncoderCount.Z += MouseXMickeyRelative;
	if( EncoderCount.Z > AzEncoderCountsPerRev)
		EncoderCount.Z -= AzEncoderCountsPerRev;
	if( EncoderCount.Z < 0L)
		EncoderCount.Z += AzEncoderCountsPerRev;

	EncoderState = Read;
}

void QueryAndReadEncoders( void)
{
	QueryEncoders_f_ptr();
	delay( SerialWriteDelayMs);
	ReadEncoders_f_ptr();
}

void TestEncoders( void)
{
	int X, Y;

	printf( "\n\n\nTest of encoders, press any key to quit...\n\n");
	X = wherex();
	Y = wherey();
	while( !KeyStroke)
	{
		QueryAndReadEncoders();
		if( EncoderState == Read)
		{
			gotoxy( X, Y);
			printf("Encoder counts of alt: %6ld az: %6ld", EncoderCount.A,
			EncoderCount.Z);
			delay( SerialWriteDelayMs);
		}
	}
	getch();
	NewLine;
	NewLine;
	ContMsgRoutine();
}

/* HANDPAD LAYOUT

handpad uses 4 data lines, each line tied to a bit from the parallel port,
attach bit 16 to pin 13 of the parallel port,
attach bit 32 to pin 12 of the parallel port,
attach bit 64 to pin 10 of the parallel port,
attach bit 128 to pin 11 of the parallel port,

the handpad also needs + 5V DC

use a 9 pin serial connector cable to attach the handpad to the pc

when a button( s) is pressed, + 5V DC is applied to the appropriate bit( s),
otherwise the bit( s) is left pulled to ground

all bits are pulled to ground with 220 ohm resistors

use diodes positioned just after the switches and buttons to ensure that
only the bits desired are raised to + 5V DC

upper part of handpad is a 3 way switch, and is wired in the following
manner:
switch position #1, for initializing position #1 and other functions,
activates bits 16, 64
switch position #2, neutral: does nothing, activates nothing
switch position #3, for initializing position #2 and other functions,
activates bits 32, 64
switch also used for other functions via keyboard direction;

lower part of handpad consists of 4 momentary on buttons in the following
pattern with a 2 way switch in the middle:
  *
* S *
  *

upper button = Up, activates bit 16
lower button = Down, activates bit 32
left button = CCW, activates bit 64
right button = CW, activates bits 16, 32

switch position #1, slow microstepping, activates bit 128
switch position #2, fast halfstepping, activates nothing */

void InitHandpad( void)
{
	if( HandPadPresentFlag)
		ReadHandPad_f_ptr = ReadHandPad;
	else
		ReadHandPad_f_ptr = NoHandPad;

	ReadHandPad_f_ptr();
	MsSpeed = HandPad&MsKey;
	Buttons = HandPad - MsSpeed;
	if( Buttons == CCWKey)
	{
		printf( "\nhandpad not connected or CCW button depressed - ignoring handpad");
		ReadHandPad_f_ptr = NoHandPad;
	}
	if( Buttons == CWKey)
	{
		printf( "\nhandpad not connected or CW button depressed - ignoring handpad");
		ReadHandPad_f_ptr = NoHandPad;
	}
	if( Buttons == UpKey)
	{
		printf( "\nhandpad not connected or UP button depressed - ignoring handpad");
		ReadHandPad_f_ptr = NoHandPad;
	}
	if( Buttons == DownKey)
	{
		printf( "\nhandpad not connected or Down button depressed - ignoring handpad");
		ReadHandPad_f_ptr = NoHandPad;
	}
}

void ReadHandPad( void)
{
	/* from InNibble() */
	/* only select upper 4 bits and then invert highest bit (128) */
	HandPad = (inportb( PPortAddrInNibble)& 240)^128;
}

void NoHandPad( void)
{
	HandPad = MsKey;
}

void SetHandPadOKFlag( void)
{
	/* once HandPad no longer equals InitHandPad, don't let HandPadOKFlag be
	reset to True by subsequent reads of the hand paddle */
	if( HandPadOKFlag)
	{
		ReadHandPad_f_ptr();
		if( HandPad == InitHandPad)
			HandPadOKFlag = Yes;
		else
			HandPadOKFlag = No;
	}
}

void TestHandpad( void)
{
	int Input;
	int Pad;

	printf( "\n\n\nTest of handpad code...'r' to read Pad, 'q' to quit.\n");
	Input = ' ';
	while( Input != 'q')
	{
		Input = getch();
		if( Input == 'r' || Input == 'R')
		{
			Pad = BiDirInNibble() + InNibble();
			printf( "bit1:%d", Pad&1?1:0);
			printf( " bit2:%d", Pad&2?1:0);
			printf( " bit4:%d", Pad&4?1:0);
			printf( " bit8:%d", Pad&8?1:0);
			printf( " bit16:%d", Pad&16?1:0);
			printf( " bit32:%d", Pad&32?1:0);
			printf( " bit64:%d", Pad&64?1:0);
			printf( " bit128:%d", Pad&128?1:0);
			NewLine;
			printf( "---> buttons pressed: ");
			Pad &= 240;
			if( Pad&MsKey)
			{
				printf( "Microstep ");
				Pad -= MsKey;
			}
			else
				printf( "Halfstep ");
			switch( Pad)
			{
				case LeftKey:
					printf( " leftkey");
					break;
				case RightKey:
					printf( " rightkey");
					break;
				case UpKey:
					printf( " up ");
					break;
				case DownKey:
					printf( " down ");
					break;
				case CCWKey:
					printf( " CCW ");
					break;
				case CWKey:
					printf( " CW ");
					break;
				case None:
					printf( " no other key pressed ");
					break;
				default:
					printf( " unknown ");
			}
			NewLine;
		}
	}
	NewLine;
	ContMsgRoutine();
}

/* Steppers */

/* each of the 4 windings of a motor is controlled directly through the
parallel port by Pulse Width Modulation, thereby giving individual
current/voltage control over each winding;

move in overvoltage, halfstep mode for fastest speed, highest torque motion:
	homebuilt stepper motor drive circuit with diode + zener suppression +
	4X overdrive voltage with smooth ramping = 10,000 hs/sec with minimal torque
	loading; 

move in microstep mode for smooth, fine motion;

microstepping algorithm:
	for first full step (angle of 0 deg to 90 deg):
	start winding A with max voltage and winding B with 0 voltage,
	gradually ramp winding B voltage up to max voltage and ramp down winding
	A voltage to 0: electromagnetic force is felt by the inverse square of the
	distance, so to position the rotor at distance 'a' from winding A and
	distance 'b' from winding B, with full voltage for winding A, the voltage for
	winding B will be sqr( a/b),
	can skip over microsteps up to halfstep for faster speed,
	experiment shows that theoretical cos/sin voltage values need to be modified
	slightly to take into account timing idiosyncrasies of the PC and the
	finite on/off timing of the opto-isolators and drive transistors;

microstep accuracy:
	from stepper motor theory and manuals:
	absolute accuracy is 5' or ~1/22 full step (1 full step = 1.8 degrees),
	shaft deflection directly proportional to torque loading when positioned
	inbetween windings;
	conclusion: if torque loading < 10%, 10 microsteps/fullstep OK,
	at minimum, stepper should be accurate at quarter steps;

Halfstepping:
Halfstep                                        Winding:
																Bit Sum
								A   B   C   D
1                       1   0   0   0           1
2                       1   1   0   0           3
3                       0   1   0   0           2
4                       0   1   1   0           6
5                       0   0   1   0           4
6                       0   0   1   1           12
7                       0   0   0   1           8
8                       1   0   0   1           9

Module algorithms:
	1. use microsteps for tracking & guiding, and halfsteps for slewing,
	2. use PWM (Pulse Width Modulation) to control motor winding voltages,
	3. keep CPU usage (recalculations, writing to screen, etc) to mimimum
	while microstepping to keep motor rotation smooth, minimum PC requirements
	probably are slow 386, with co-processor for conversion routines,
	4. use pre-calculated Byte arrays for outportb() values for faster speed,
	5. speed of microstepping set by:
		a. (double) IncrMs which says how many microsteps per PWM
		will occur; when IncrMs > 1 (max is 5, equivalent to halfstepping),
		some microsteps are skipped,
		b. # of PWM per bios clock tick (bios clock tick occurs 18.2x a second)
		is approximated by PWMRepsTick, no matter the value of PWMRepsTick,
		microstepping PWM will conclude with when bios clock tick occurs
		checked for at the end of each PWM),
	6. tracking timing (re-)synchronized by bios clock tick,
	7. start half stepping with a holding time to precisely align rotor,
	8. when finished with halfstepping or microstepping, end on fullstep
	alignment with braking time to dampen shaft oscillation, 
	9. speed of halfstepping determined by var HsTimerFlag, where 1 means to
	hook IRQ 8 interrupt, and 0 means to disable IRQs and time halfsteps by a
	delay loop of (MaxDelay - MinDelay)*HsDelayX,
	10.IRQ 8 timer is set to mode 4 to time the steps; mode 4 outputs a single
	pulse at the end of a countdown period; the counter does not start until
	it is loaded by software; the period range is about 1 us to 54 ms for count
	values of 1 to 65536. 65536 is the familiar 18.2 times a second of the
	standard timer; thus the MinDelay and MaxDelay are specified in about
	1 us increments; this range should cover most stepper requirements;
	6v Steppers start to stall at about 250 us with a 12 volt supply;
	the interrupt routine should not take longer to execute than the shortest
	stepper pulse; so far testing has shown that a 286/16Mhz can easily keep up
	even with a MinDelay of only 50 us; suggested by Dale Eason who provided
	sample code,
	10a.interrupt timer speed set by HsRepsIx + MinDelay, where HsRepsIx at
	slowest speed = MaxDelay - MinDelay, and at max speed = 0,
	10b.in parallel while halfstep slewing, control kept in MoveHs(), where
	aborts are checked for and displays updated,
	11.linearily ramp motor speed during halfstepping to protect worm and
	gear speed reducer and to give fastest slewing speed possible,
	12.for long, open loop slews, set steps to move to MAXLONG - 1 and bring
	motor to ramped stop by setting HsMoveOKFlag,
	13.reset pc time based on CMOS clock when finished with halfstepping,
	14.module keeps track of accumulated steps made,
	15.controls 2 motors called 'A' and 'Z',
	16.slewing moves both motors initially then finishes with the remaining
	motor's leftover steps,
	17.for faster PCs, repeat each microstepping outportb() MsDelayX times
	and run through a pause loop MsPause times,
	18.use parallel port to interface to motors since the parallel port has 8
	bits of output; */

void InitSteppers( void)
{
	int IxA;

	if( AltFullStepSizeArcsec < 0)
		BadExit( "AltFullStepSizeArcsec must be positive value");
	if( AzFullStepSizeArcsec < 0)
		BadExit( "AzFullStepSizeArcsec must be positive value");
	if( MinDelay >= MaxDelay)
		BadExit( "MinDelay >= MaxDelay in Steppers module");
	if( HsDelayX < 1)
		HsDelayX = 1;
	if( HsRampX < 1)
		HsRampX = 1;
	if( MsDelayX < 1)
		MsDelayX = 1;
	if( Ms > MaxMs)
		BadExit( "Ms value too large");

	SlewState = SlewDone;
	AbortState = NoAbort;

	AltLowLimit = AltLowLimitDeg/RadToDeg;
	AltHighLimit = AltHighLimitDeg/RadToDeg;
	if( AltLowLimit == AltHighLimit)
		AltLimitFlag = No;
	else
		AltLimitFlag = Yes;
	AzLowLimit = AzLowLimitDeg/RadToDeg;
	AzHighLimit = AzHighLimitDeg/RadToDeg;
	if( AzLowLimit == AzHighLimit)
		AzLimitFlag = No;
	else
		AzLimitFlag = Yes;

	/* microstep size in arc seconds */
	MicroStepSizeArcsec.A = AltFullStepSizeArcsec / Ms;
	MicroStepSizeArcsec.Z = AzFullStepSizeArcsec / Ms;

	/* length of one microstep in Radians = MsRad. */
	MsRad.A = MicroStepSizeArcsec.A / RadToArcsec;
	MsRad.Z = MicroStepSizeArcsec.Z / RadToArcsec;

	/* length of one halfstep in Radians = HsRad. */
	MsPerHs = Ms/2;
	HsRad.A = MsRad.A*MsPerHs;
	HsRad.Z = MsRad.Z*MsPerHs;

	/* max Ms distance possible in one bios clock tick */
	MaxMsDistanceRadTick.A = PWMRepsTick * MsPerHs * MsRad.A;
	MaxMsDistanceRadTick.Z = PWMRepsTick * MsPerHs * MsRad.Z;

	/* set maximum microstepping speed */
	if( MicroStepSizeArcsec.A < MicroStepSizeArcsec.Z)
		MaxMsSpeed = PWMRepsTick * MsPerHs * ClockTicksSec * MicroStepSizeArcsec.A;
	else
		MaxMsSpeed = PWMRepsTick * MsPerHs * ClockTicksSec * MicroStepSizeArcsec.Z;

	/* set vars for microstepping velocity based on arc seconds per seconds */
	InitMsTickVars( MsArcsecSec);

	/* 'A' motor lower nibble, 'Z' motor upper nibble */
	if( InvertOutput)
	{
		MotorOff.A = 0x0F;
		MotorOff.Z = 0xF0;
	}
	else
		MotorOff.Z = MotorOff.A = 0;

	MotorPort = PPortAddrOutByte;
	SteppersOff();

	Dir.A = Dir.Z = CW;

	HsIx.A = HsIx.Z = 0;
	MsIx.A = MsIx.Z = 0;
	Steps.A = Steps.Z = 0;
	AccumMs.A = AccumMs.Z = 0;
	IncrMs.A = IncrMs.Z = 0;

	/* A motor uses bits 0 to 3 (1, 2, 4, 8) */
	HsOut[0].A = 1;
	HsOut[1].A = 3;
	HsOut[2].A = 2;
	HsOut[3].A = 6;
	HsOut[4].A = 4;
	HsOut[5].A = 12;
	HsOut[6].A = 8;
	HsOut[7].A = 9;
	/* Z motor uses bits 4 to 7 (16, 32, 64, 128) */
	for( IxA = 0; IxA <= MaxHsIx; IxA++)
		HsOut[IxA].Z = HsOut[IxA].A << 4;

	CreateHsArrays();
	InitHsArrays();

	CreateMsArrays();
	InitMsArrays();
}

void CreateHsArrays( void)
{
	/* set MaxHsRepsIx */
	MaxHsRepsIx = MaxDelay - MinDelay;
	/* build HsReps array */
	HsReps = (long*) malloc( (MaxHsRepsIx + 1) * sizeof( long));
	if( HsReps == NULL)
		BadExit( "Problem with malloc of HsReps in steppers module");
}

void InitHsArrays( void)
{
	int IxA;

	/* since MoveHs() rounds up to nearest full step */
	MaxHs = MAXLONG - 1;
	HsReps[0] = MaxHs;
	for( HsRepsIx = 1; HsRepsIx <= MaxHsRepsIx; HsRepsIx++)
		HsReps[HsRepsIx] = (long) HsRampX * (long) MaxDelay /
		(long) (HsRepsIx + MinDelay);

	if( InvertOutput)
		for( IxA = 0; IxA <= MaxHsIx; IxA++)
		{
			HsOut[IxA].A = MotorOff.A - HsOut[IxA].A;
			HsOut[IxA].Z = MotorOff.Z - HsOut[IxA].Z;
		}
}

void FreeHsArrays( void)
{
	free( HsReps);
}

void CreateMsArrays( void)
{
	MaxPWM = PWM[0];
	HsIxToMsIxConvFactor = MaxPWM*MsPerHs;
	/* set MaxMsIx;
	# of microstep waveforms = # of microsteps (Ms) * # of windings (4);
	# of elements in microstep array = # of microstep waveforms *
	# of pulse width modulations per microstep voltage (MaxPWM) */
	MaxMsIx = Ms*MotorWindings*MaxPWM - 1;

	/* build microstep arrays */
	MsPWM = (struct AZByte*) malloc( (MaxMsIx + 1) * sizeof( struct AZByte));
	if( MsPWM == NULL)
		BadExit( "Problem with malloc of MsPWM in steppers module ");
}

void InitMsArrays( void)
{
	int Winding;
	int MicroStep;
	int WindingA, WindingB;
	int IxA, IxB;

	/* cleanup PWM[]: no negative values and no PWM[] greater than PWM[0] */
	for( IxA = 0; IxA < MaxMs; IxA++)
		if( PWM[IxA] < 0)
			PWM[IxA] = 0;
		else
			if( PWM[IxA] > PWM[0])
				PWM[IxA] = PWM[0];

	/* zero out arrays */
	for( IxA = 0; IxA <= MaxMsIx; IxA++)
		MsPWM[IxA].Z = MsPWM[IxA].A = 0;

	/* start winding A at bit #1 and winding B at bit #2,
	winding A will start at the highest microstep voltage and ramp
	down to zero volts while winding B will start at zero volts and
	ramp up */
	WindingA = 1;
	WindingB = 2;

	/* start base index of microstep array at the beginning,
	index is incremented by MaxPWM (# of pulse width modulations
	per microstep voltage) */
	IxA = 0;

	/* microstep array has 4 windings to build */
	for( Winding = 1; Winding <= MotorWindings; Winding++)
	{
		/* each winding has Ms # of microsteps to build */
		for( MicroStep = 0; MicroStep < Ms; MicroStep++)
		{
			/* turn on the winding A bit for PWM[MicroStep] # of times */
			for( IxB = 0; IxB < PWM[MicroStep]; IxB++)
				MsPWM[IxA+IxB].A += WindingA;
			/* Microstep == 0 has no contribution from Winding B */
			if( MicroStep > 0)
				/* the winding B microstep that corresponds to the winding A
				microstep of Ms is Ms - MicroStep,
				ie, if the total # of microsteps = 10
				microstep     winding A Winding B
				0             PWM[0]  n/a
				1             PWM[1]  PWM[9]
				2             PWM[2]  PWM[8]
				3             PWM[3]  PWM[7]
				4             PWM[4]  PWM[6]
				5             PWM[5]  PWM[5]
				6             PWM[6]  PWM[4]
				7             PWM[7]  PWM[3]
				8             PWM[8]  PWM[2]
				9             PWM[9]  PWM[1] */
				for( IxB = 0; IxB < PWM[Ms-MicroStep]; IxB++)
					MsPWM[IxA+IxB].A += WindingB;
			/* increment to start of next microstep voltage */
			IxA += MaxPWM;
		}
		/* goto next windings */
		WindingA *= 2;
		WindingB *= 2;
		if( WindingB > 8)
			WindingB = 1;
	}
	/* 'Z' motor bits occupy upper nibble */
	for( IxA = 0; IxA <= MaxMsIx; IxA++)
		MsPWM[IxA].Z = MsPWM[IxA].A << 4;

	if( InvertOutput)
		for( IxA = 0; IxA <= MaxMsIx; IxA++)
		{
			MsPWM[IxA].A = MotorOff.A - MsPWM[IxA].A;
			MsPWM[IxA].Z = MotorOff.Z - MsPWM[IxA].Z;
		}

	/* for testing purposes: to display PWM values
	Output = fopen( "pwm.txt", "w");
	if( Output == NULL)
		BadExit( "Could not open pwm.txt");
	for( IxA = 0; IxA <= MaxMsIx; IxA++)
	{
		if( !(IxA % MaxPWM))
			fprintf( Output, "\n%4d: ", IxA);
		fprintf( Output, "%4d", MotorOff.A - MsPWM[IxA].A);
	}
	fclose( Output);
	_exit( 0);
	end test of display PWM values */
}

void FreeMsArrays( void)
{
	free( MsPWM);
}

void CloseSteppers( void)
{
	FreeHsArrays();
	FreeMsArrays();
}

/* change MsTick.A and MsTick.Z based on MsArcsecSec */
void InitMsTickVars( const int MsArcsecSec)
{
	MsTick.A = MsArcsecSec / (MicroStepSizeArcsec.A * ClockTicksSec);
	MsTick.Z = MsArcsecSec / (MicroStepSizeArcsec.Z * ClockTicksSec);
}

void SteppersOff( void)
{
	outportb( MotorPort, MotorOff.A + MotorOff.Z);
}

/* holds motors position by energizing windings for HoldReps reps of
slowest motor speed: use to align motors and brake motors */
void Hold( void)
{
	struct AZByte Out;
	int RepCount, HsDelayXCount, DelayCount;

	if( HoldMotor.A)
		Out.A = HsOut[HsIx.A].A;
	else
		Out.A = MotorOff.A;
	if( HoldMotor.Z)
		Out.Z = HsOut[HsIx.Z].Z;
	else
		Out.Z = MotorOff.Z; 
	outportb( MotorPort, Out.A + Out.Z);
	for( RepCount = 0; RepCount < HoldReps; RepCount++)
		for( HsDelayXCount = 0; HsDelayXCount < HsDelayX; HsDelayXCount++)
			for( DelayCount = 0; DelayCount < HsRepsIx + MinDelay; DelayCount++)
				;
}

/* pauses until next clock tick */
void PauseUntilNewSidTime( void)
{
	NewSidT();
	while( !NewSidT())
		;
}

void DoOneHs( void)
{
	struct AZByte Out;

	if( Steps.A)
	{
		if( Dir.A == CW)
		{
			if( ++HsIx.A > MaxHsIx)
				HsIx.A = 0;
			AccumMs.A += MsPerHs;
		}
		else
		{
			if( --HsIx.A < 0)
				HsIx.A = MaxHsIx;
			AccumMs.A -= MsPerHs;
		}
		Steps.A--;
		Out.A = HsOut[HsIx.A].A;
	}
	else
		Out.A = MotorOff.A;
	MsIx.A = HsIx.A * HsIxToMsIxConvFactor;

	if( Steps.Z)
	{
		if( Dir.Z == CW)
		{
			if( ++HsIx.Z > MaxHsIx)
				HsIx.Z = 0;
			AccumMs.Z += MsPerHs;
		}
		else
		{
			if( --HsIx.Z < 0)
				HsIx.Z = MaxHsIx;
			AccumMs.Z -= MsPerHs;
		}
		Steps.Z--;
		Out.Z = HsOut[HsIx.Z].Z;
	}
	else
		Out.Z = MotorOff.Z;
	MsIx.Z = HsIx.Z * HsIxToMsIxConvFactor;

	outportb( MotorPort, Out.A + Out.Z);
}

void DoHsDelayLoop( void)
{
	int HsDelayXCount, DelayCount;

	/* repetitions of delay counts */
	for( HsDelayXCount = 0; HsDelayXCount < HsDelayX; HsDelayXCount++)
		for( DelayCount = 0; DelayCount < HsRepsIx + MinDelay; DelayCount++)
			;
}

void SetTickDelay( void)
{
	if( AbortState)
	{
		SlewState = RampDown;
		if( !HsRepsIx)
			/* immediate ramp down from max slew speed */
			SameSpeedHs = HsReps[HsRepsIx];
	}
	switch( SlewState)
	{
		case RampUp:
			if( --RampHs == 0)
				SlewState = RampDown;
			if( --SameSpeedHs == 0)
				SameSpeedHs = HsReps[--HsRepsIx];
			if( HsRepsIx == 0)
				SlewState = MaxSlewUp;
			RampUpSteps++;
			break;
		case MaxSlewUp:
			if( --RampHs)
				 --SameSpeedHs;
			else if( HsRepsIx == 0)
				SlewState = MaxSlewDown;
			else
				SlewState = RampDown;
			MaxSlewUpSteps++;
			break;
		case MaxSlewDown:
			if( SameSpeedHs++ == HsReps[0])
			{
				HsRepsIx = 1;
				SameSpeedHs = 0;
				SlewState = RampDown;
			}
			MaxSlewDownSteps++;
			break;
		case RampDown:
			if( SameSpeedHs++ == HsReps[HsRepsIx])
				if( ++HsRepsIx > MaxHsRepsIx)
				{
					SlewState = SlewDone;
					break;
				}
				else
					SameSpeedHs = 1;
			RampDownSteps++;
	}
	Timer = HsRepsIx + MinDelay;
	if( Timer == 0)
		Timer = 1;
	/* set 8259 chip, Timer 0, read low, then high, software triggered strobe */
	outportb( Timer_Control, 0x38);
	/* low byte */
	outportb( Timer_0, 0xFF & Timer);
	/* high byte */
	outportb( Timer_0, 0xFF & (Timer >> 8));
}

void interrupt SlewTickHandler( void)
{
	if( SlewState != SlewDone)
	{
		DoOneHs();
		SetTickDelay();
	}
	/* enable PIC EOI (end of interrupt) */
	outportb( PIC_EOI_ADDR, EOI);
}

void RoundUpHs( void)
{
	/* steps can never be < 0 */
	if( Steps.A < 0)
		Steps.A = 0;
	if( Steps.Z < 0)
		Steps.Z = 0;
	/* end on next fullstep */
	if( Steps.A%2)
		Steps.A++;
	if( Steps.Z%2)
		Steps.Z++;
}

/*
MoveHs() is called by:
	HPEventMoveHs() which is called by:
		KBEventMoveHs() which is called by:
			SetDirDistanceStepsThenMove() which is called by:
				MoveToCurrentRaDec() which is called by:
					ProcessHPEvents() (no buttons pushed)
					ProcessHPEvents() (direction button pushed + Guide)
					ProcessHPEvents() (no direction button pushed + InitAutoOn)
					ProcessHPEvents() (no direction button pushed + Init1On)
					ProcessHPEvents() (no direction button pushed + Init2On)
					ProcessHPEvents() (no direction button pushed + Init3On)
					ProcessHPEvents() (no direction button pushed + Guide...On)
					ProcessHPEvents() (no direction button pushed + GrandTour)
					ProcessHPEvents() (no direction button pushed + ScrollTour)
					ProcessHPEvents() (no direction button pushed + RecordOn)
					ProcessHPEvents() (no direction button pushed)
					Move_Update_Handpad_Subr() which is called by:
						ProcessScroll()
				ProcessMenuSelection() (MenuMoveAltaz)
				ProcessMenuSelection() (MenuMoveHome)
			ProcessHPEvents()

ProcessHPEvents() is called by:
	ProcessMenuSelection()
	ProcessKBEvents()
	main()																																																							  <- MoveHsUsingIRQTimer()
*/

/* keeps control until motors come to a stop after ramping down;
moves to nearest full step */
void MoveHs( void)
{
	InitHandPad = HandPad;
	HandPadOKFlag = Yes;
	AbortState = No;
	/* for delay loop timing of halfsteps, all interrupts disabled and no encoder
	query or read functions are called; for interrupt timer timing of halfsteps,
	function DoAProcessTimedToBiosClockTick() is called, but in this function
	encoder query and read are ignored during slew */
	CloseSerial( EncoderComPort);
	while( !AbortState && (Steps.A || Steps.Z))
	{
		RoundUpHs();
		/* hold motor(s) position for brief time to align */
		if( Steps.A)
			HoldMotor.A = On;
		else
			HoldMotor.A = Off;
		if( Steps.Z)
			HoldMotor.Z = On;
		else
			HoldMotor.Z = Off;
		Hold();

		/* do smaller # of steps 1st, unless a motor has 0 steps to do:
		flags set for Hold() depend on this mvmt algorithm */
		if( Steps.A == 0)
			MvmtHs = Steps.Z;
		else if( Steps.Z == 0)
			MvmtHs = Steps.A;
		else if( Steps.A < Steps.Z)
			MvmtHs = Steps.A;
		else
			MvmtHs = Steps.Z;

		RampHs = MvmtHs/2;
		if( RampHs < 0)
			BadExit( "Bad RampHs in MoveHs()");

		if( HsTimerFlag)
			MoveHsUsingIRQTimer();
		else
			{
				MoveHsUsingDelayLoop();
				if( !HandPadOKFlag)
					AbortState = HandPadAbort;
			}
		/* hold motor(s) position for brief time to brake */
		Hold();
		HoldMotor.A = HoldMotor.Z = Off;
		RoundUpHs();
	}
	SteppersOff();
	SetDOSToCMOS();
	InitSerial( EncoderComPort, BaudRate, Parity, DataBits, StopBits);
	PauseUntilNewSidTime();
}

/* this function installs a new clock interrupt handler, SlewTickHandler(),
then stays in a loop that handles limits and calls
DoAProcessTimedToBiosClockTick() and checks for SlewDone, when SlewDone,
restores the original clock interrupt handler;
each time SlewTickHandler() is called via the clock interrupt, it does a single
halfstep, then calls SetTickDelay();
SetTickDelay(() sets the delay interval for calling the clock interrupt handler
again, and also sets the SlewState (when finished sets it to SlewDone) */

void MoveHsUsingIRQTimer( void)
{
	/* initialize for SetTickDelay() */
	HsRepsIx = MaxHsRepsIx;
	SameSpeedHs = HsReps[HsRepsIx];
	SlewState = RampUp;
	RampUpSteps = MaxSlewUpSteps = MaxSlewDownSteps = RampDownSteps = 0;
	/* set new interrupt handler */
	disable();
	ClockVect = getvect( Timer_Int);
	setvect( Timer_Int, SlewTickHandler);
	/* enable() occurs after the while loop evaluation, to prevent the SlewState
	from being changed by the timer interrupt handler routine during the while
	loop evaluation, suggested by Egon Lenc */
	while( SlewState != SlewDone)
	{
		enable();
		SetHandPadOKFlag();
		if( !HandPadOKFlag)
		{
			disable();
			AbortState = HandPadAbort;
			enable();
		}
		if( KeyStroke)
		{
			disable();
			AbortState = KeyStrokeAbort;
			enable();
			getch();
		}
		if( AltLimitFlag)
		{
			if( Current.Alt < AltLowLimit && Dir.A == CCW)
			{
				disable();
				AbortState = AltLowLimitAbort;
				enable();
			}
			else if( Current.Alt > AltHighLimit && Dir.A == CW)
			{
				disable();
				AbortState = AltHighLimitAbort;
				enable();
			}
		}
		if( AzLimitFlag)
		{
			if( Current.Az < AzLowLimit && Dir.Z == CCW)
			{
				disable();
				AbortState = AzLowLimitAbort;
				enable();
			}
			else if( Current.Az > AzHighLimit && Dir.Z == CW)
			{
				disable();
				AbortState = AzHighLimitAbort;
				enable();
			}
		}

		DoAProcessTimedToBiosClockTick();

		/* this disable() stays in effect through the while loop evaluation */
		disable();
		if( SlewState == SlewDone)
		{
			/* read low, then high, square wave gen. */
			outportb( Timer_Control, 0x36);
			outportb( Timer_0, 0);
			outportb( Timer_0, 0);
			/* restore interrupt vector */
			setvect( Timer_Int, ClockVect);
		}
	}
	enable();
}

void MoveHsUsingDelayLoop( void)
{
	/* set for max delay giving slowest speed (index is decremented
	in while loop before being used for 1st time) */
	HsRepsIx = MaxHsRepsIx + 1;
	/* if steps to move exceed InterruptHs, then disable interrupts for
	smoothest timing pulses to allow faster speeds */
	if( RampHs > InterruptHs)
	{
		InterruptFlag = Yes;
		disable();
	}
	/* ramp up */
	while( HandPadOKFlag && RampHs)
	{
		SameSpeedHs = HsReps[--HsRepsIx];
		while( HandPadOKFlag && RampHs && SameSpeedHs)
		{
			DoOneHs();
			DoHsDelayLoop();
			SetHandPadOKFlag();
			RampHs--;
			SameSpeedHs--;
		}
	}
	/* ramp down */
	while( HsRepsIx <= MaxHsRepsIx)
	{
		while( SameSpeedHs < HsReps[HsRepsIx])
		{
			/* if move cancelled while moving at max speed, then immediate
			ramp down */
			if( !HandPadOKFlag && HsRepsIx == 0)
				SameSpeedHs = HsReps[HsRepsIx] - 1; 
			DoOneHs();
			DoHsDelayLoop(); 
			SetHandPadOKFlag();
			RampHs--;
			SameSpeedHs++;
		}
		SameSpeedHs = 0;
		HsRepsIx++;
	}
	if( InterruptFlag)
		enable();
}

/* speed of microstepping set by IncrMs, if IncrMs left at zero, function
sets IncrMs to spread Steps over 1 bios clock tick */
void MoveMs( void)
{
	int IxA, IxB, IxC;
	struct AZInt MsToDo;
	struct AZDouble MsRunningTotal;

	MsAlignFlag = No;
	ActualPWMRepsTick = 0;
	MsRunningTotal.A = MsRunningTotal.Z = 0;

	/* speed of microstepping set by IncrMs (# of microsteps per PWM):
	when < 1, multiple PWMs occur for a microstep, when > 1 (max = 5),
	microsteps are skipped over */
	if( IncrMs.A == 0 && IncrMs.Z == 0)
	{
		IncrMs.A = (double) Steps.A / (double) PWMRepsTick;
		IncrMs.Z = (double) Steps.Z / (double) PWMRepsTick;

		/* allow skipping of microsteps up to but not exceeding halfstepping */
		if( IncrMs.A > MsPerHs)
			IncrMs.A = MsPerHs;
		if( IncrMs.Z > MsPerHs)
			IncrMs.Z = MsPerHs;
	}

	do
	{
		if( Steps.A)
		{
			/* MsRunningTotal is a double */
			MsRunningTotal.A += IncrMs.A;
			/* MsToDo is an int */
			MsToDo.A = MsRunningTotal.A;
			/* fractional part remains in MsRunningTotal */
			MsRunningTotal.A -= MsToDo.A;
			Steps.A -= MsToDo.A;
			if( Dir.A == CW)
			{
				MsIx.A += MaxPWM*MsToDo.A;
				if( MsIx.A > MaxMsIx)
					MsIx.A -= MaxMsIx + 1;
				AccumMs.A += MsToDo.A;
			}
			else
			{
				MsIx.A -= MaxPWM*MsToDo.A;
				if( MsIx.A < 0)
					MsIx.A += MaxMsIx + 1;
				AccumMs.A -= MsToDo.A;
			}
		}
		if( Steps.Z)
		{
			MsRunningTotal.Z += IncrMs.Z;
			MsToDo.Z = MsRunningTotal.Z;
			MsRunningTotal.Z -= MsToDo.Z;
			Steps.Z -= MsToDo.Z;
			if( Dir.Z == CW)
			{
				MsIx.Z += MaxPWM*MsToDo.Z;
				if( MsIx.Z > MaxMsIx)
					MsIx.Z -= MaxMsIx + 1;
				AccumMs.Z += MsToDo.Z;
			}
			else
			{
				MsIx.Z -= MaxPWM*MsToDo.Z;
				if( MsIx.Z < 0)
					MsIx.Z += MaxMsIx + 1;
				AccumMs.Z -= MsToDo.Z;
			}
		}

		/* microstep by sending a PWM[] that generates voltages to motors */
		for( IxA = 0; IxA < MaxPWM; IxA++)
			/* repeat outportb() MsDelayX times */
			for( IxB = 0; IxB < MsDelayX; IxB++)
				/* always do both motors in case a motor needs to be held in
				place between windings */
				outportb( MotorPort, MsPWM[MsIx.A+IxA].A + MsPWM[MsIx.Z+IxA].Z);

		SteppersOff();
		/* pause for MsPause counts */
		for( IxC = 0; IxC < MsPause; IxC++)
			SteppersOff();
		/* one microstepping voltage waveform finished */
		ActualPWMRepsTick++;
	} while( !NewSidT());

	/* set halfstep indexes */
	HsIx.A = MsIx.A / HsIxToMsIxConvFactor;
	HsIx.Z = MsIx.Z / HsIxToMsIxConvFactor;

	IncrMs.A = IncrMs.Z = 0;
}

/* moves steppers to nearest full step */
void AlignMs( void)
{
	if( MsAlignFlag)
		PauseUntilNewSidTime();
	else
	{
		/* find microsteps to nearest fullstep */
		Steps.A = (MsIx.A/MaxPWM) % Ms;
		if( Steps.A && Dir.A == CW)
			Steps.A = Ms - Steps.A;
		Steps.Z = (MsIx.Z/MaxPWM) % Ms;
		if( Steps.Z && Dir.Z == CW)
			Steps.Z = Ms - Steps.Z;
		MoveMs();
		MsAlignFlag = Yes;
	}
}

/* convert... */

void InitConvert( void)
{
	SaveInitFlag = Yes;

	/* clear out InitFile */
	Output = fopen( InitFile, "w");
	if( Output == NULL)
		BadExit( strcat( "Could not create ", InitFile));
	fclose( Output);

	SetMountErrorsDeg( Z1Deg, Z2Deg, Z3Deg);
	One.Init = Two.Init = Three.Init = No;
   AltOffset = MAXDOUBLE;

	if( DisplayOpeningMsgs)
	{
		printf( "\n\nUsing LatitudeDeg, LongitudeDeg, Tz, and DST values from %s",
		CfgFile);
		printf( "\n   would you like to:");
		printf( "\n      1. adopt an equatorial alignment");
		printf( "\n      2. adopt an altazimuth alignment (set 0 azimuth to the pole)");
		printf( "\n      3. adopt no alignment and start from scratch");
		Input = fopen( AlignFile, "r");
		if( Input != NULL)
			printf( "\n      4. use previous alignment data");
		fclose( Input);
		printf( "\n   what is your choice? ");
		Response = getch();
		printf( "%c\n", Response);
		switch( Response)
		{
			case '1':
				InitConvertEquat();
				break;
			case '2':
				InitConvertAltaz();
				break;
			case '3':
				break;
			case '4':
				if( LoadAlign())
					ConvertAlignFile();
		}
	}
	else
		if( LoadAlign())
			ConvertAlignFile();
}

void InitConvertEquat( void)
{
	struct Position Temp;

	RefractFlag = No;
	Z1Deg = Z2Deg = Z3Deg = 0;
	SetMountErrorsDeg( Z1Deg, Z2Deg, Z3Deg);

	/* point south on celestian equator on meridian */
	/* Az of zero == meridian to the south; on meridian, Ra == SidT */
	One.Ra = Current.SidT;
	One.Dec = 0;
	One.Alt = 0;
	One.Az = 0;
	One.SidT = Current.SidT;

	/* point west on celestian equator */
	Two.Ra = Current.SidT - QtrRev;
	ValidRa( &Two);
	Two.Dec = 45./RadToDeg;
	Two.Alt = 45./RadToDeg;
	Two.Az = 90./RadToDeg;
	Two.SidT = Current.SidT;

	/* point east on celestian equator */
	Three.Ra = Current.SidT + QtrRev;
	ValidRa( &Three);
	Three.Dec = 0;
	Three.Alt = 0;
	Three.Az = 270./RadToDeg;
	Three.SidT = Current.SidT;

	One.Init = Two.Init = Three.Init = No;
	Temp = Current;
	Current = One;
	InitMatrix( 1);
	Current = Two;
	InitMatrix( 2);
	Current = Three;
	InitMatrix( 3);
	Current = Temp;
}

/* flip a german equatorial mount across the meridian:
the Ra tracking movement will continue to move in the same direction but the
Dec movement will be reversed;
if Ra, Dec are to be kept the same then invert the Altitude, then flip Azimuth
by 180 and then flip Altitude across the pole */

void InitConvertEquatMeridianFlip( void)
{
	struct Position Temp;

	One.Ra = Current.SidT;
	One.Dec = 0;
	One.Alt = 0;
	One.Az = 0;
	One.SidT = Current.SidT;

	Two.Ra = Current.SidT - QtrRev;
	ValidRa( &Two);
	Two.Dec = 45./RadToDeg;
	Two.Alt = -45./RadToDeg;
	Two.Az = 90./RadToDeg;
	Two.SidT = Current.SidT;

	Three.Ra = Current.SidT + QtrRev;
	ValidRa( &Three);
	Three.Dec = 0;
	Three.Alt = 0;
	Three.Az = 270./RadToDeg;
	Three.SidT = Current.SidT;

	One.Init = Two.Init = Three.Init = No;
	Temp = Current;
	Current = One;
	InitMatrix( 1);
	Current = Two;
	InitMatrix( 2);
	Current = Three;
	InitMatrix( 3);
	Current = Temp;
}

void InitConvertAltaz( void)
{
	struct Position Temp;

	/* point to pole */
	One.Ra = 0;
	One.Dec = QtrRev;
	One.Alt = LatitudeDeg/RadToDeg;
	One.Az = 0;
	One.SidT = Current.SidT;

	/* point on celestian equator on meridian */
	Two.Ra = Current.SidT;
	ValidRa( &Two);
	Two.Dec = 0;
	Two.Alt = (90.-LatitudeDeg)/RadToDeg;
	Two.Az = HalfRev;
	Two.SidT = Current.SidT;

	One.Init = Two.Init = Three.Init = No;
	Temp = Current;
	Current = One;
	InitMatrix( 1);
	Current = Two;
	InitMatrix( 2);
	Current = Temp;
}

void ConvertAlignFile( void)
{
	double Var[15];
	int IxA, IxB, IxC;
	int InitsRead = 0;

	Input = fopen( AlignFile, "r");
	if( Input != NULL)
	{
		strcpy( Name, NameBlanks);
		fscanf( Input, "%s", Name);
		if( (strncmpi( Name, "One.Ra", sizeof( Name))) == 0)
		{
			if( DisplayOpeningMsgs)
				printf( "\nConverting %s format...", AlignFile);
			ReadDouble( Input, &Var[0]);
			while( !feof( Input))
			{
				if( (strncmpi( Name, "One.Dec", sizeof( Name))) == 0)
					ReadDouble( Input, &Var[1]);
				else if( (strncmpi( Name, "One.Alt", sizeof( Name))) == 0)
					ReadDouble( Input, &Var[2]);
				else if( (strncmpi( Name, "One.Az", sizeof( Name))) == 0)
					ReadDouble( Input, &Var[3]);
				else if( (strncmpi( Name, "One.SidT", sizeof( Name))) == 0)
				{
					ReadDouble( Input, &Var[4]);
					InitsRead = 1;
				}
				else if( (strncmpi( Name, "Two.Ra", sizeof( Name))) == 0)
					ReadDouble( Input, &Var[5]);
				else if( (strncmpi( Name, "Two.Dec", sizeof( Name))) == 0)
					ReadDouble( Input, &Var[6]);
				else if( (strncmpi( Name, "Two.Alt", sizeof( Name))) == 0)
					ReadDouble( Input, &Var[7]);
				else if( (strncmpi( Name, "Two.Az", sizeof( Name))) == 0)
					ReadDouble( Input, &Var[8]);
				else if( (strncmpi( Name, "Two.SidT", sizeof( Name))) == 0)
				{
					ReadDouble( Input, &Var[9]);
					InitsRead = 2;
				}
				else if( (strncmpi( Name, "Three.Ra", sizeof( Name))) == 0)
					ReadDouble( Input, &Var[10]);
				else if( (strncmpi( Name, "Three.Dec", sizeof( Name))) == 0)
					ReadDouble( Input, &Var[11]);
				else if( (strncmpi( Name, "Three.Alt", sizeof( Name))) == 0)
					ReadDouble( Input, &Var[12]);
				else if( (strncmpi( Name, "Three.Az", sizeof( Name))) == 0)
					ReadDouble( Input, &Var[13]);
				else if( (strncmpi( Name, "Three.SidT", sizeof( Name))) == 0)
				{
					ReadDouble( Input, &Var[14]);
					InitsRead = 3;
				}
				fscanf( Input, "%s", Name);
			}
			fclose( Input);

			Output = fopen( AlignFile, "w");
			if( Output == NULL)
				BadExit( strcat( "Could not open ", AlignFile));
			IxC = 0;
			for( IxA = 0; IxA < InitsRead; IxA++)
			{
				for( IxB = 0; IxB < 5; IxB++)
					fprintf( Output, "%f ", Var[IxC++]);
				fprintf( Output, "\n");
			}
			fclose( Output);
		}
	}
}

void SaveAlign( void)
{
	Output = fopen( AlignFile, "w");
	if( Output == NULL)
		BadExit( strcat( "Could not open ", AlignFile));

	/* re-write the entire AlignFile contents */
	if( One.Init)
	{
		fprintf( Output, "%f ", One.Ra * RadToDeg);
		fprintf( Output, "%f ", One.Dec * RadToDeg);
		fprintf( Output, "%f ", One.Alt * RadToDeg);
		fprintf( Output, "%f ", One.Az * RadToDeg);
		fprintf( Output, "%f\n", One.SidT * RadToDeg);
	}
	if( Two.Init)
	{
		fprintf( Output, "%f ", Two.Ra * RadToDeg);
		fprintf( Output, "%f ", Two.Dec * RadToDeg);
		fprintf( Output, "%f ", Two.Alt * RadToDeg);
		fprintf( Output, "%f ", Two.Az * RadToDeg);
		fprintf( Output, "%f\n", Two.SidT * RadToDeg);
	}
	if( Three.Init)
	{
		fprintf( Output, "%f ", Three.Ra * RadToDeg);
		fprintf( Output, "%f ", Three.Dec * RadToDeg);
		fprintf( Output, "%f ", Three.Alt * RadToDeg);
		fprintf( Output, "%f ", Three.Az * RadToDeg);
		fprintf( Output, "%f\n", Three.SidT * RadToDeg);
	}
	fclose( Output);

	if( SaveInitFlag)
		/* append current alignment/initialization to the InitFile */
		SaveInit();
}

Flag LoadAlign( void)
{
	int OneLoaded = No;
	int TwoLoaded = No;
	int ThreeLoaded = No;
	/* temporary coordinates */
	struct Position Temp;

	Input = fopen( AlignFile, "r");
	if( Input == NULL)
	{
		if( DisplayOpeningMsgs)
			printf( "\nDid not find %s", AlignFile);
		return False;
	}
	else
	{
		ReadDouble( Input, &One.Ra);
		One.Ra /= RadToDeg;
		ReadDouble( Input, &One.Dec);
		One.Dec /= RadToDeg;
		ReadDouble( Input, &One.Alt);
		One.Alt /= RadToDeg;
		ReadDouble( Input, &One.Az);
		One.Az /= RadToDeg;
		ReadDouble( Input, &One.SidT);
		One.SidT /= RadToDeg;
		if( !feof( Input))
			OneLoaded = Yes;

		ReadDouble( Input, &Two.Ra);
		Two.Ra /= RadToDeg;
		ReadDouble( Input, &Two.Dec);
		Two.Dec /= RadToDeg;
		ReadDouble( Input, &Two.Alt);
		Two.Alt /= RadToDeg;
		ReadDouble( Input, &Two.Az);
		Two.Az /= RadToDeg;
		ReadDouble( Input, &Two.SidT);
		Two.SidT /= RadToDeg;
		if( !feof( Input))
			TwoLoaded = Yes;

		ReadDouble( Input, &Three.Ra);
		Three.Ra /= RadToDeg;
		ReadDouble( Input, &Three.Dec);
		Three.Dec /= RadToDeg;
		ReadDouble( Input, &Three.Alt);
		Three.Alt /= RadToDeg;
		ReadDouble( Input, &Three.Az);
		Three.Az /= RadToDeg;
		ReadDouble( Input, &Three.SidT);
		Three.SidT /= RadToDeg;
		if( !feof( Input))
			ThreeLoaded = Yes;

		/* don't re-save inits in AlignFile that are already in InitFile */
		SaveInitFlag = No;
		/* local Temp */
		Temp = Current;
		if( OneLoaded)
		{
			Current = One;
			InitMatrix( 1);
			if( TwoLoaded)
			{
				Current = Two;
				InitMatrix( 2);
				if( ThreeLoaded)
				{
					Current = Three;
					InitMatrix( 3);
				}
			}
		}
		Current = Temp;
		SaveInitFlag = Yes;
		fclose( Input);
		return True;
	}
}

void SaveInit( void)
{
	Output = fopen( InitFile, "a");
	if( Output == NULL)
		BadExit( strcat( "Could not open for append ", InitFile));

	fprintf( Output, "%f %f %f %f %f\n", Current.Ra*RadToDeg,
	Current.Dec*RadToDeg, Current.Alt*RadToDeg, Current.Az*RadToDeg,
	Current.SidT*RadToDeg);

	fclose( Output);
}

void SetMountErrorsDeg( const double Z1Deg, const double Z2Deg,
const double Z3Deg)
{
	Z1 = Z1Deg/RadToDeg;
	Z2 = Z2Deg/RadToDeg;
	Z3 = Z3Deg/RadToDeg;
	if( Z1 != 0 || Z2 != 0)
		Z1Z2NonZeroFlag = Yes;
	else
		Z1Z2NonZeroFlag = No;
}

void ZeroArrays( void)
{
	int I, J; 

	for( I = 0; I < 4; I++)
		for( J = 0; J < 4; J++)
			QQ[I][J] = VV[I][J] = RR[I][J] = XX[I][J] = YY[I][J] = 0;
}

void ArrayAsignInit( const int Init)
{
	double D, B;

	if( Init == 1)
		ZeroArrays();
	D = Current.Dec;
	/* B is CCW so HA formula backwards */
	B = Current.Ra - Current.SidT;
	XX[1][Init] = cos( D) * cos( B);
	XX[2][Init] = cos( D) * sin( B);
	XX[3][Init] = sin( D);
	/* F is CCW */
	F = OneRev - Current.Az;
	H = Current.Alt + Z3;
	SubrA();
	YY[1][Init] = YY[1][0];
	YY[2][Init] = YY[2][0];
	YY[3][Init] = YY[3][0];
}

void GenerateThirdInit( void)
{
	int I;
	double A;

	/* generate 3rd initialization point from the first two */
	XX[1][3] = XX[2][1]*XX[3][2] - XX[3][1]*XX[2][2];
	XX[2][3] = XX[3][1]*XX[1][2] - XX[1][1]*XX[3][2];
	XX[3][3] = XX[1][1]*XX[2][2] - XX[2][1]*XX[1][2];
	A = sqrt( XX[1][3]*XX[1][3] + XX[2][3]*XX[2][3] + XX[3][3]*XX[3][3]);
	for( I = 1; I <= 3; I++)
	{
		if( A == 0)
			XX[I][3] = MAXDOUBLE;
		else
			XX[I][3] /= A;
	}
	YY[1][3] = YY[2][1]*YY[3][2] - YY[3][1]*YY[2][2];
	YY[2][3] = YY[3][1]*YY[1][2] - YY[1][1]*YY[3][2];
	YY[3][3] = YY[1][1]*YY[2][2] - YY[2][1]*YY[1][2];
	A = sqrt( YY[1][3]*YY[1][3] + YY[2][3]*YY[2][3] + YY[3][3]*YY[3][3]);
	for( I = 1; I <= 3; I++)
	{
		if( A == 0)
			YY[I][3] = MAXDOUBLE;
		else
			YY[I][3] /= A;
	}
}

void TransformMatrix( void)
{
	int I, J, L, M, N;
	double E;

	for( I = 1; I <= 3; I++)
		for( J = 1; J <= 3; J++)
			VV[I][J] = XX[I][J];
	DeterminateSubr();
	E = W;
	for( M = 1; M <= 3; M++)
	{
		for( I = 1; I <= 3; I++)
			for( J = 1; J <= 3; J++)
				VV[I][J] = XX[I][J];
		for( N = 1; N <= 3; N++)
		{
			VV[1][M] = 0;
			VV[2][M] = 0;
			VV[3][M] = 0;
			VV[N][M] = 1;
			DeterminateSubr();
			if( E == 0)
				QQ[M][N] = MAXDOUBLE;
			else
				QQ[M][N] = W/E;
		}
	}
	for( I = 1; I <= 3; I++)
		for( J = 1; J <= 3; J++)
			RR[I][J] = 0;
	for( I = 1; I <= 3; I++)
		for( J = 1; J <= 3; J++)
			for( L = 1; L <= 3; L++)
				RR[I][J] += (YY[I][L] * QQ[L][J]);
	for( M = 1; M <= 3; M++)
	{
		for( I = 1; I <= 3; I++)
			for( J = 1; J <= 3; J++)
				VV[I][J] = RR[I][J];
		DeterminateSubr();
		E = W;
		for( N = 1; N <= 3; N++)
		{
			VV[1][M] = 0;
			VV[2][M] = 0;
			VV[3][M] = 0;
			VV[N][M] = 1;
			DeterminateSubr();
			if( E == 0)
				QQ[M][N] = MAXDOUBLE;
			else
				QQ[M][N] = W/E;
		}
	}
}

void InitMatrix( const int Init)
{
	struct Position Temp;

	if( Init == 3 && One.Init && Two.Init)
	{
		Temp = Current;
		Current = One;
		ArrayAsignInit( 1);
		Current = Two;
		ArrayAsignInit( 2);
		Current = Temp;
		ArrayAsignInit( 3);
		TransformMatrix();
		CalcPostInitVars();
		Three = Current;
		Three.Init = Yes;
		SaveAlign();
	}
	else if( Init == 2 && One.Init && Two.Init && Three.Init)
	{
		Temp = Current;
		Current = One;
		ArrayAsignInit( 1);
		Current = Temp;
		ArrayAsignInit( 2);
		Temp = Current;
		Current = Three;
		ArrayAsignInit( 3);
		Current = Temp;
		TransformMatrix();
		CalcPostInitVars();
		Two = Current;
		Two.Init = Yes;
		SaveAlign();
	}
	else if( Init == 2 && One.Init && !Three.Init)
	{
		Temp = Current;
		Current = One;
		ArrayAsignInit( 1);
		Current = Temp;
		ArrayAsignInit( 2);
		GenerateThirdInit();
		TransformMatrix();
		CalcPostInitVars();
		Two = Current;
		Two.Init = Yes;
		SaveAlign();
	}
	else if( Init == 1 && One.Init && Two.Init && Three.Init)
	{
		ArrayAsignInit( 1);
		Temp = Current;
		Current = Two;
		ArrayAsignInit( 2);
		Current = Three;
		ArrayAsignInit( 3);
		Current = Temp;
		TransformMatrix();
		CalcPostInitVars();
		One = Current;
		One.Init = Yes;
		SaveAlign();
	}
	else if( Init == 1 && Two.Init && !Three.Init)
	{
		ArrayAsignInit( 1);
		Temp = Current;
		Current = Two;
		ArrayAsignInit( 2);
		Current = Temp;
		GenerateThirdInit();
		TransformMatrix();
		CalcPostInitVars();
		One = Current;
		One.Init = Yes;
		SaveAlign();
	}
	else if( Init == 1 && !Two.Init)
	{
		ArrayAsignInit( 1);
		One = Current;
		One.Init = Yes;
		SaveAlign();
	}
	else
	{
		sprintf( StrBuf,
		"InitMatrix() failure: Init=%d, One.Init=%d, Two.Init=%d, Three.Init=%d",
		Init, One.Init, Two.Init, Three.Init);
		BadExit( StrBuf);
	}

	/* get altitude offset after ...Init = Yes assigned */
	CalcBestAltOffset();
}

void SubrA( void)
{
	double CosF, CosH, SinF, SinH;

	CosF = cos( F); 
	CosH = cos( H); 
	SinF = sin( F); 
	SinH = sin( H); 
	if( Z1Z2NonZeroFlag)
	{
		YY[1][0] = CosF*CosH - SinF*Z2 + SinF*CosH*Z1;
		YY[2][0] = SinF*CosH + CosF*Z2 - CosF*SinH*Z1;
	}
	else
	{
		YY[1][0] = CosF*CosH;
		YY[2][0] = SinF*CosH;
	}
	YY[3][0] = SinH;
}

void SubrB( void)
{
	double CosF, CosH, SinF, SinH;

	CosF = cos( F); 
	CosH = cos( H); 
	SinF = sin( F); 
	SinH = sin( H); 
	if( Z1Z2NonZeroFlag)
	{
		YY[1][1] = CosF*CosH + SinF*Z2 - SinF*CosH*Z1; 
		YY[2][1] = SinF*CosH - CosF*Z2 + CosF*SinH*Z1;
	}
	else
	{
		YY[1][1] = CosF*CosH;
		YY[2][1] = SinF*CosH; 
	}
	YY[3][1] = SinH;
}

void DeterminateSubr( void)
{
	W = VV[1][1]*VV[2][2]*VV[3][3] + VV[1][2]*VV[2][3]*VV[3][1]
	  + VV[1][3]*VV[3][2]*VV[2][1] - VV[1][3]*VV[2][2]*VV[3][1]
	  - VV[1][1]*VV[3][2]*VV[2][3] - VV[1][2]*VV[2][1]*VV[3][3];
}

void AngleSubr( void)
{
	double C;

	C = sqrt( YY[1][1]*YY[1][1] + YY[2][1]*YY[2][1]);
	if( C == 0 && YY[3][1] > 0)
		H = QtrRev;
	if( C == 0 && YY[3][1] < 0)
		H = -QtrRev;
	if( C != 0)
		H = atan( YY[3][1]/C);
	if( C == 0)
		/* F should be indeterminate: program listing is F = 1000/RadToDeg; */
		F = 0;
	if( C != 0 && YY[1][1] == 0 && YY[2][1] > 0)
		F = QtrRev;
	if( C != 0 && YY[1][1] == 0 && YY[2][1] < 0)
		F = OneRev * (3/4);
	if( YY[1][1] > 0)
		F = atan( YY[2][1]/YY[1][1]);
	if( YY[1][1] < 0)
		F = atan( YY[2][1]/YY[1][1]) + HalfRev;
	while( F > OneRev)
		F -= OneRev;
	while( F < 0)
		F += OneRev;
}

/* call after init 2, calculates apparent scope latitude, longitude, offset
azimuth, and updates field rotation */
void CalcPostInitVars( void)
{
	/* temporary coordinates */
	struct Position Temp = Current;

	/* find Lat by setting for 90 deg declination( NCP) */
	Current.Dec = QtrRev;
	Current.Ra = 0;
	GetAltaz();
	Lat = Current.Alt;
	SinLat = sin( Lat);
	CosLat = cos( Lat);
	SinLatDividedByCosLat = SinLat/CosLat;

	/* set azimuth offset */
	if( Lat == QtrRev || Lat == -QtrRev)
	{
		AzOff = Current.Az - Current.Ra;
		while( AzOff >= OneRev)
			AzOff -= OneRev;
		while( AzOff < 0)
			AzOff += OneRev;
	}
	else
		AzOff = Current.Az;

	/* find longitude */
	Current.Alt = QtrRev;
	Current.Az = 0;
	GetEquat();
	/* LongitudeDeg/RadToDeg + Current.SidT = Greenwich Sidereal Time;
	difference between GST and Current.Ra (== zenith) will be scope longitude */
	LongitudeRad = LongitudeDeg/RadToDeg + Current.SidT - Current.Ra;
	while( LongitudeRad < 0)
		LongitudeRad += OneRev;
	while( LongitudeRad > OneRev)
		LongitudeRad -= OneRev;

	/* find hour angle offset = LST( Current.SidT) - scope's meridian,
	HA = LST - HAOff - Ra, or, HAOff = LST - Ra, by setting for zenith (HA = 0);
	 + offset = scope tilted to West, - offset = scope tilted to East;
	HAOff varies from - offset to + offset( should be a small amount) */
	HAOff = Current.SidT - Current.Ra;
	while( HAOff > M_PI)
		HAOff -= OneRev;
	while( HAOff < -M_PI)
		HAOff += OneRev;

	/* restore current coordinates */
	Current = Temp;

	/* update field rotation */
	CalcFieldR();
}

void GetAltaz( void)
{
	int I, J;
	double D, B;
	double CosD;

	D = Current.Dec;
	CosD = cos( D);
	/* B is CCW so HA formula backwards */
	B = Current.Ra - Current.SidT;
	XX[1][1] = CosD*cos( B);
	XX[2][1] = CosD*sin( B);
	XX[3][1] = sin( D);
	YY[1][1] = 0;
	YY[2][1] = 0;
	YY[3][1] = 0;
	for( I = 1; I <= 3; I++)
		for( J = 1; J <= 3; J++)
			YY[I][1] += (RR[I][J] * XX[J][1]);
	AngleSubr();
	SubrB();
	AngleSubr();
	H -= Z3; 
	Current.Alt = H; 
	/* convert back to CW */
	Current.Az = OneRev - F;
}

void GetEquat( void)
{
	int I, J;

	/* convert from CW to CCW az */
	F = OneRev - Current.Az; 
	H = Current.Alt + Z3;
	SubrA();
	XX[1][1] = YY[1][0];
	XX[2][1] = YY[2][0];
	XX[3][1] = YY[3][0];
	YY[1][1] = 0;
	YY[2][1] = 0;
	YY[3][1] = 0;
	for( I = 1; I <= 3; I++)
		for( J = 1; J <= 3; J++)
			YY[I][1] += (QQ[I][J] * XX[J][1]);
	AngleSubr(); 
	F += Current.SidT; 
	Current.Ra = F; 
	ValidRa( &Current);
	Current.Dec = H;
}

void CalcFieldR( void)
{
	double A;
	double SinHA; 

	Current.HA = Current.SidT - HAOff - Current.Ra; 
	SinHA = sin( Current.HA);

	A = SinLatDividedByCosLat * cos( Current.Dec) - sin( Current.Dec) *
	cos( Current.HA);

	if( A < 0)
		FieldR = atan( SinHA/A) + M_PI/2;
	else
		if( A == 0)
			if( SinHA < 0)
				FieldR = -M_PI/2;
			else if( SinHA == 0)
				FieldR = 0;
			else
				FieldR = M_PI/2;
		else
			FieldR = atan( SinHA/A);
	if( FieldR < 0)
		FieldR += OneRev;
}

/* this function currently not in use... */
void DisplayFieldR( void)
{
	printf( "%7.3f", FieldR*RadToDeg);
}

double CalcEquatAngularSep( struct Position A, struct Position Z)
{
	/* use hour angle, not Ra */
	return acos( sin( A.Dec) * sin( Z.Dec)
	+ cos( A.Dec) * cos( Z.Dec) * cos( (A.SidT - A.Ra) - (Z.SidT - Z.Ra)));
}

double CalcAltazAngularSep( struct Position A, struct Position Z)
{
	return acos( sin( A.Alt) * sin( Z.Alt)
	+ cos( A.Alt) * cos( Z.Alt) * cos( A.Az - Z.Az));
}

/* angular separation of two equatorial coordinates should = the angular
separation of the corresponding altazimuth coordinates; starting from a very
low altitude, keep adding altitude offset to both altitudes, saving the
best altitude offset when the angular separation matches; for target altitudes
that cross the equator of their coordinate system, there are two solutions */
Flag CalcAltOffset( double* AltOffset, struct Position A, struct Position Z)
{
	Flag AltOffFlag = No;
	double AltOff, BestAltOff;
	double sep1, sep2;
	double Diff, BestDiff = MAXDOUBLE;
	const double Incr = 1/RadToArcmin;
	/* make the offset range 15 degrees */
	const double AltStart = -QtrRev/6;
	const double AltFinish = -AltStart;

	for( AltOff = AltStart, A.Alt += AltStart, Z.Alt += AltStart;
	AltOff < AltFinish; AltOff += Incr, A.Alt += Incr, Z.Alt += Incr)
	{
		sep1 = CalcEquatAngularSep( A, Z);
		sep2 = CalcAltazAngularSep( A, Z);
		Diff = fabs( sep1 - sep2);

		if( Diff < BestDiff && Diff < Incr)
		{
			BestDiff = Diff;
			BestAltOff = AltOff;
			AltOffFlag = Yes;
		}
	}
	if( AltOffFlag)
		*AltOffset = BestAltOff;
	else
		*AltOffset = MAXDOUBLE;
	return AltOffFlag;
}

void CalcBestAltOffset( void)
{
	double ao, aototal = 0;
	int aodiv = 0;

	if( Three.Init)
	{
		if( CalcAltOffset( &ao, One, Two))
		{
			aodiv++;
			aototal += ao;
		}
		if( CalcAltOffset( &ao, One, Three))
		{
			aodiv++;
			aototal += ao;
		}
		if( CalcAltOffset( &ao, Two, Three))
		{
			aodiv++;
			aototal += ao;
		}
		if( aodiv)
			AltOffset = aototal / (double) aodiv;
		else
			AltOffset = MAXDOUBLE;
	}
	else
		if( Two.Init)
			CalcAltOffset( &AltOffset, One, Two);
		else
			AltOffset = MAXDOUBLE;
}

void TestConvert( void)
{
	printf( "\n\n\nTest of Convert code...\n");
	SaveInitFlag = No;
	One.Init = Two.Init = Three.Init = No;
	SetMountErrorsDeg( -.04, .4, -1.63);
	SetCoord( &Current, 79.172, 45.998, 39.9, 360-39.9, 39.2*SidRate/4);
	InitMatrix( 1);
	SetCoord( &Current, 37.96, 89.264, 36.2, 360-94.6, 40.3*SidRate/4);
	InitMatrix( 2);
	SetCoord( &Current, 326.05, 9.88, 0, 0, 47*SidRate/4);
	GetAltaz();
	ShowCoord( &Current);
	printf( "\nShould be Alt: 42.16   Az: %7.3f", 360-202.54);
	SetCoord( &Current, 71.53, 17.07, 0, 0, 62*SidRate/4);
	GetAltaz();
	ShowCoord( &Current);
	printf( "\nShould be Alt: 40.31   Az: %7.3f", 360-359.98);
	SetCoord( &Current, 0, 0, 35.5, 360-24.1, 71.9*SidRate/4);
	GetEquat();
	ShowCoord( &Current);
	printf( "\nShould be Ra: 87.99   Dec: 32.51\n");
	ContMsgRoutine();
	SaveInitFlag = Yes;
}

void TestAltOffset( void)
{
	double var;

	printf( "\n\n\nTest of altitude offset code...\n");
	One.Init = Two.Init = Yes;
	Three.Init = No;

	printf( "\nexample: 1: 72.1, 20.4333, 63.785, 210.287, 0");
	printf( "\n         2: 359.138, 2.5833, 4.164, 269.58, 0");
	printf( "\n         +- an equal amount from both altitudes...");
	printf( "\n\n1st (deg) Ra ");
	GetDouble( &var);
	One.Ra = var/RadToDeg;
	printf( "   Dec ");
	GetDouble( &var);
	One.Dec = var/RadToDeg;
	printf( "   Alt ");
	GetDouble( &var);
	One.Alt = var/RadToDeg;
	printf( "   Az ");
	GetDouble( &var);
	One.Az = var/RadToDeg;
	printf( "   SidT ");
	GetDouble( &var);
	One.SidT = var/RadToDeg;

	printf( "\n2nd (deg) Ra ");
	GetDouble( &var);
	Two.Ra = var/RadToDeg;
	printf( "   Dec ");
	GetDouble( &var);
	Two.Dec = var/RadToDeg;
	printf( "   Alt ");
	GetDouble( &var);
	Two.Alt = var/RadToDeg;
	printf( "   Az ");
	GetDouble( &var);
	Two.Az = var/RadToDeg;
	printf( "   SidT ");
	GetDouble( &var);
	Two.SidT = var/RadToDeg;

	/* AltOffset = CalcAltOffset( One, Two); */
	CalcBestAltOffset();
	printf( "\nAltOffset %f, One.Alt %f, Two.Alt %f", AltOffset * RadToDeg,
	(One.Alt + AltOffset) * RadToDeg, (Two.Alt + AltOffset) * RadToDeg);

	NewLine;
	ContMsgRoutine();
}

/* PEC area... */

/* arrays hold values that show scope movement errors in tenths of arcseconds
with PEC rotation divided into PECSize units: positive values indicate excess
CW movement;
for double or quad worms, set FullstepsPerPECArray to cover 2x or 4x worm
rotation */

void InitPEC( void)
{
	AltPECFileNameCount = AzPECFileNameCount = 0;
	SetPECVars();
	ZeroAltPEC();
	ZeroAzPEC();
	LoadPEC();
	LastAutoAltPECSyncSignal = LastAutoAzPECSyncSignal = 0;
}

void SetPECVars( void)
{
	MsPerPECArray = (long) Ms * (long) FullstepsPerPECArray;
	MsPerPECIx = MsPerPECArray / (long) PECSize;
}

void ZeroAltPEC( void)
{
	for( Ix = 0; Ix < PECSize; Ix++)
		PECs[Ix].A = 0;
}

void ZeroAzPEC( void)
{
	for( Ix = 0; Ix < PECSize; Ix++)
		PECs[Ix].Z = 0;
}

void LoadPEC( void)
{
	Flag ArrayFlag = 0;
	char Index[ValueSize];

	Input = fopen( PECFile, "r");
	if( Input == NULL)
	{
		if( DisplayOpeningMsgs)
			printf( "\nDid not find %s, using flat PEC table", PECFile);
	}
	else
	{
		if( DisplayOpeningMsgs)
			printf( "\nFound %s", PECFile);

		fscanf( Input, "%s %s", Index, Value);
		while( !feof( Input))
		{
			Ix = atoi( Index);
			TenthsArcsec = atoi( Value);
			/* 1st time through indexes, ArrayFlag == 1; 2nd time ArrayFlag == 2 */
			if( Ix == 0)
				ArrayFlag++;
			if( ArrayFlag == 1)
				PECs[Ix].A = TenthsArcsec;
			else
				PECs[Ix].Z = TenthsArcsec;
			fscanf( Input, "%s %s", Index, Value);
		}
	}
	fclose( Input);
}

void SavePEC( char* Name)
{
	Output = fopen( Name, "w");
	if( Output == NULL)
		BadExit( strcat( "Could not open ", Name));

	for( PECIx.A = 0; PECIx.A < PECSize; PECIx.A++)
		fprintf( Output, "%d %d\n", PECIx.A, PECs[PECIx.A].A);
	fprintf( Output, "\n");
	for( PECIx.Z = 0; PECIx.Z < PECSize; PECIx.Z++)
		fprintf( Output, "%d %d\n", PECIx.Z, PECs[PECIx.Z].Z);

	fclose( Output);
}

void BuildAltPECFilename( void)
{
	int len = strlen( PECALT);

	strcpy( Name, PECALT);
	Name[len-1] = '0' + AltPECFileNameCount / 10;
	Name[len] = '0' + AltPECFileNameCount - (AltPECFileNameCount / 10) * 10;
	Name[len+1] = '\0';
	strcat( Name, DOT_TXT);
	AltPECFileNameCount++;
}

void BuildAzPECFilename( void)
{
	int len = strlen( PECAZ);

	strcpy( Name, PECAZ);
	Name[len-1] = '0' + AzPECFileNameCount / 10;
	Name[len] = '0' + AzPECFileNameCount - (AzPECFileNameCount / 10) * 10;
	Name[len+1] = '\0';
	strcat( Name, DOT_TXT);
	AzPECFileNameCount++;
}

/* this function synchs PEC file to current rotor angle */
void SynchPEC( void)
{
	SynchAltPEC();
	SynchAzPEC();
}

void SynchAltPEC( void)
{
	PECIxOffset.A = (int) ((AccumMs.A%MsPerPECArray) / MsPerPECIx);
}

void SynchAzPEC( void)
{
	PECIxOffset.Z = (int) ((AccumMs.Z%MsPerPECArray) / MsPerPECIx);
}

/* this function sets the PEC array indexes based on rotor angle */
void GetPECIx( void)
{
	struct AZDouble DoublePECIx;

	DoublePECIx.A = (double) (AccumMs.A%MsPerPECArray)/ MsPerPECIx - PECIxOffset.A;
	while( DoublePECIx.A < 0)
		DoublePECIx.A += PECSize;
	while( DoublePECIx.A >= PECSize)
		DoublePECIx.A -= PECSize;
	PECIx.A = (int) DoublePECIx.A;
	DecimalPECIx.A = DoublePECIx.A - PECIx.A;
	PECDir.A = Dir.A;
	if( PECDir.A == CW)
	{
		NextPECIx.A = PECIx.A + 1;
		if( NextPECIx.A >= PECSize)
			NextPECIx.A = 0;
	}
	else
	{
		NextPECIx.A = PECIx.A - 1;
		if( NextPECIx.A < 0)
			NextPECIx.A = PECSize- 1;
		DecimalPECIx.A = 1 - DecimalPECIx.A;
	}

	DoublePECIx.Z = (double) (AccumMs.Z%MsPerPECArray)/ MsPerPECIx - PECIxOffset.Z;
	while( DoublePECIx.Z < 0)
		DoublePECIx.Z += PECSize;
	while( DoublePECIx.Z >= PECSize)
		DoublePECIx.Z -= PECSize;
	PECIx.Z = (int) DoublePECIx.Z;
	DecimalPECIx.Z = DoublePECIx.Z - PECIx.Z;
	PECDir.Z = Dir.Z;
	if( PECDir.Z == CW)
	{
		NextPECIx.Z = PECIx.Z + 1;
		if( NextPECIx.Z >= PECSize)
			NextPECIx.Z = 0;
	}
	else
	{
		NextPECIx.Z = PECIx.Z - 1;
		if( NextPECIx.Z < 0)
			NextPECIx.Z = PECSize- 1;
		DecimalPECIx.Z = 1 - DecimalPECIx.Z;
	}

	/*
	gotoxy( 2, 2); printf( "%d %d %f %d", PECIx.A, NextPECIx.A, DecimalPECIx.A, PECDir.A);
	gotoxy( 2, 3); printf( "%d %d %f %d", PECIx.Z, NextPECIx.Z, DecimalPECIx.Z, PECDir.Z);
	*/
}

void DisplayPECgraphically( void)
{
	int altpecy;
	int azpecy;
	const int linecolor = RED;
	const int altcolor = GREEN;
	const int azcolor = BLUE;
	/* pixels for each PEC index */
	double xscale;
	/* pixels for each tenths of an arcsecond */
	double yscale;
	int maxh = 0;

	InitGraphics();

	altpecy = 1 * maxy / 3;
	azpecy = 2 * maxy / 3;
	xscale = (double) maxx / (double) PECSize;

	/* set maxh to greatest deviation from zero for either axis */
	for( Ix = 0; Ix < PECSize; Ix++)
	{
		if( PECs[Ix].A > maxh)
			maxh = PECs[Ix].A;
		if( PECs[Ix].A < -maxh)
			maxh = -PECs[Ix].A;
		if( PECs[Ix].Z > maxh)
			maxh = PECs[Ix].Z;
		if( PECs[Ix].Z < -maxh)
			maxh = -PECs[Ix].Z;
	}
	if( maxh == 0)
		yscale = 1;
	else
		yscale = (double) (maxy/6) / (double) maxh;

	/* draw lines */
	for( Ix = 0; Ix <= maxx; Ix++)
		putpixel( Ix, altpecy, linecolor);
	for( Ix = 0; Ix <= maxx; Ix++)
		putpixel( Ix, azpecy, linecolor);

	/* draw vertical scales of 1 arcsecond */
	for( Ix = -10 * yscale; Ix < 10 * yscale; Ix++)
		putpixel( 0, altpecy + Ix, linecolor);
	for( Ix = -10 * yscale; Ix < 10 * yscale; Ix++)
		putpixel( 0, azpecy + Ix, linecolor);

	/* plot altitude PEC */
	for( Ix = 0; Ix < PECSize; Ix++)
		putpixel( Ix * xscale, altpecy - PECs[Ix].A * yscale, altcolor);

	/* plot azimuth PEC */
	for( Ix = 0; Ix < PECSize; Ix++)
		putpixel( Ix * xscale, azpecy - PECs[Ix].Z * yscale, azcolor);

	gotoxy( 1, 1);
	printf( "current periodic error correction values display\n");
	printf( "alt=upper curve, az=lower curve\n");
	printf( "press 'y' to save to pec.dat file, any other key to exit");
	Response = getch();
	if( Response == 'y' || Response == 'Y')
		SavePEC( PECFile);

	CloseGraphics();
	_setcursortype( _NOCURSOR);
}

Flag AveragePECAnalysisFiles( Flag axis)
{
	int pecy;
	int analysisy;
	int resulty;
	const int linecolor = RED;
	const int peccolor = WHITE;
	const int analysiscolor = YELLOW;
	const int resultcolor = GREEN;
	/* pixels for each PEC index */
	double xscale;
	/* pixels for each tenths of an arcsecond */
	double yscale;
	int maxh = 0;
	char Index[ValueSize];
	int FilesRead = 0.;
	/* declare a pointer to type of int */
	int* P;


	if( axis == azaxis)
	{
		strcpy( Fname, PECAZ);
		strcat( Fname, "*");
		strcat( Fname, DOT_TXT);
	}
	else
	{
		strcpy( Fname, PECALT);
		strcat( Fname, "*");
		strcat( Fname, DOT_TXT);
	}

	/* assign to P the address of the beginning of the allocated memory */
	P = (int*) malloc( PECSize * sizeof( int));
	/* zero out array */
	for( Ix = 0; Ix < PECSize; Ix++)
		P[Ix] = 0;

	FindFirst = True;
	FoundFile = True;

	while( FoundFile)
	{
		if( FindFirst)
		{
			FindFirst = False;
			/* returns 0 if successful */
			FoundFile = !findfirst( Fname, &Ffblk, 0);
		}
		else
			FoundFile = !findnext( &Ffblk);
		if( FoundFile)
		{
			Input = fopen( Ffblk.ff_name, "r");
			if( Input == NULL)
				BadExit( strcat( "Could not open ", Ffblk.ff_name));
			else
			{
				FilesRead++;
				fscanf( Input, "%s %s", Index, Value);
				while( !feof( Input))
				{
					/* int* P and P[] are equivalent;
					P[x] accesses element x of P, so *(P+x) == P[x];
					P == &P[0] so *P == P[0] */
					P[atoi( Index)] += atoi( Value);
					fscanf( Input, "%s %s", Index, Value);
				}
			}
			fclose( Input);
		}
	}
	if( FilesRead)
	{
		for( Ix = 0; Ix < PECSize; Ix++)
			P[Ix] /= FilesRead;

		InitGraphics();

		pecy = 1 * maxy / 4;
		analysisy = 2 * maxy / 4;
		resulty = 3 * maxy / 4;
		xscale = (double) maxx / (double) PECSize;

		/* draw lines */
		for( Ix = 0; Ix <= maxx; Ix++)
			putpixel( Ix, pecy, linecolor);
		for( Ix = 0; Ix <= maxx; Ix++)
			putpixel( Ix, analysisy, linecolor);
		for( Ix = 0; Ix <= maxx; Ix++)
			putpixel( Ix, resulty, linecolor);

		/* set maxh to greatest deviation from zero for either axis */
		for( Ix = 0; Ix < PECSize; Ix++)
		{
			if( P[Ix] > maxh)
				maxh = P[Ix];
			if( P[Ix] < -maxh)
				maxh = -P[Ix];
			if( axis == azaxis)
			{
				if( PECs[Ix].Z > maxh)
					maxh = PECs[Ix].Z;
				if( PECs[Ix].Z < -maxh)
					maxh = -PECs[Ix].Z;
				if( PECs[Ix].Z + P[Ix] > maxh)
					maxh = PECs[Ix].Z + P[Ix];
				if( PECs[Ix].Z + P[Ix] < -maxh)
					maxh = -(PECs[Ix].Z + P[Ix]);
			}
			else
			{
				if( PECs[Ix].A > maxh)
					maxh = PECs[Ix].A;
				if( PECs[Ix].A < -maxh)
					maxh = -PECs[Ix].A;
				if( PECs[Ix].A + P[Ix] > maxh)
					maxh = PECs[Ix].A + P[Ix];
				if( PECs[Ix].A + P[Ix] < -maxh)
					maxh = -(PECs[Ix].A + P[Ix]);
			}
		}
		if( maxh == 0)
			yscale = 1;
		else
			yscale = (double) (maxy/8) / (double) maxh;

		/* draw vertical scales of 1 arcsecond */
		for( Ix = -10 * yscale; Ix < 10 * yscale; Ix++)
			putpixel( 0, pecy + Ix, linecolor);
		for( Ix = -10 * yscale; Ix < 10 * yscale; Ix++)
			putpixel( 0, analysisy + Ix, linecolor);
		for( Ix = -10 * yscale; Ix < 10 * yscale; Ix++)
			putpixel( 0, resulty + Ix, linecolor);

		/* plot original PEC */
		if( axis == azaxis)
			for( Ix = 0; Ix < PECSize; Ix++)
				putpixel( Ix * xscale, pecy - PECs[Ix].Z * yscale, peccolor);
		else
			for( Ix = 0; Ix < PECSize; Ix++)
				putpixel( Ix * xscale, pecy - PECs[Ix].A * yscale, peccolor);

		/* plot averaged analysis curve */
			for( Ix = 0; Ix < PECSize; Ix++)
				putpixel( Ix * xscale, analysisy - P[Ix] * yscale, analysiscolor);

		/* plot possible updated PEC */
		if( axis == azaxis)
			for( Ix = 0; Ix < PECSize; Ix++)
				putpixel( Ix * xscale, resulty - (PECs[Ix].Z + P[Ix]) * yscale,
				resultcolor);
		else
			for( Ix = 0; Ix < PECSize; Ix++)
				putpixel( Ix * xscale, resulty -(PECs[Ix].A + P[Ix]) * yscale,
				resultcolor);

		gotoxy( 1, 1);
		printf( "adding %d averaged pec", FilesRead);
		if( axis == azaxis)
			printf( "az");
		else
			printf( "alt");
		printf( "*.txt files to pec.dat\n");
		printf( "original pec color = white, average of pec files = yellow,\n");
		printf( "pec + average color = green\n");
		printf( "press 'y' to do so, any other key to abort");
		Response = getch();
		if( Response == 'y' || Response == 'Y')
		{
			/* positive PEC indicates excess CW movement; if scope is moving
			clockwise, Current. must be increased by adding PEC so that (target
			Current. - corrected Current.) is a smaller value resulting in less
			clockwise motion;
			positive P or guide values mean the same: so add P to PEC array */
			if( axis == azaxis)
				for( Ix = 0; Ix < PECSize; Ix++)
					PECs[Ix].Z += P[Ix];
			else
				for( Ix = 0; Ix < PECSize; Ix++)
					PECs[Ix].A += P[Ix];
			SavePEC( PECFile);
		}
		CloseGraphics();
		_setcursortype( _NOCURSOR);
		free( P);
		return True;
	}
	else
	{
		free( P);
		return False;
	}
}

/* Guide Area... */

void InitGuide( void)
{
	GuideFlag = Yes;
	GuideRadTick = GuideArcsecSec/RadToArcsec/ClockTicksSec;
	AccumGuide.A = AccumGuide.Z = 0;
	GuideIx.A = GuideIx.Z = 0;
	for( Ix = 0; Ix < MaxGuideIx; Ix++)
	{
		Guides[Ix].A.PECIx = Guides[Ix].Z.PECIx = 0;
		Guides[Ix].A.TenthsArcsec = Guides[Ix].Z.TenthsArcsec = 0;
	}
	GuideDir.A = GuideDir.Z = NoRotation;
	PECIxCrossZero.A = PECIxCrossZero.Z = 0;
}

void SaveGuideAlt( void)
{
	int Ix;

	Output = fopen( GuideAltFile, "w");
	if( Output == NULL)
		BadExit( strcat( "Could not open ", GuideAltFile));

	for( Ix = 0; Ix < GuideIx.A; Ix++)
		fprintf( Output, "%d %d\n", (int) Guides[Ix].A.PECIx,
		Guides[Ix].A.TenthsArcsec);

	fclose( Output);
}

void SaveGuideAz( void)
{
	int Ix;

	Output = fopen( GuideAzFile, "w");
	if( Output == NULL)
		BadExit( strcat( "Could not open ", GuideAzFile));

	for( Ix = 0; Ix < GuideIx.Z; Ix++)
		fprintf( Output, "%d %d\n", (int) Guides[Ix].Z.PECIx,
		Guides[Ix].Z.TenthsArcsec);

	fclose( Output);
}

/* each entry in the guide array contains the PEC index and accumulated guiding
corrections; it is possible for successive entries in the guide array to skip
over PEC indexes since the motor may have rotated more than the angular distance
between PEC indexes */

void WriteToGuideArray( void)
{
	static struct AZInt HoldPECIx;
	static Flag soundon;

	if( soundon)
		nosound();

	/* only write to file if PEC index changes */
	if( PECIx.A != HoldPECIx.A)
	{
		/* make sound when PECIx.A goes through zero */
		if(( Dir.A == CW && (PECIx.A < HoldPECIx.A))
		|| ( Dir.A == CCW && (PECIx.A > HoldPECIx.A)))
		{
			sound( 1000);
			soundon = Yes;
		}
		/* write an entry in the guide array */
		Guides[GuideIx.A].A.PECIx = PECIx.A;
		Guides[GuideIx.A].A.TenthsArcsec = AccumGuide.A*RadToTenthsArcsec;
		/* gotoxy( 68, 21);
		printf( "%3d %3d %3d", Guides[GuideIx.A].A.PECIx,
		Guides[GuideIx.A].A.TenthsArcsec, GuideIx.A); */
		HoldPECIx.A = PECIx.A;
		GuideIx.A++;
	}
	if( PECIx.Z != HoldPECIx.Z)
	{
		/* make sound when PECIx.Z goes through zero */
		if(( Dir.Z == CW && (PECIx.Z < HoldPECIx.Z))
		|| ( Dir.Z == CCW && (PECIx.Z > HoldPECIx.Z)))
		{
			sound( 500);
			soundon = Yes;
		}
		/* write an entry in the guide array */
		Guides[GuideIx.Z].Z.PECIx = PECIx.Z;
		Guides[GuideIx.Z].Z.TenthsArcsec = AccumGuide.Z*RadToTenthsArcsec;
		/* gotoxy( 68, 22);
		printf( "%3d %3d %3d", Guides[GuideIx.Z].Z.PECIx,
		Guides[GuideIx.Z].Z.TenthsArcsec, GuideIx.Z); */
		HoldPECIx.Z = PECIx.Z;
		GuideIx.Z++;
	}
	if( GuideIx.A >= MaxGuideIx || GuideIx.Z >= MaxGuideIx)
	{
		sound( 250);
		delay( 50);
		nosound();
		GuideArrayFlag = ReadyToSaveGuideArray;
	}
}

void LoadGuideAlts( void)
{
	char Index[ValueSize];

	Input = fopen( GuideAltFile, "r");
	if( Input == NULL)
		printf( "\nDid not find %s", GuideAltFile);
	else
	{
		printf( "\nLoading %s", GuideAltFile);
		GuideIx.A = 0;
	}
	if( Input != NULL)
	{
		fscanf( Input, "%s %s", Index, Value);
		while( !feof( Input))
		{
			Ix = atoi( Index);
			TenthsArcsec = atoi( Value);
			Guides[GuideIx.A].A.PECIx = Ix;
			Guides[GuideIx.A].A.TenthsArcsec = TenthsArcsec;
			GuideIx.A++;
			fscanf( Input, "%s %s", Index, Value);
		}
	}
	fclose( Input);
}

void LoadGuideAzs( void)
{
	char Index[ValueSize];

	Input = fopen( GuideAzFile, "r");
	if( Input == NULL)
		printf( "\nDid not find %s", GuideAzFile);
	else
	{
		printf( "\nLoading %s", GuideAzFile);
		GuideIx.Z = 0;
	}
	if( Input != NULL)
	{
		fscanf( Input, "%s %s", Index, Value);
		while( !feof( Input))
		{
			Ix = atoi( Index);
			TenthsArcsec = atoi( Value);
			Guides[GuideIx.Z].Z.PECIx = Ix;
			Guides[GuideIx.Z].Z.TenthsArcsec = TenthsArcsec;
			GuideIx.Z++;
			fscanf( Input, "%s %s", Index, Value);
		}
	}
	fclose( Input);
}

void AnalyzeGuideAltArray( void)
{
	int cwcount = 0;
	int ccwcount = 0;
	double xscale, yscale;
	int maxh = 0;
	int guidey;
	int guidepecy;
	int Incr;
	int LastGuideIx;
	int IxB;
	double Drift;
	int Offset;
	int FileCount;
	int FileNameSize;
	const int linecolor = RED;
	const int guidecolor = GREEN;
	const int driftcolor = YELLOW;

	InitGraphics();
	guidey = 2 * maxy / 4;
	xscale = (double) maxx / (double) MaxGuideIx;

	gotoxy( 1, 1);
	printf( "altitude guiding");

	/* determine direction of motion while Guides was recorded */
	Ix = 1;
	while( Ix < MaxGuideIx && abs( cwcount - ccwcount) < 3)
	{
		if( Guides[Ix+1].A.PECIx > Guides[Ix].A.PECIx)
			cwcount++;
		else
			ccwcount++;
		Ix++;
	}
	if( cwcount > ccwcount)
		GuideDir.A = CW;
	else
		GuideDir.A = CCW;
	if( GuideDir.A == CW)
		printf( " - CW motor rotation\n");
	else
		printf( " - CCW motor rotation\n");

	printf( "top graph plots %s: PECIx=0 is shown by short vertical lines (+-1\")\n",
	GuideAltFile);
	printf( "first set in bottom graph plots guiding corrections per each PEC cycle\n");
	printf( "while second set is corrected for drift and offset");

	/* draw guide reference line */
	for( Ix = 0; Ix <= maxx; Ix++)
		putpixel( Ix, guidey, linecolor);

	/* set maxh to greatest deviation from zero */
	for( Ix = 0; Ix < GuideIx.A; Ix++)
	{
		if( Guides[Ix].A.TenthsArcsec > maxh)
			maxh = Guides[Ix].A.TenthsArcsec;
		if( Guides[Ix].A.TenthsArcsec < -maxh)
			maxh = -Guides[Ix].A.TenthsArcsec;
	}
	if( maxh == 0)
		yscale = 1;
	else
		yscale = (double) (maxy/8) / (double) maxh;

	/* plot guiding curve */
	for( Ix = 0; Ix < GuideIx.A; Ix++)
		putpixel( Ix * xscale, guidey - Guides[Ix].A.TenthsArcsec * yscale,
		guidecolor);

	/* mark PECIx of 0 */
	for( Ix = 1; Ix < GuideIx.A; Ix++)
		/* check for PECIx of 0 crossing */
		if( (GuideDir.A == CW && Guides[Ix-1].A.PECIx > Guides[Ix].A.PECIx) ||
		(GuideDir.A == CCW && Guides[Ix-1].A.PECIx < Guides[Ix].A.PECIx))
			/* draw vertical line */
			for( guidepecy = guidey - 10*yscale; guidepecy < guidey + 10*yscale; guidepecy++)
				putpixel( Ix * xscale, guidepecy, linecolor);

	/* allocate memory for PEC array */
	P = (struct PECWORK*) malloc( PECSize * sizeof( struct PECWORK));

	/* draw guidepec reference line */
	guidepecy = 3 * maxy / 4;
	for( Ix = 0; Ix <= maxx; Ix++)
		putpixel( Ix, guidepecy, linecolor);

	PECIxCrossZero.A = 0;
	if( GuideDir.A == CW)
		Incr = 1;
	else
		Incr = -1;

	/* run through Guides array again and preserve GuideIx since it is the marker
	for the end of valid Guides array values */
	LastGuideIx = GuideIx.A;
	for( IxB = 1; IxB < LastGuideIx; IxB++)
		/* check for PECIx of 0 crossing */
		if( (GuideDir.A == CW && Guides[IxB-1].A.PECIx > Guides[IxB].A.PECIx) ||
		(GuideDir.A == CCW && Guides[IxB-1].A.PECIx < Guides[IxB].A.PECIx))
		{
			PECIxCrossZero.A++;
			if( PECIxCrossZero.A == 1)
				StartGuidesIxCrossZeroPECIx.A = EndGuidesIxCrossZeroPECIx.A = IxB;
			else
				StartGuidesIxCrossZeroPECIx.A = EndGuidesIxCrossZeroPECIx.A;
			if( PECIxCrossZero.A > 1)
			{
				EndGuidesIxCrossZeroPECIx.A = IxB;

				/* zero out working array */
				for( Ix = 0; Ix < PECSize; Ix++)
				{
					P[Ix].TenthsArcsec = 0;
					P[Ix].Entry = No;
				}

				GuideIx.A = StartGuidesIxCrossZeroPECIx.A;
				/* fill working PEC array with values from Guides[] */
				while( GuideIx.A != EndGuidesIxCrossZeroPECIx.A)
				{
					Ix = Guides[GuideIx.A].A.PECIx;
					P[Ix].TenthsArcsec = Guides[GuideIx.A].A.TenthsArcsec;
					P[Ix].Entry = Yes;
					GuideIx.A += Incr;
				}

				/* fill in missing values: if value is unentered, then use value
				from previous entry */
				if( P[0].Entry == No)
					P[0].TenthsArcsec = 0;
				for( Ix = 1; Ix < PECSize; Ix++)
					if( P[Ix].Entry == No)
						P[Ix].TenthsArcsec = P[Ix-1].TenthsArcsec;

				/* display working PEC array that contains values from Guides[] */
				for( Ix = 0; Ix < PECSize; Ix++)
					putpixel( Ix * xscale, guidepecy - P[Ix].TenthsArcsec * yscale,
					guidecolor);

				/* compensate for drift */
				Drift = P[PECSize-1].TenthsArcsec - P[0].TenthsArcsec;
				for( Ix = 0; Ix < PECSize; Ix++)
					P[Ix].TenthsArcsec -= ((double) Ix / (double) PECSize) * Drift;

				/* eliminate beginning offset */
				Offset = P[0].TenthsArcsec;
				for( Ix = 0; Ix < PECSize; Ix++)
					P[Ix].TenthsArcsec -= Offset;

				/* display working PEC array that contains values from Guides[]
				compensated for drift */
				for( Ix = 0; Ix < PECSize; Ix++)
					putpixel( (PECSize + Ix) * xscale,
					guidepecy - P[Ix].TenthsArcsec * yscale, driftcolor);

				printf( "\nsave %1d PEC cycle? (y/n) ", PECIxCrossZero.A - 1);
				Response = getch();
				printf( "%c", Response);
				if( Response == 'y' || Response == 'Y')
				{
					FileCount = FindNextIncrFilename( PECALT, TXT);
					strcpy( Fname, PECALT);
					FileNameSize = sizeof( PECALT) - 1;
					Fname[FileNameSize] = '0' + FileCount / 10;
					Fname[FileNameSize+1] = '0' + FileCount - (FileCount / 10) * 10;
					Fname[FileNameSize+2] = '\0';
					strcat( Fname, DOT_TXT);
					printf( " %s", Fname);

					Output = fopen( Fname, "w");
					if( Output == NULL)
						BadExit( strcat( "Could not open ", Fname));
					for( Ix = 0; Ix < PECSize; Ix++)
						fprintf( Output, "%d %d\n", Ix, P[Ix].TenthsArcsec);
					fclose( Output);
				}
			}
	}
	printf( "\npress any key to continue");
	getch();
	free( P);
	/* restore GuideIx since it marks the end of valid Guides values */
	GuideIx.A = LastGuideIx;
	CloseGraphics();
	_setcursortype( _NOCURSOR);
}

void AnalyzeGuideAzArray( void)
{
	int cwcount = 0;
	int ccwcount = 0;
	double xscale, yscale;
	int maxh = 0;
	int guidey;
	int guidepecy;
	int Incr;
	int LastGuideIx;
	int IxB;
	double Drift;
	int Offset;
	int FileCount;
	int FileNameSize;
	const int linecolor = RED;
	const int guidecolor = GREEN;
	const int driftcolor = YELLOW;

	InitGraphics();
	guidey = 2 * maxy / 4;
	xscale = (double) maxx / (double) MaxGuideIx;

	gotoxy( 1, 1);
	printf( "azimuth guiding");

	/* determine direction of motion while Guides was recorded */
	Ix = 1;
	while( Ix < MaxGuideIx && abs( cwcount - ccwcount) < 3)
	{
		if( Guides[Ix+1].Z.PECIx > Guides[Ix].Z.PECIx)
			cwcount++;
		else
			ccwcount++;
		Ix++;
	}
	if( cwcount > ccwcount)
		GuideDir.Z = CW;
	else
		GuideDir.Z = CCW;
	if( GuideDir.Z == CW)
		printf( " - CW motor rotation\n");
	else
		printf( " - CCW motor rotation\n");

	printf( "top graph plots %s: PECIx=0 is shown by short vertical lines (+-1\")\n",
	GuideAzFile);
	printf( "first set in bottom graph plots guiding corrections per each PEC cycle\n");
	printf( "while second set is corrected for drift and offset");

	/* draw guide reference line */
	for( Ix = 0; Ix <= maxx; Ix++)
		putpixel( Ix, guidey, linecolor);

	/* set maxh to greatest deviation from zero */
	for( Ix = 0; Ix < GuideIx.Z; Ix++)
	{
		if( Guides[Ix].Z.TenthsArcsec > maxh)
			maxh = Guides[Ix].Z.TenthsArcsec;
		if( Guides[Ix].Z.TenthsArcsec < -maxh)
			maxh = -Guides[Ix].Z.TenthsArcsec;
	}
	if( maxh == 0)
		yscale = 1;
	else
		yscale = (double) (maxy/8) / (double) maxh;

	/* plot guiding curve */
	for( Ix = 0; Ix < GuideIx.Z; Ix++)
		putpixel( Ix * xscale, guidey - Guides[Ix].Z.TenthsArcsec * yscale,
		guidecolor);

	/* mark PECIx of 0 */
	for( Ix = 1; Ix < GuideIx.Z; Ix++)
		/* check for PECIx of 0 crossing */
		if( (GuideDir.Z == CW && Guides[Ix-1].Z.PECIx > Guides[Ix].Z.PECIx) ||
		(GuideDir.Z == CCW && Guides[Ix-1].Z.PECIx < Guides[Ix].Z.PECIx))
			/* draw vertical line */
			for( guidepecy = guidey - 10*yscale; guidepecy < guidey + 10*yscale; guidepecy++)
				putpixel( Ix * xscale, guidepecy, linecolor);

	/* allocate memory for PEC array */
	P = (struct PECWORK*) malloc( PECSize * sizeof( struct PECWORK));

	/* draw guidepec reference line */
	guidepecy = 3 * maxy / 4;
	for( Ix = 0; Ix <= maxx; Ix++)
		putpixel( Ix, guidepecy, linecolor);

	PECIxCrossZero.Z = 0;
	if( GuideDir.Z == CW)
		Incr = 1;
	else
		Incr = -1;

	/* run through Guides array again and preserve GuideIx since it is the marker
	for the end of valid Guides array values */
	LastGuideIx = GuideIx.Z;
	for( IxB = 1; IxB < LastGuideIx; IxB++)
		/* check for PECIx of 0 crossing */
		if( (GuideDir.Z == CW && Guides[IxB-1].Z.PECIx > Guides[IxB].Z.PECIx) ||
		(GuideDir.Z == CCW && Guides[IxB-1].Z.PECIx < Guides[IxB].Z.PECIx))
		{
			PECIxCrossZero.Z++;
			if( PECIxCrossZero.Z == 1)
				StartGuidesIxCrossZeroPECIx.Z = EndGuidesIxCrossZeroPECIx.Z = IxB;
			else
				StartGuidesIxCrossZeroPECIx.Z = EndGuidesIxCrossZeroPECIx.Z;
			if( PECIxCrossZero.Z > 1)
			{
				EndGuidesIxCrossZeroPECIx.Z = IxB;

				/* zero out working array */
				for( Ix = 0; Ix < PECSize; Ix++)
				{
					P[Ix].TenthsArcsec = 0;
					P[Ix].Entry = No;
				}

				GuideIx.Z = StartGuidesIxCrossZeroPECIx.Z;
				/* fill working PEC array with values from Guides[] */
				while( GuideIx.Z != EndGuidesIxCrossZeroPECIx.Z)
				{
					Ix = Guides[GuideIx.Z].Z.PECIx;
					P[Ix].TenthsArcsec = Guides[GuideIx.Z].Z.TenthsArcsec;
					P[Ix].Entry = Yes;
					GuideIx.Z += Incr;
				}

				/* fill in missing values: if value is unentered, then use value
				from previous entry */
				if( P[0].Entry == No)
					P[0].TenthsArcsec = 0;
				for( Ix = 1; Ix < PECSize; Ix++)
					if( P[Ix].Entry == No)
						P[Ix].TenthsArcsec = P[Ix-1].TenthsArcsec;

				/* display working PEC array that contains values from Guides[] */
				for( Ix = 0; Ix < PECSize; Ix++)
					putpixel( Ix * xscale, guidepecy - P[Ix].TenthsArcsec * yscale,
					guidecolor);

				/* compensate for drift */
				Drift = P[PECSize-1].TenthsArcsec - P[0].TenthsArcsec;
				for( Ix = 0; Ix < PECSize; Ix++)
					P[Ix].TenthsArcsec -= ((double) Ix / (double) PECSize) * Drift;

				/* eliminate beginning offset */
				Offset = P[0].TenthsArcsec;
				for( Ix = 0; Ix < PECSize; Ix++)
					P[Ix].TenthsArcsec -= Offset;

				/* display working PEC array that contains values from Guides[]
				compensated for drift */
				for( Ix = 0; Ix < PECSize; Ix++)
					putpixel( (PECSize + Ix) * xscale,
					guidepecy - P[Ix].TenthsArcsec * yscale, driftcolor);

				printf( "\nsave %1d PEC cycle? (y/n) ", PECIxCrossZero.Z - 1);
				Response = getch();
				printf( "%c", Response);
				if( Response == 'y' || Response == 'Y')
				{
					FileCount = FindNextIncrFilename( PECAZ, TXT);
					strcpy( Fname, PECAZ);
					FileNameSize = sizeof( PECAZ) - 1;
					Fname[FileNameSize] = '0' + FileCount / 10;
					Fname[FileNameSize+1] = '0' + FileCount - (FileCount / 10) * 10;
					Fname[FileNameSize+2] = '\0';
					strcat( Fname, DOT_TXT);
					printf( " %s", Fname);

					Output = fopen( Fname, "w");
					if( Output == NULL)
						BadExit( strcat( "Could not open ", Fname));
					for( Ix = 0; Ix < PECSize; Ix++)
						fprintf( Output, "%d %d\n", Ix, P[Ix].TenthsArcsec);
					fclose( Output);
				}
			}
	}
	printf( "\npress any key to continue");
	getch();
	free( P);
	/* restore GuideIx since it marks the end of valid Guides values */
	GuideIx.Z = LastGuideIx;
	CloseGraphics();
	_setcursortype( _NOCURSOR);
}

/* IACA area... */

/* the Intra-Application Communication Area is a 16 byte area starting at
0040:00F0 that DOS sets aside to allow programs to communicate with each other;

this area is used to exchange coordinates between the scope control program
and graphically oriented CD-ROM planetarium programs such as Guide;

the planetarium program's coordinates serve as input to the scope,
the scope program tells the planetarium program where the scope is pointing;

coordinates are assumed to be precessed to the current date;

each program, at startup, sets all coordinates initially to zero: this way,
when non-zero coordinates are found, it can be assumed that the other program
put them there;

ie,
long iaca_ra = *(long far*) (0x4f0);
long iaca_dec = *(long far*) (0x4f4);
long scope_ra = *(long far*) (0x4f8);
long scope_dec = *(long far*) (0x4fc);
double scope_ra_in_decimal_hours = (double) scope_ra / 1.e+7;
double scope_dec_in_decimal_degrees = (double) scope_dec / 1.e+7; */

void InitIACA( void)
{
	Conv_Factor = 1.e+7;

	IACA_Ra_Decimal_Hrs_Ptr = (long far*) 0x4f0;
	IACA_Dec_Decimal_Degrees_Ptr = (long far*) 0x4f4;
	Scope_Ra_Decimal_Hrs_Ptr = (long far*) 0x4f8;
	Scope_Dec_Decimal_Degrees_Ptr = (long far*) 0x4fc;

	*IACA_Ra_Decimal_Hrs_Ptr = 0;
	*IACA_Dec_Decimal_Degrees_Ptr = 0;
	*Scope_Ra_Decimal_Hrs_Ptr = 0;
	*Scope_Dec_Decimal_Degrees_Ptr = 0;
}

void PutScope( double RaRad, double DecRad)
{
	*Scope_Ra_Decimal_Hrs_Ptr= (long) (RaRad * RadToHr * Conv_Factor);
	*Scope_Dec_Decimal_Degrees_Ptr= (long) (DecRad * RadToDeg * Conv_Factor);
}

int NewIACA( void)
{
	static long HoldRa, HoldDec;

	if( HoldRa != *IACA_Ra_Decimal_Hrs_Ptr)
	{
		HoldRa = *IACA_Ra_Decimal_Hrs_Ptr;
		return True;
	}
	else
		if( HoldDec != *IACA_Dec_Decimal_Degrees_Ptr)
		{
			HoldDec = *IACA_Dec_Decimal_Degrees_Ptr;
			return True;
		}
		else
			return False;
}

void GetIACA( double* RaRad, double* DecRad)
{
	*RaRad = (double) *IACA_Ra_Decimal_Hrs_Ptr / (RadToHr*Conv_Factor);
	*DecRad = (double) *IACA_Dec_Decimal_Degrees_Ptr / (RadToDeg*Conv_Factor);
}

void TestIACA( void)
{
	double Ra, Dec;

	printf( "\n\n\nStarting IACA module test:");
	printf( "\n     (Ra in decimal hours and Dec in decimal degrees)");
	do
	{
		printf( "\nPlease enter Scope Ra ");
		GetDouble( &Ra);
		printf( "   Dec ");
		GetDouble( &Dec);
		PutScope( Ra/RadToHr, Dec/RadToDeg);
		printf( "Scope Ra = %f", (double) *Scope_Ra_Decimal_Hrs_Ptr/Conv_Factor);
		printf( " Dec = %f", (double) *Scope_Dec_Decimal_Degrees_Ptr/Conv_Factor);

		GetIACA( &Ra, &Dec);
		printf( "\nIACA Ra = %f Dec = %f", Ra*RadToHr, Dec*RadToDeg);
		printf( "\nInject new IACA Ra Dec? ");

		Response = getch();
		if( Response=='y' || Response=='Y')
		{
			printf( "Enter new IACA Ra ");
			GetDouble( &Ra);
			printf( " Dec ");
			GetDouble( &Dec);
			*IACA_Ra_Decimal_Hrs_Ptr = (long) (Ra*Conv_Factor);
			*IACA_Dec_Decimal_Degrees_Ptr = (long) (Dec*Conv_Factor);
			GetIACA( &Ra, &Dec);
			printf( "IACA Ra = %f Dec = %f", Ra*RadToHr, Dec*RadToDeg);
		}
		printf( "\nAnother go (y/n)? ");
		Response = getch();
	} while( Response=='y' || Response=='Y');
	ContMsgRoutine();
}

