/* DOS 'C' program compiled with Borland C++ 4.5x, use large memory model;
tabs set at 3 char spacing; look at the altaz.htm document for more notes */

#include <math.h>
#include <time.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <values.h>
#include <string.h>
#include <ctype.h>
#include <dir.h>
#include <process.h>
#include <graphics.h>
#include "common.h"
#include "lowlevel.h"
#include "scope.h"

/* LX200 input... */

void InitLX200Input( void)
{
	if( LX200ComPort < 0 || LX200ComPort > 2)
		BadExit( "LX200ComPort must be 0, 1, or 2");
	if( LX200ComPort && LX200ComPort == EncoderComPort)
		BadExit( "LX200ComPort can't equal EncoderComPort");

	InitSerial( LX200ComPort, BaudRate, Parity, DataBits, StopBits);
	LX200_Ix = 0;
	LX200_Cmd_Count = 0;
	Beg_LX200_Ix = 0;
	LX200_LongFormat = No;
	LX200_Motor_Cmd = LX200_Speed_Cmd = NoAck;
	for( Ix = 0; Ix < LX200QueueSize; Ix++)
		LX200Queue[Ix] = Blank;
	for( Ix = 0; Ix < LX200_Cmd_Array_Size; Ix++)
	{
		LX200_Cmd_Array[Ix].LX200_Cmd_Type = 0;
		LX200_Cmd_Array[Ix].BegIx = 0;
	}
	LX200_Cmd_Array_Ix = 0;

	strcpy( LX200_Cmd_Str[NoAck], "NA");
	strcpy( LX200_Cmd_Str[Ack], "AK");
	strcpy( LX200_Cmd_Str[GetRa], "GR");
	strcpy( LX200_Cmd_Str[GetDec], "GD");
	strcpy( LX200_Cmd_Str[GetAlt], "GA");
	strcpy( LX200_Cmd_Str[GetAz], "GZ");
	strcpy( LX200_Cmd_Str[GetSidT], "GS");
	strcpy( LX200_Cmd_Str[GetLat], "Gt");
	strcpy( LX200_Cmd_Str[GetLong], "Gg");
	strcpy( LX200_Cmd_Str[MoveDirRateNorth], "Mn");
	strcpy( LX200_Cmd_Str[MoveDirRateSouth], "Ms");
	strcpy( LX200_Cmd_Str[MoveDirRateEast], "Me");
	strcpy( LX200_Cmd_Str[MoveDirRateWest], "Mw");
	strcpy( LX200_Cmd_Str[StartSlew], "MS");
	strcpy( LX200_Cmd_Str[StopSlew], "Q ");
	strcpy( LX200_Cmd_Str[StopMotionNorth], "Qn");
	strcpy( LX200_Cmd_Str[StopMotionSouth], "Qs");
	strcpy( LX200_Cmd_Str[StopMotionEast], "Qe");
	strcpy( LX200_Cmd_Str[StopMotionWest], "Qw");
	strcpy( LX200_Cmd_Str[SetMotionRateGuide], "RG");
	strcpy( LX200_Cmd_Str[SetMotionRateCenter], "RC");
	strcpy( LX200_Cmd_Str[SetMotionRateFind], "RM");
	strcpy( LX200_Cmd_Str[SetMotionRateSlew], "RS");
	strcpy( LX200_Cmd_Str[SetRa], "Sr");
	strcpy( LX200_Cmd_Str[SetDec], "Sd");
	strcpy( LX200_Cmd_Str[SetSidT], "SS");
	strcpy( LX200_Cmd_Str[SetLocalT], "SL");
	strcpy( LX200_Cmd_Str[SetDate], "SC");
	strcpy( LX200_Cmd_Str[Sync], "CM");
	strcpy( LX200_Cmd_Str[ToggleLongFormat], "U ");
	strcpy( LX200_Cmd_Str[LX200_Unfinished_Cmd], "Un");
	strcpy( LX200_Cmd_Str[LX200_Unknown_Cmd0], "U0");
	strcpy( LX200_Cmd_Str[LX200_Unknown_Cmd1], "U1");
	strcpy( LX200_Cmd_Str[LX200_Ignored_Cmd], "Ig");
}

void InsertLX200CmdIntoArray( const LX200_COMMAND_TYPE LX200_Cmd_To_Add,
const int LX200_Ix)
{
	LX200_Cmd_Array_Ix++;
	/* array size must be 2^n - 1 for this to work */
	LX200_Cmd_Array_Ix &= LX200_Cmd_Array_End;
	LX200_Cmd_Array[LX200_Cmd_Array_Ix].LX200_Cmd_Type = LX200_Cmd_To_Add;
	LX200_Cmd_Array[LX200_Cmd_Array_Ix].BegIx = LX200_Ix;
	LX200_Cmd_Count++;
}

void ReadLX200Input( void)
{
	Byte B;
	static Flag ReadSomethingLastTime;
	static Flag ReadSomethingThisTime;

	if( ReadSerial( LX200ComPort, &B))
	{
		ReadSomethingThisTime = Yes;
		do
		{
			LX200_Ix++;
			LX200_Ix &= LX200QueueEnd;
			LX200Queue[LX200_Ix] = B;
			if( LX200Queue[LX200_Ix] == LX200_ACK)
			{
				WriteSerial( LX200ComPort, 'A');
				InsertLX200CmdIntoArray( Ack, LX200_Ix);
				/* start fresh, ignoring any previous commands */
				Beg_LX200_Ix = LX200_Ix+1;
				Beg_LX200_Ix &= LX200QueueEnd;
				ReadSomethingThisTime = No;
			}
		} while( ReadSerial( LX200ComPort, &B));
	}
	else
		ReadSomethingThisTime = No;

	/* since multiple commands can be streamed at one time, wait until input
	port is quiet before processing commands */
	if( ReadSomethingThisTime == Yes)
		ReadSomethingLastTime = True;
	else
		if( ReadSomethingLastTime == True)
		{
			ReadSomethingLastTime = No;
			/* all commands end with a '#' */
			if( LX200Queue[LX200_Ix] == '#')
				ProcessLX200Cmds();
			else
				InsertLX200CmdIntoArray( LX200_Unfinished_Cmd, LX200_Ix);
			/* get ready for next command... */
			Beg_LX200_Ix = LX200_Ix+1;
			Beg_LX200_Ix &= LX200QueueEnd;
		}
}

void LX200_Write_Ra( void)
{
	int Hr, Min, TenthsMin;

	GetHMSH( RadToHundSec*Current.Ra + 0.5, &Current.RaHMSH);
	if( LX200_LongFormat)
		sprintf( StrBuf, "%02d:%02d:%02d#", Current.RaHMSH.Hr, Current.RaHMSH.Min,
		Current.RaHMSH.Sec);
	else
	{
		Hr = Current.RaHMSH.Hr;
		Min = Current.RaHMSH.Min;
		TenthsMin = (Current.RaHMSH.Sec + 3)/6;
		if( TenthsMin > 9)
		{
			TenthsMin = 0;
			Min++;
			if( Min > 59)
			{
				Min = 0;
				Hr++;
			}
		}
		sprintf( StrBuf, "%02d:%02d.%1d#", Hr, Min, TenthsMin);
	}
	WriteSerialString( LX200ComPort, StrBuf, 8);
}

void LX200_Write_Dec( void)
{
	int Deg, Min;
	char Sign;

	GetDMS( RadToArcsec*Current.Dec + 0.5, &Current.DecDMS);
	if( Current.DecDMS.Sign == Plus)
		Sign = '+';
	else
		Sign = '-';
	if( LX200_LongFormat)
		sprintf( StrBuf, "%c%02d%c%02d:02d#", Sign, Current.DecDMS.Deg, DegSym,
		Current.DecDMS.Min, Current.DecDMS.Sec);
	else
	{
		Deg = Current.DecDMS.Deg;
		Min = Current.DecDMS.Min;
		if( Current.DecDMS.Sec > 29)
		{
			Min++;
			if( Min > 59)
			{
				Min = 0;
				Deg++;
			}
		}
		sprintf( StrBuf, "%c%02d%c%02d#", Sign, Deg, DegSym, Min);
	}
	WriteSerialString( LX200ComPort, StrBuf, 7);
}

void LX200_Write_Alt( void)
{
	struct DMS V;
	char Sign;

	GetDMS( RadToArcsec*Current.Alt + 0.5, &V);
	if( V.Sign == Plus)
		Sign = '+';
	else
		Sign = '-';
	if( LX200_LongFormat)
		sprintf( StrBuf, "%c%02d%c%02d:%02d#", Sign, V.Deg, DegSym, V.Min, V.Sec);
	else
	{
		if( V.Sec > 29)
		{
			V.Min++;
			if( V.Min > 59)
				V.Deg++;
		}
		sprintf( StrBuf, "%c%02d%c%02d#", Sign, V.Deg, DegSym, V.Min);
	}
	WriteSerialString( LX200ComPort, StrBuf, 7);
}

void LX200_Write_Az( void)
{
	struct DMS V;

	GetDMS( RadToArcsec*Current.Az + 0.5, &V);
	if( LX200_LongFormat)
		sprintf( StrBuf, "%03d%c%02d:%02d#", V.Deg, DegSym, V.Min, V.Sec);
	else
	{
		if( V.Sec > 29)
		{
			V.Min++;
			if( V.Min > 59)
				V.Deg++;
		}
		sprintf( StrBuf, "%03d%c%02d#", V.Deg, DegSym, V.Min);
	}
	WriteSerialString( LX200ComPort, StrBuf, 7);
}

void LX200_Write_SidT( void)
{
	GetHMSH( RadToHundSec*Current.SidT + 0.5, &Current.SidTimeHMSH);
	sprintf( StrBuf, "%02d:%02d:%02d#", Current.SidTimeHMSH.Hr,
	Current.SidTimeHMSH.Min, Current.SidTimeHMSH.Sec);
	WriteSerialString( LX200ComPort, StrBuf, 9);
}

void LX200_Write_Lat( void)
{
	struct DMS V;
	char Sign;

	GetDMS( RadToArcsec*Lat + 0.5, &V);
	if( V.Sign == Plus)
		Sign = '+';
	else
		Sign = '-';
	if( LX200_LongFormat)
		sprintf( StrBuf, "%c%02d%c%02d:%02d#", Sign, V.Deg, DegSym, V.Min, V.Sec);
	else
	{
		if( V.Sec > 29)
		{
			V.Min++;
			if( V.Min > 59)
				V.Deg++;
		}
		sprintf( StrBuf, "%c%02d%c%02d#", Sign, V.Deg, DegSym, V.Min);
	}
	WriteSerialString( LX200ComPort, StrBuf, 7);
}

void LX200_Write_Long( void)
{
	struct DMS V;

	GetDMS( RadToArcsec*LongitudeRad + 0.5, &V);
	if( LX200_LongFormat)
		sprintf( StrBuf, "%03d%c%02d:%02d#", V.Deg, DegSym, V.Min, V.Sec);
	else
	{
		if( V.Sec > 29)
		{
			V.Min++;
			if( V.Min > 59)
				V.Deg++;
		}
		sprintf( StrBuf, "%03d%c%02d#", V.Deg, DegSym, V.Min);
	}
	WriteSerialString( LX200ComPort, StrBuf, 7);
}

void LX200_Read_Ra( const int Ix)
{
	int Ix3, Ix4, Ix6, Ix7, Ix9, Ix10;

	Ix3 = Ix+3;
	Ix3 &= LX200QueueEnd;
	Ix4 = Ix+4;
	Ix4 &= LX200QueueEnd;
	Ix6 = Ix+6;
	Ix6 &= LX200QueueEnd;
	Ix7 = Ix+7;
	Ix7 &= LX200QueueEnd;
	Ix9 = Ix+9;
	Ix9 &= LX200QueueEnd;
	Ix10 = Ix+10;
	Ix10 &= LX200QueueEnd;

	In.RaHMSH.Hr = (LX200Queue[Ix3] - '0') * 10	+ (LX200Queue[Ix4] - '0');
	In.RaHMSH.Min = (LX200Queue[Ix6] - '0') * 10 + (LX200Queue[Ix7] - '0');
	if( LX200_LongFormat)
		/* _HH:MM:SS# */
		In.RaHMSH.Sec = (LX200Queue[Ix9] - '0') * 10 + (LX200Queue[Ix10] - '0');
	else
		/* _HH:MM.T# */
		In.RaHMSH.Sec = 6 * (LX200Queue[Ix9] - '0');
	In.RaHMSH.HundSec = 0;
	In.RaHMSH.Sign = Plus;
	CalcRadFromHMSH( &In.Ra, In.RaHMSH);
	WriteSerial( LX200ComPort, LX200_OK);
	DisplayIn( "from LX200", NameBlanks);
}

void LX200_Read_Dec( const int Ix)
{
	int Ix3, Ix4, Ix5, Ix7, Ix8, Ix10, Ix11;

	Ix3 = Ix+3;
	Ix3 &= LX200QueueEnd;
	Ix4 = Ix+4;
	Ix4 &= LX200QueueEnd;
	Ix5 = Ix+5;
	Ix5 &= LX200QueueEnd;
	Ix7 = Ix+7;
	Ix7 &= LX200QueueEnd;
	Ix8 = Ix+8;
	Ix8 &= LX200QueueEnd;
	Ix10 = Ix+10;
	Ix10 &= LX200QueueEnd;
	Ix11 = Ix+11;
	Ix11 &= LX200QueueEnd;

	In.DecDMS.Deg = (LX200Queue[Ix4] - '0') * 10 + (LX200Queue[Ix5] - '0');
	In.DecDMS.Min = (LX200Queue[Ix7] - '0') * 10 + (LX200Queue[Ix8] - '0');
	if( LX200_LongFormat)
		/* _sDD*MM:SS# */
		In.DecDMS.Sec = (LX200Queue[Ix10] - '0') * 10 + (LX200Queue[Ix11] - '0');
	else
		/* _sDD*MM# */
		In.DecDMS.Sec = 0;
	if( LX200Queue[Ix3] == '+')
		In.DecDMS.Sign = Plus;
	else
		In.DecDMS.Sign = Minus;
	CalcRadFromDMS( &In.Dec, In.DecDMS);
	WriteSerial( LX200ComPort, LX200_OK);
	DisplayIn( "from LX200", NameBlanks);
}

void LX200_Read_SidT( const int Ix)
{
	double GST;
	int Ix3, Ix4, Ix6, Ix7, Ix9, Ix10;

	// MLB: note: not yet finished

	// WriteSerial( LX200ComPort, LX200_OK);

	Ix3 = Ix+3;
	Ix3 &= LX200QueueEnd;
	Ix4 = Ix+4;
	Ix4 &= LX200QueueEnd;
	Ix6 = Ix+6;
	Ix6 &= LX200QueueEnd;
	Ix7 = Ix+7;
	Ix7 &= LX200QueueEnd;
	Ix9 = Ix+9;
	Ix9 &= LX200QueueEnd;
	Ix10 = Ix+10;
	Ix10 &= LX200QueueEnd;

	/* _HH:MM:SS# (always use 24 hr format) */
	In.SidTimeHMSH.Hr = (LX200Queue[Ix3] - '0') * 10	+ (LX200Queue[Ix4] - '0');
	In.SidTimeHMSH.Min = (LX200Queue[Ix6] - '0') * 10 + (LX200Queue[Ix7] - '0');
	In.SidTimeHMSH.Sec = (LX200Queue[Ix9] - '0') * 10 + (LX200Queue[Ix10] - '0');
	In.SidTimeHMSH.HundSec = 0;
	In.SidTimeHMSH.Sign = Plus;
	CalcRadFromHMSH( &In.SidT, In.SidTimeHMSH);

	/* local sidereal time to greenwich sidereal time */
	GST = In.SidT + LongitudeRad;
	/* ignore any days to add since we are dealing with time only, not date here */
	if( GST > OneRev)
		GST -= OneRev;

	/* GST to UT */

	/* UT to local time */

	/* MLB not finished */
}

void LX200_Read_LocalT( const int Ix)
{
	long Yr;
	int M;
	int D;
	int hr, min, sec;
	int Ix3, Ix4, Ix6, Ix7, Ix9, Ix10;

	WriteSerial( LX200ComPort, LX200_OK);

	Ix3 = Ix+3;
	Ix3 &= LX200QueueEnd;
	Ix4 = Ix+4;
	Ix4 &= LX200QueueEnd;
	Ix6 = Ix+6;
	Ix6 &= LX200QueueEnd;
	Ix7 = Ix+7;
	Ix7 &= LX200QueueEnd;
	Ix9 = Ix+9;
	Ix9 &= LX200QueueEnd;
	Ix10 = Ix+10;
	Ix10 &= LX200QueueEnd;

	/* _HH:MM:SS# (always use 24 hr format) */
	hr = (LX200Queue[Ix3] - '0') * 10	+ (LX200Queue[Ix4] - '0');
	min = (LX200Queue[Ix6] - '0') * 10 + (LX200Queue[Ix7] - '0');
	sec = (LX200Queue[Ix9] - '0') * 10 + (LX200Queue[Ix10] - '0');

	getdate( &d);
	/* set century for Y2K problem with CMOS clock */
	Century = d.da_year / 100;
	Yr = (long) d.da_year;
	M = (int) d.da_mon;
	D = (int) d.da_day;

	SetRealTimeClock( hr, min, sec);
	SetDOSToCMOS();
	SetStartBiosClockAndSidTime( Yr, M, D, hr, min, sec, Tz, DST, LongitudeDeg);
}

void LX200_Read_CurrentDate( const int Ix)
{
	int h;
	int m;
	double s;
	long year;
	int mon, day;
	int Ix3, Ix4, Ix6, Ix7, Ix9, Ix10;

	WriteSerial( LX200ComPort, LX200_OK);

	Ix3 = Ix+3;
	Ix3 &= LX200QueueEnd;
	Ix4 = Ix+4;
	Ix4 &= LX200QueueEnd;
	Ix6 = Ix+6;
	Ix6 &= LX200QueueEnd;
	Ix7 = Ix+7;
	Ix7 &= LX200QueueEnd;
	Ix9 = Ix+9;
	Ix9 &= LX200QueueEnd;
	Ix10 = Ix+10;
	Ix10 &= LX200QueueEnd;

	/* _MM/DD/YY# */
	mon = (LX200Queue[Ix3] - '0') * 10	+ (LX200Queue[Ix4] - '0');
	day = (LX200Queue[Ix6] - '0') * 10 + (LX200Queue[Ix7] - '0');
	year = (LX200Queue[Ix9] - '0') * 10 + (LX200Queue[Ix10] - '0');

	if( year > 80)
		Century = 19;
	else
		Century = 20;

	gettime( &t);
	h = (int) t.ti_hour;
	m = (int) t.ti_min;
	s = ((double) t.ti_sec) + (t.ti_hund / 100.);

	SetDateofRealTimeClock( Century, (int) year, mon, day);
	SetDOSToCMOS();
	SetStartBiosClockAndSidTime( year, mon, day, h, m, s, Tz, DST, LongitudeDeg);
}

void ProcessLX200Cmds( void)
{
	int Ix, IxA, Cmd_Ix, Ix1, IncrIx;

	Ix = Beg_LX200_Ix;
	IxA = LX200_Ix+1;
	IxA &= LX200QueueEnd;

	while( Ix != IxA)
	{
		IncrIx = 1;
		/* all commands start with a ':' */
		if( LX200Queue[Ix] == ':')
		{
			Cmd_Ix = Ix;
			Ix++;
			Ix &= LX200QueueEnd;
			Ix1 = Ix+1;
			Ix1 &= LX200QueueEnd;

			switch( LX200Queue[Ix])
			{
				case 'C':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						case 'M':
							IncrIx++;
							InsertLX200CmdIntoArray( Sync, Cmd_Ix);
							Response = MenuResetEquat;
							GetNewMenuCatSubFromResponse();
							UpdateMenuCatSub();
							ProcessMenuSelection();
							LX200_Write_Ra();
							LX200_Write_Dec();
							break;
						default:
							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1, Cmd_Ix);
					}
					break;
				case 'G':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						case 'R':
							IncrIx++;
							InsertLX200CmdIntoArray( GetRa, Cmd_Ix);
							LX200_Write_Ra();
							break;
						case 'D':
							IncrIx++;
							InsertLX200CmdIntoArray( GetDec, Cmd_Ix);
							LX200_Write_Dec();
							break;
						case 'A':
							IncrIx++;
							InsertLX200CmdIntoArray( GetAlt, Cmd_Ix);
							LX200_Write_Alt();
							break;
						case 'Z':
							IncrIx++;
							InsertLX200CmdIntoArray( GetAz, Cmd_Ix);
							LX200_Write_Az();
							break;
						case 'S':
							IncrIx++;
							InsertLX200CmdIntoArray( GetSidT, Cmd_Ix);
							LX200_Write_SidT();
							break;
						case 't':
							IncrIx++;
							InsertLX200CmdIntoArray( GetLat, Cmd_Ix);
							LX200_Write_Lat();
							break;
						case 'g':
							IncrIx++;
							InsertLX200CmdIntoArray( GetLong, Cmd_Ix);
							LX200_Write_Long();
							break;
						default:
							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1, Cmd_Ix);
					}
					break;
				case 'M':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						case 'n':
							IncrIx++;
							InsertLX200CmdIntoArray( MoveDirRateNorth, Cmd_Ix);
							LX200_Motor_Cmd = MoveDirRateNorth;
							break;
						case 's':
							IncrIx++;
							InsertLX200CmdIntoArray( MoveDirRateSouth, Cmd_Ix);
							LX200_Motor_Cmd = MoveDirRateSouth;
							break;
						case 'e':
							IncrIx++;
							InsertLX200CmdIntoArray( MoveDirRateEast, Cmd_Ix);
							LX200_Motor_Cmd = MoveDirRateEast;
							break;
						case 'w':
							IncrIx++;
							InsertLX200CmdIntoArray( MoveDirRateWest, Cmd_Ix);
							LX200_Motor_Cmd = MoveDirRateWest;
							break;
						case 'G':
						case 'S':
							IncrIx++;
							InsertLX200CmdIntoArray( StartSlew, Cmd_Ix);
							LX200_Speed_Cmd = LX200_Motor_Cmd = StartSlew;
							WriteSerial( LX200ComPort, '0');
							break;
						default:
							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1, Cmd_Ix);
					}
					break;
				case 'Q':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						case '#':
							InsertLX200CmdIntoArray( StopSlew, Cmd_Ix);
							LX200_Motor_Cmd = StopSlew;
							break;
						case 'n':
							IncrIx++;
							InsertLX200CmdIntoArray( StopMotionNorth, Cmd_Ix);
							LX200_Motor_Cmd = StopMotionNorth;
							break;
						case 's':
							IncrIx++;
							InsertLX200CmdIntoArray( StopMotionSouth, Cmd_Ix);
							LX200_Motor_Cmd = StopMotionSouth;
							break;
						case 'e':
							IncrIx++;
							InsertLX200CmdIntoArray( StopMotionEast, Cmd_Ix);
							LX200_Motor_Cmd = StopMotionEast;
							break;
						case 'w':
							IncrIx++;
							InsertLX200CmdIntoArray( StopMotionWest, Cmd_Ix);
							LX200_Motor_Cmd = StopMotionWest;
							break;
						default:
							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1, Cmd_Ix);
					}
					break;
				case 'R':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						case 'G':
							IncrIx++;
							InsertLX200CmdIntoArray( SetMotionRateGuide, Cmd_Ix);
							LX200_Speed_Cmd = SetMotionRateGuide;
							break;
						case 'C':
							IncrIx++;
							InsertLX200CmdIntoArray( SetMotionRateCenter, Cmd_Ix);
							LX200_Speed_Cmd = SetMotionRateCenter;
							break;
						case 'M':
							IncrIx++;
							InsertLX200CmdIntoArray( SetMotionRateFind, Cmd_Ix);
							LX200_Speed_Cmd = SetMotionRateFind;
							break;
						case 'S':
							IncrIx++;
							InsertLX200CmdIntoArray( SetMotionRateSlew, Cmd_Ix);
							LX200_Speed_Cmd = SetMotionRateSlew;
							break;
						default:
							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1, Cmd_Ix);
					}
					break;
				case 'S':
					IncrIx++;
					switch( LX200Queue[Ix1])
					{
						case 'r':
							if( LX200_LongFormat)
								IncrIx += 10;
							else
								IncrIx += 9;
							InsertLX200CmdIntoArray( SetRa, Cmd_Ix);
							LX200_Read_Ra( Ix);
							break;
						case 'd':
							if( LX200_LongFormat)
								IncrIx += 11;
							else
								IncrIx += 8;
							InsertLX200CmdIntoArray( SetDec, Cmd_Ix);
							LX200_Read_Dec( Ix);
							break;
						case 'S':
							IncrIx += 10;
							InsertLX200CmdIntoArray( SetSidT, Cmd_Ix);
							LX200_Read_SidT( Ix);
							break;
						case 'L':
							IncrIx += 10;
							InsertLX200CmdIntoArray( SetLocalT, Cmd_Ix);
							LX200_Read_LocalT( Ix);
							break;
						case 'C':
							IncrIx += 10;
							InsertLX200CmdIntoArray( SetDate, Cmd_Ix);
							LX200_Read_CurrentDate( Ix);
							break;
						default:
							InsertLX200CmdIntoArray( LX200_Unknown_Cmd1, Cmd_Ix);
					}
					break;
				case 'U':
					IncrIx++;
					InsertLX200CmdIntoArray( ToggleLongFormat, Cmd_Ix);
					LX200_LongFormat = !LX200_LongFormat;
					break;
				default:
					InsertLX200CmdIntoArray( LX200_Unknown_Cmd0, Cmd_Ix);
					sprintf( StrBuf, "%02d %c %02d %c", Cmd_Ix, LX200Queue[Cmd_Ix],
					Ix, LX200Queue[Ix]);
					VidMemXY.Y = DisplayXY[DisplayLX200].Y;
					VidMemXY.X = DisplayXY[DisplayLX200].X+29;
					TextAttr = DisplayText;
					WriteStrBufToScreen();
			}
		}
		Ix += IncrIx;
		Ix &= LX200QueueEnd;
	}
}

void ProcessLX200_Motor_Cmd( void)
{
	struct AZLong HoldSteps;
	static LX200_COMMAND_TYPE LX200_Hold_Motor_Cmd;
	int timer = 0;

	if( LX200_Motor_Cmd == StartSlew)
	{
		Response = MenuMoveEquat;
		GetNewMenuCatSubFromResponse();
		UpdateMenuCatSub();
		ProcessMenuSelection();
		LX200_Motor_Cmd = NoAck;
	}
	else
		if( LX200_Speed_Cmd == SetMotionRateCenter
		|| LX200_Speed_Cmd == SetMotionRateFind)
		{
			if( LX200_Motor_Cmd == MoveDirRateNorth
			|| LX200_Motor_Cmd == MoveDirRateSouth
			|| LX200_Motor_Cmd == MoveDirRateEast
			|| LX200_Motor_Cmd == MoveDirRateWest)
			{
				/* can move in one direction only at a time */
				switch( LX200_Motor_Cmd)
				{
					case MoveDirRateNorth:
						Steps.A = MsTick.A;
						Dir.A = CW;
						break;
					case MoveDirRateSouth:
						Steps.A = MsTick.A;
						Dir.A = CCW;
						break;
					case MoveDirRateEast:
						Steps.Z = MsTick.Z;
						Dir.Z = CCW;
						break;
					case MoveDirRateWest:
						Steps.Z = MsTick.Z;
						Dir.Z = CW;
				}

				/* keeps control until Ms mvmt ends; limited in time */
				HoldSteps = Steps;
				LX200_Hold_Motor_Cmd = LX200_Motor_Cmd;
				while( LX200_Hold_Motor_Cmd == LX200_Motor_Cmd
				&& timer++ < LX200MotionTimeoutSec * ClockTicksSec)
				{
					HPEventMoveMs();
					/* ReadLX200Input() calls ProcessLX200Cmds(): resetting of
					LX200_Motor_Cmd done in ProcessLX200Cmds() */
					ReadLX200Input();
					/* add undone steps to steps to do for next clock tick */
					Steps.A += HoldSteps.A;
					Steps.Z += HoldSteps.Z;
				}
				AlignMs();
				SetCurrentAltazToAccumMs();
				HPEventGetEquat();
			}
		}
		else
			if( LX200_Speed_Cmd == SetMotionRateGuide)
			{
				/* currently does not InitGuide() and write to guide file */
				switch( Buttons)
				{
					case UpKey:
						AccumGuide.A -= GuideRadTick;
						break;
					case DownKey:
						AccumGuide.A += GuideRadTick;
						break;
					case CWKey:
						AccumGuide.Z -= GuideRadTick;
						break;
					case CCWKey:
						AccumGuide.Z += GuideRadTick;
				}
				MoveToCurrentRaDec();
			}
			else
				if( LX200_Speed_Cmd == SetMotionRateSlew)
				{
					Steps.A = Steps.Z = 0;
					switch( Buttons)
					{
						case UpKey:
							Steps.A = LX200SlewHs;
							Dir.A = CW;
							break;
						case DownKey:
							Steps.A = LX200SlewHs;
							Dir.A = CCW;
							break;
						case CCWKey:
							Steps.Z = LX200SlewHs;
							Dir.Z = CCW;
							break;
						case CWKey:
							Steps.Z = LX200SlewHs;
							Dir.Z = CW;
					}
					KBEventMoveHs();
					PauseUntilNewSidTime();
					HPEventGetEquat();
				}
}

/* handpad area... */

void InitHPEvent( void)
{
	/* init Flags */
	TrackFlag = No;
	MoveToCurrentRaDecFlag = No;
	DriftEquatFlag = No;
	DriftAltazFlag = No;
	PECFlag = No;
	GuideFlag = No;
	GuideArrayFlag = No;
	GrandTourFlag = No;
	ScrollFlag = No;
	HandpadFlag = HandpadOff;
	ConsecutiveSlews = 0;
	BacklashDir.A = BacklashDir.Z = CW;
	CheckBacklashOscillation = Yes;
	if( AltBacklashArcmin > 0 || AzBacklashArcmin > 0)
		BacklashFlag = Yes;
	else
		BacklashFlag = No;

	/* init field rotation motor vars */
	FRStepSize = FRStepSizeArcsec / RadToArcsec;
	if( FRStepSize == 0)
		DoFR = No;
	else
	{
		DoFR = Yes;
		if( SectoredFRDrive)
			ResetFRMotorAngleThreshold = 2 * FRStepSize;
		else
			ResetFRMotorAngleThreshold = OneRev;
		FRDir = FRPulse = Off;
		if( Two.Init)
		{
			CalcFieldR();
			FRMotorAngle = FieldR;
		}
		else
			FRMotorAngle = 0;
	}

	FRDiagPulseHigh = FRDiagPulseLow = FRDiagReset = 0;

	/* set backlash microsteps to move */
	BacklashMs.A = AltBacklashArcmin / RadToArcmin / MsRad.A;
	BacklashMs.Z = AzBacklashArcmin / RadToArcmin / MsRad.Z;
	/* set exact amount of backlash movement: mvmt (rad) = steps*stepsize */
	Backlash.A = BacklashMs.A * MsRad.A;
	Backlash.Z = BacklashMs.Z * MsRad.Z;

	SetAccumMsToCurrentAltaz();
	HPEventGetEquat();
}

/* this function sets AccumMs.A and AccumMs.Z based on Current.Alt and
Current.Az */
void SetAccumMsToCurrentAltaz( void)
{
	struct AZInt Ix;

	/* use Hold to calculate Alt and Az for AccumAltMs and AccumAzMs:
	this preserves Current.Alt and Current.Az */
	HoldAZ.A = Current.Alt;
	HoldAZ.Z = Current.Az;

	if( RefractFlag)
	{
		CalcRefractSkyToScope( Current.Alt);
		HoldAZ.A -= Refract;
	}
	if( BacklashFlag)
	{
		if( BacklashDir.A == CCW)
			HoldAZ.A -= Backlash.A;
		if( BacklashDir.Z == CCW)
			HoldAZ.Z -= Backlash.Z;
	}
	if( PECFlag)
	{
		GetPECIx();

		PECToAdd.A = PECs[PECIx.A].A
		+ DecimalPECIx.A * (PECs[NextPECIx.A].A - PECs[PECIx.A].A);
		HoldAZ.A -= PECToAdd.A / RadToTenthsArcsec;

		PECToAdd.Z = PECs[PECIx.Z].Z +
		DecimalPECIx.Z * (PECs[NextPECIx.Z].Z - PECs[PECIx.Z].Z);
		HoldAZ.Z -= PECToAdd.Z / RadToTenthsArcsec;

		/* HoldAZ.A -= PECs[PECIx.A].A / RadToTenthsArcsec;
		HoldAZ.Z -= PECs[PECIx.Z].Z / RadToTenthsArcsec; */
		/* preserve PEC array indexes */
		Ix = PECIx;
	}
	if( DriftAltazFlag)
	{
		HoldAZ.A -= AccumDrift.A;
		HoldAZ.Z -= AccumDrift.Z;
	}
	if( GuideFlag)
	{
		HoldAZ.A -= AccumGuide.A;
		HoldAZ.Z -= AccumGuide.Z;
	}

	AccumMs.A = (long) (0.5 + HoldAZ.A/MsRad.A);
	/* set to nearest full step */
	AccumMs.A -= AccumMs.A%Ms;

	AccumMs.Z = (long) (0.5 + HoldAZ.Z/MsRad.Z);
	/* set to nearest full step */
	AccumMs.Z -= AccumMs.Z%Ms;

	/* reset PEC array offsets */
	if( PECFlag)
	{
		GetPECIx();

		PECIxOffset.A += (PECIx.A - Ix.A);
		while( PECIxOffset.A < 0)
			PECIxOffset.A += PECSize;
		while( PECIxOffset.A >= PECSize)
			PECIxOffset.A -= PECSize;

		PECIxOffset.Z += (PECIx.Z - Ix.Z);
		while( PECIxOffset.Z < 0)
			PECIxOffset.Z += PECSize;
		while( PECIxOffset.Z >= PECSize)
			PECIxOffset.Z -= PECSize;
	}
}

/* Alt, Az 'de-coupled' from AccumMs;
this function sets Current.Alt, Current.Az based on AccumAltMs, AccumAzMs */
void SetCurrentAltazToAccumMs( void)
{
	/* set to AccumMs */
	Current.Alt = AccumMs.A*MsRad.A;
	Current.Az = AccumMs.Z*MsRad.Z;
	if( RefractFlag)
	{
		CalcRefractScopeToSky( Current.Alt);
		Current.Alt += Refract;
	}
	if( BacklashFlag)
	{
		if( BacklashDir.A == CCW)
			Current.Alt += Backlash.A;
		if( BacklashDir.Z == CCW)
			Current.Az += Backlash.Z;
	}
	if( PECFlag)
	{
		GetPECIx();
		/* positive PEC indicates excess CW movement; if scope is moving
		clockwise, Current. must be increased by adding PEC so that target
		Current. - corrected Current. is a smaller value resulting in less
		clockwise motion */

		PECToAdd.A = PECs[PECIx.A].A
		+ DecimalPECIx.A * (PECs[NextPECIx.A].A - PECs[PECIx.A].A);
		Current.Alt += PECToAdd.A / RadToTenthsArcsec;

		PECToAdd.Z = PECs[PECIx.Z].Z +
		DecimalPECIx.Z * (PECs[NextPECIx.Z].Z - PECs[PECIx.Z].Z);
		Current.Az += PECToAdd.Z / RadToTenthsArcsec;

		/* gotoxy( 2, 2); printf( "%f %f", PECToAdd.A, PECToAdd.Z); */
		/* Current.Alt += PECs[PECIx.A].A / RadToTenthsArcsec;
		Current.Az += PECs[PECIx.Z].Z / RadToTenthsArcsec; */
	}
	if( DriftAltazFlag)
	{
		AccumDrift.A += DriftTick.Alt;
		Current.Alt += AccumDrift.A;
		AccumDrift.Z += DriftTick.Az;
		Current.Az += AccumDrift.Z;
	}
	if( GuideFlag)
	{
		Current.Alt += AccumGuide.A;
		Current.Az += AccumGuide.Z;
		if( GuideArrayFlag == WritingToGuideArray)
			WriteToGuideArray();
	}
	ValidAz( &Current);
}

/* called by KBEventMoveHs() */
void HPEventMoveHs( void)
{
	CheckBacklashOscillation = No;
	MoveBacklash();
	CheckBacklashOscillation = Yes;
	MoveHs();
	SetCurrentAltazToAccumMs();
}

void HPEventMoveMs( void)
{
	MoveBacklash();
	MoveMs();
	SetCurrentAltazToAccumMs();
}

/* moves in (altaz) Ms until handpad buttons change */
void AltazMoveMs( void)
{
	struct AZLong HoldSteps = Steps;

	InitHandPad = HandPad;
	HandPadOKFlag = Yes;
	while( HandPadOKFlag)
	{
		HPEventMoveMs();
		/* add undone steps to steps to do for next clock tick */
		Steps.A += HoldSteps.A;
		Steps.Z += HoldSteps.Z;
		SetHandPadOKFlag();
	}
	AlignMs();
	SetCurrentAltazToAccumMs();
	HPEventGetEquat();
}

/* moves to takeup backlash if necessary; returns true if mvmt occured */
Flag MoveBacklash( void)
{
	struct AZLong SaveSteps, TotalSteps;
	static struct AZFlag LastDir[LastDirSize];
	int Ix;
	static int HoldIx = 0;
	Flag CancelBacklash = No;

	/* if backlash 'on', motor(s) can oscillate to and fro when microstepping
	tracking and steps = 0 or 1 because Dir can flip/flop;
	ignore oscillation check if handpad initiated move or halfstep slew:
	CheckBacklashOscillation turned off by HPEventMoveHs() just before call to
	MoveBacklash() and turned on afterwards;
	MoveToCurrentRaDecFlag turned on while in MoveToCurrentRaDec() */
	if( CheckBacklashOscillation && MoveToCurrentRaDecFlag)
		/* prevent backlash action if to and fro motor oscillations */
		for( Ix = 0; Ix < LastDirSize; Ix++)
			if( LastDir[Ix].A != Dir.A || LastDir[Ix].Z != Dir.Z)
			{
				CancelBacklash = Yes;
				break;
			}
	if( ++HoldIx == LastDirSize)
		HoldIx = 0;
	LastDir[HoldIx] = Dir;

	if( BacklashFlag && !CancelBacklash)
	{
		/* preserve original steps to move */
		SaveSteps = Steps;
		Steps.A = Steps.Z = 0;
		/* may need to disallow backlash if step = 1 because Dir can slowly
		flip/flop every couple of seconds causing slow oscillation, however,
		when large step size, tracking steps to move often at 0 or 1 */
		if( SaveSteps.A > 0)
		{
			if( Dir.A == CW && BacklashDir.A == CCW)
			{
				BacklashDir.A = CW;
				Steps.A = BacklashMs.A;
			}
			if( Dir.A == CCW && BacklashDir.A == CW)
			{
				BacklashDir.A = CCW;
				Steps.A = BacklashMs.A;
			}
		}
		if( SaveSteps.Z > 0)
		{
			if( Dir.Z == CCW && BacklashDir.Z == CW)
			{
				BacklashDir.Z = CCW;
				Steps.Z = BacklashMs.Z;
			}
			if( Dir.Z == CW && BacklashDir.Z == CCW)
			{
				BacklashDir.Z = CW;
				Steps.Z = BacklashMs.Z;
			}
		}
		if( Steps.A || Steps.Z)
		{
			/* set MsTick.A, MsTick.Z */
			InitMsTickVars( BacklashMsArcsecSec);
			/* Steps used by MoveMs(), so go with TotalSteps */
			TotalSteps = Steps;
			/* if PWMRepsTick set above actual # of PWMRepsTick, MoveMs() will not
			complete last microstep, so stop loop when steps are 1 or less */
			while( TotalSteps.A > 1 || TotalSteps.Z > 1)
			{
				/* set steps to do */
				Steps = TotalSteps;
				/* adjust Steps to move at backlash microstepping speed */
				if( Steps.A > MsTick.A)
					Steps.A = MsTick.A;
				if( Steps.Z > MsTick.Z)
					Steps.Z = MsTick.Z;
				/* subtract steps to do, anticipating MoveMs()'s decrement of Steps
				to 0 */
				TotalSteps.A -= Steps.A;
				TotalSteps.Z -= Steps.Z;
				/* not HPEventMoveMs() 'cause HPEventMoveMs() calls MoveBacklash()
				causing infinite loop */
				MoveMs();
				/* add back in any steps not done by MoveMs() */
				TotalSteps.A += Steps.A;
				TotalSteps.Z += Steps.Z;
			}
			/* recover original Steps to move */
			Steps = SaveSteps;
			/* restore microstep speed */
			InitMsTickVars( MsArcsecSec);
			return True;
		}
		else
		{
			/* restore original steps to move */
			Steps = SaveSteps;
			return False;
		}
	}
	else
		return False;
}

void FRMotorOff( void)
{
	outportb( FRPort, Off);
}

/* called every bios clock tick from MoveToCurrentRaDec();
max step rate is 18.2/2 or 9 times per second;
since field rotation motor tracks slowly, all that is needed is a simple
pulse and direction going to a single stepper controller chip */
void MoveFR( void)
{
	double FRAngleToMove;

	/* if pulse bit high, turn it off */
	if( FRPulse)
	{
		FRPulse = Off;
		FRDiagPulseLow++;
		outportb( FRPort, FRDir);
	}
	else
	{
		FRAngleToMove = FieldR - FRMotorAngle;

		/* from azimuth algorithm in SetDirDistanceStepsThenMove() */
		/* force it positive */
		if( FRAngleToMove < 0)
			FRAngleToMove += OneRev;
		/* bring it within -M_PI to +M_PI */
		if( FRAngleToMove > M_PI)
			FRAngleToMove -= OneRev;

		/* if move too big, just reset current motor position: prevents damage
		to	limited motion field rotation systems */
		if( FRAngleToMove > ResetFRMotorAngleThreshold ||
		FRAngleToMove < -ResetFRMotorAngleThreshold)
		{
			FRMotorAngle = FieldR;
			FRDiagReset++;
		}
		else
		{
			/* determine direction */
			if( FRAngleToMove < 0)
			{
				FRAngleToMove = -FRAngleToMove;
				FRDir = Off;
			}
			else
				FRDir = FRDirBit;

			/* see if step needed */
			if( FRAngleToMove > FRStepSize)
			{
				if( FRDir == FRDirBit)
					FRMotorAngle += FRStepSize;
				else
					FRMotorAngle -= FRStepSize;
				FRPulse = FRPulseBit;
				FRDiagPulseHigh++;

				/* pulse the field rotation motor step bit */
				outportb( FRPort, FRDir + FRPulse);
			}
		}
	}
}

/* for siderostat or uranostat or equat mounts: normally the az would be
flipped 180 deg when moving to other side of zenith, however, certain mounts
cannot this flip because the polar axis would rotate to unacceptable positions,
hence the need for this check */
void CheckSiderostatAltaz( void)
{
	if( Siderostat)
		if( Current.Az < AzLowLimit || Current.Az > AzHighLimit)
		{
			Current.Alt = M_PI - Current.Alt;
			Current.Az += M_PI;
			ValidAz( &Current);
		}
}

/* scope is brought to position calculated at start of clock tick by
microstepping until next clock tick (scope is always 1 clock tick behind during
tracking or microstepping) if possible, or by halfstepping if move too large;
if slew does not bring scope close enough to initiate microstepping, then next
pass through function will also slew, eventually moving scope close enough to
desired position to track by microstepping */
void MoveToCurrentRaDec( void)
{
	MoveToCurrentRaDecFlag = Yes;
	if( Two.Init)
		if( TrackFlag)
		{
			if( DoFR)
				MoveFR();
			HoldAZ.A = Current.Alt;
			HoldAZ.Z = Current.Az;
			GetAltaz();
			CheckSiderostatAltaz();

			if( AltLimitFlag && Current.Alt < AltLowLimit)
			{
				Current.Alt = HoldAZ.A;
				Current.Az = HoldAZ.Z;
				TrackFlag = No;
				WriteTrackStatus();
				PressKeyToContMsg( "Tried to move below AltLowLimt");
			}
			else
				if( AltLimitFlag && Current.Alt > AltHighLimit)
				{
					Current.Alt = HoldAZ.A;
					Current.Az = HoldAZ.Z;
					TrackFlag = No;
					WriteTrackStatus();
					PressKeyToContMsg( "Tried to move above AltHighLimt");
				}
				else
					if( AzLimitFlag && Current.Az < AzLowLimit)
					{
						Current.Alt = HoldAZ.A;
						Current.Az = HoldAZ.Z;
						TrackFlag = No;
						WriteTrackStatus();
						PressKeyToContMsg( "Tried to move below AzLowLimt");
					}
					else
						if( AzLimitFlag && Current.Az > AzHighLimit)
						{
							Current.Alt = HoldAZ.A;
							Current.Az = HoldAZ.Z;
							TrackFlag = No;
							WriteTrackStatus();
							PressKeyToContMsg( "Tried to move above AzHighLimt");
						}
						else
						{
							/* Delta = new - old */
							Delta.A = Current.Alt - HoldAZ.A;
							Delta.Z = Current.Az - HoldAZ.Z;
							Current.Alt = HoldAZ.A;
							Current.Az = HoldAZ.Z;
							/* if ok, then calc the move and make it so */
							if( !SetDirDistanceStepsThenMove())
							{
								TrackFlag = No;
								WriteTrackStatus();
								PauseUntilNewSidTime();
								HPEventGetEquat();
							}
						}
		}
		else
		{
			PauseUntilNewSidTime();
			HPEventGetEquat();
		}
	else
		PauseUntilNewSidTime();

	MoveToCurrentRaDecFlag = No;
}

Flag SetDirDistanceStepsThenMove( void)
{
	/* altitude... */
	if( Delta.A < 0)
	{
		Delta.A = -Delta.A;
		Dir.A = CCW;
	}
	else
		Dir.A = CW;

	/* azimuth (increases CW)...
	4 possibilities of calculating az steps to move:
		start		end		delta		+ 360 if nec.	 > 180?	result
	1. 350,     200,     -150,    210,           yes,     -150
	2. 200,     350,     150,                    no,      150
	3. 350,     100,     -250,    110,           no,      110
	4. 100,     350,     250,                    yes,     -110 */
	if( Delta.Z < 0)
		Delta.Z += OneRev;
	/* if > 1/2 rev, go other way */
	if( Delta.Z > M_PI)
		/* get distance to go (- or +) */
		Delta.Z -= OneRev;
	if( Delta.Z < 0)
	{
		Delta.Z = -Delta.Z;
		Dir.Z = CCW;
	}
	else
		Dir.Z = CW;

	if( Delta.A <= MaxMsDistanceRadTick.A && Delta.Z <= MaxMsDistanceRadTick.Z)
	{
		Steps.A = (long) (0.5 + Delta.A/MsRad.A);
		Steps.Z = (long) (0.5 + Delta.Z/MsRad.Z);
		ConsecutiveSlews = 0;
		HPEventMoveMs();
		return True;
	}
	/* if distance too large for microstep, do halfstepping slew */
	else
	{
		Steps.A = (long) (0.5 + (Delta.A/HsRad.A));
		Steps.Z = (long) (0.5 + (Delta.Z/HsRad.Z));
		/* if too many steps, confirm move */
		if( ConfirmHsMove())
		{
			ConsecutiveSlews++;
			KBEventMoveHs();
			return True;
		}
		else
			return False;
	}
}

void HPEventGetEquat( void)
{
	if( Two.Init)
		GetEquat();
}

void UpdateDriftCalculatedFromGuide( void)
{
	double TimeMin = (EndDriftT - StartDriftT) * RadToMin;

	Drift.Alt += AccumGuide.A/TimeMin;
	Drift.Az += AccumGuide.Z/TimeMin;

	CalcCommonDriftVars();
}

/* record equatorial position when handpad mode switch activated */
void RecordEquat( void)
{
	Output = fopen( RecordEquatFile, "a");
	if( Output == NULL)
		BadExit( strcat( "Could not open ", RecordEquatFile));

	GetHMSH( RadToHundSec*Current.Ra + 0.5, &Current.RaHMSH);
	GetDMS( RadToArcsec*Current.Dec + 0.5, &Current.DecDMS);
	if( Current.DecDMS.Sign == Minus)
	{
		Current.DecDMS.Deg = -Current.DecDMS.Deg;
		Current.DecDMS.Min = -Current.DecDMS.Min;
		Current.DecDMS.Sec = -Current.DecDMS.Sec;
	}
	fprintf( Output, "%3d %3d %3d   %3d %3d %3d   handpad_record\n",
	Current.RaHMSH.Hr, Current.RaHMSH.Min, Current.RaHMSH.Sec,
	Current.DecDMS.Deg, Current.DecDMS.Min, Current.DecDMS.Sec );

	fclose( Output);
}

Flag IACA_Event( void)
{
	if( NewIACA())
	{
		GetIACA( &In.Ra, &In.Dec);
		GetHMSH( In.Ra*RadToHundSec+.5, &In.RaHMSH);
		GetDMS( In.Dec*RadToArcsec+.5, &In.DecDMS);
		DisplayIn( "from IACA", NameBlanks);
		return True;
	}
	else
		return False;
}

int FindClosestInit( void)
{
	double Init1Distance, Init2Distance, Init3Distance;

	Init1Distance = CalcEquatAngularSep( Current, One);
	Init2Distance = CalcEquatAngularSep( Current, Two);
	Init3Distance = CalcEquatAngularSep( Current, Three);
	if( Init1Distance < Init2Distance && Init1Distance < Init3Distance)
		return 1;
	else
		if( Init2Distance < Init3Distance)
			return 2;
		else
			return 3;
}

void SetEndDriftT( void)
{
	EndDriftT = Current.SidT;
	/* if cross 24 hr == 0hr boundary */
	while( EndDriftT < StartDriftT)
		EndDriftT += OneRev;
}

void ZeroDrift( void)
{
	Drift.Alt = Drift.Az = Drift.Ra = Drift.Dec = 0;
	CalcCommonDriftVars();
}

void AddDragToDrift( void)
{
	Drift.Alt += Drag.Alt;
	Drift.Az += Drift.Az;
	Drift.Ra += Drift.Ra;
	Drift.Dec += Drift.Dec;
	CalcCommonDriftVars();
}

void RemoveDragFromDrift( void)
{
	Drift.Alt -= Drag.Alt;
	Drift.Az -= Drift.Az;
	Drift.Ra -= Drift.Ra;
	Drift.Dec -= Drift.Dec;
	CalcCommonDriftVars();
}

void CalcCommonDriftVars( void)
{
	/* drift per bios clock tick */
	DriftTick.Alt = Drift.Alt/ClockTicksMin;
	DriftTick.Az = Drift.Az/ClockTicksMin;
	DriftTick.Ra = Drift.Ra/ClockTicksHr;
	DriftTick.Dec = Drift.Dec/ClockTicksHr;

	AccumDrift.A = AccumDrift.Z = 0;

	if( Drift.Alt != 0 || Drift.Az != 0)
		DriftAltazFlag = Yes;
	else
		DriftAltazFlag = No;
	if( Drift.Ra != 0 || Drift.Dec != 0)
		DriftEquatFlag = Yes;
	else
		DriftEquatFlag = No;

	GetHMSH( RadToHundSec*Drift.Ra + .5, &Drift.RaHMSH);
	GetDMS( RadToArcsec*Drift.Dec + .5, &Drift.DecDMS);
}

void CheckMiscEvents( void)
{
	if( IACA_Flag && IACA_Event())
		;
	else
	{
		if( LX200ComPort)
		{
			ReadLX200Input();
			ProcessLX200_Motor_Cmd();
		}
		MoveToCurrentRaDec();
	}

	/* handle consecutive slews when scope should be microstepping tracking;
	by resetting current equatorial to current altazimuth, tracking can start
	fresh from current position instead of repeatedly trying to slew to previous
	current equatorial coordinates */
	if( ConsecutiveSlews >= MaxConsecutiveSlews)
	{
		ConsecutiveSlews = 0;
		PauseUntilNewSidTime();
		HPEventGetEquat();
		In = Current;
		DisplayIn( "consecutive slews", NameBlanks);
	}
}

void ProcessHPEvents( void)
{
	static int InitTimer = 0;
	static int RecordEquatTimer = 0;
	/* 5 sec delay */
	const int StartTimer = 91;
	struct AZLong StepsToMove;
	static Flag HoldTrackFlag;


	/* to prevent too rapid init'ing */
	if( InitTimer)
		InitTimer--;
	/* to prevent too rapid recording of equat position */
	if( RecordEquatTimer)
		RecordEquatTimer--;

	/* if PEC on and auto sync of PEC on, then check alt PEC sync signal */
	if( PECFlag && AutoAltPECSyncOnFlag)
	{
		/* Look at parallel port pin 15 (bit 8) and check for a high to low
		transition.	This pin is inverted by the parallel port controller chip. */
		READ_AUTO_ALT_PEC_SYNC;
		if( AutoAltPECSyncLowHighFlag)
			AutoAltPECSyncSignal = !AutoAltPECSyncSignal;
		if( AutoAltPECSyncSignal && !LastAutoAltPECSyncSignal
		&& (!AutoAltPECSyncDirFlag || AutoAltPECSyncDirFlag == CCW && Dir.A == CCW
		|| AutoAltPECSyncDirFlag == CW && Dir.A == CW))
		{
			/* synch sensor has just turned on with Alt motor moving in CW
			direction */
			SynchAltPEC();
			WritePECStatus();
		}
		LastAutoAltPECSyncSignal = AutoAltPECSyncSignal;
	}

	/* if PEC on and auto sync of PEC on, then check az PEC sync signal */
	if( PECFlag && AutoAzPECSyncOnFlag)
	{
		/* Look at parallel port pin 15 (bit 8) and check for a high to low
		transition.	This pin is inverted by the parallel port controller chip. */
		READ_AUTO_AZ_PEC_SYNC;
		if( AutoAzPECSyncLowHighFlag)
			AutoAzPECSyncSignal = !AutoAzPECSyncSignal;
		if( AutoAzPECSyncSignal && !LastAutoAzPECSyncSignal
		&& (!AutoAzPECSyncDirFlag || AutoAzPECSyncDirFlag == CCW && Dir.Z == CCW
		|| AutoAzPECSyncDirFlag == CW && Dir.Z == CW))
		{
			/* synch sensor has just turned on with Az motor moving in CW
			direction */
			SynchAzPEC();
			WritePECStatus();
		}
		LastAutoAzPECSyncSignal = AutoAzPECSyncSignal;
	}

	/* check for handpad event... */
	ReadHandPad_f_ptr();
	/* subtract MsKey from Buttons if it is on */
	MsSpeed = HandPad&MsKey;
	Buttons = HandPad - MsSpeed;

	/* if direction button pressed, then either:
			1. process guiding correction followed by move to current equat
			2. or process field rotation motor
			3. or move the scope altazimuth either by microstep or halfstep;
		else if no direction button pressed, then process mode switch based on
		handpad mode: many handpad modes conclude by calling CheckMiscEvents() */

	if( Buttons == UpKey || Buttons == DownKey || Buttons == CCWKey ||
	Buttons == CWKey)
	{
		/* if guide on, then use guiding speed */
		if( GuideFlag)
		{
			switch( Buttons)
			{
				case UpKey:
					AccumGuide.A -= GuideRadTick;
					break;
				case DownKey:
					AccumGuide.A += GuideRadTick;
					break;
				case CWKey:
					AccumGuide.Z -= GuideRadTick;
					break;
				case CCWKey:
					AccumGuide.Z += GuideRadTick;
			}
			MoveToCurrentRaDec();
		}
		else
			/* field rotation motor move */
			if( DoFR && HandpadFRMotorControlOnFlag
			&& (Buttons == CCWKey || Buttons == CWKey))
			{
				HoldTrackFlag = TrackFlag;
				/* turn off tracking */
				if( TrackFlag)
				{
					TrackFlag = No;
					WriteTrackStatus();
					/* if init'd, save current to input so that upon resumption of
					tracking, scope can slew to last tracking position */
					if( Two.Init)
					{
						In = Current;
						DisplayIn( "last Track", NameBlanks);
					}
				}
				/* set field rotation motor direction */
				if( Buttons == CWKey)
					/* increasing field rotation angle */
					FRDir = FRDirBit;
				else
					FRDir = Off;

				/* display handpad buttons */
				if( Buttons == CWKey)
					sprintf( StrBuf, "FR-CW  ");
				else
					sprintf( StrBuf, "FR-CCW ");
				VidMemXY = DisplayXY[DisplayButtons];
				TextAttr = DisplayText;
				WriteStrBufToScreen();

				/* setup handpad vars */
				InitHandPad = HandPad;
				HandPadOKFlag = Yes;
				while( HandPadOKFlag && !KeyStroke)
				{
					delay( FRStepSpeedMilliSec/2);
					/* raise field rotation motor pulse */
					outportb( FRPort, FRDir + FRPulseBit);
					delay( FRStepSpeedMilliSec/2);
					/* lower field rotation motor pulse */
					outportb( FRPort, FRDir);
					SetHandPadOKFlag();
				}
				if( KeyStroke)
					getch();
				FRMotorAngle = FieldR;

				/* blank display of handpad buttons */
				sprintf( StrBuf, "       ");
				VidMemXY = DisplayXY[DisplayButtons];
				TextAttr = DisplayText;
				WriteStrBufToScreen();

				if( HoldTrackFlag)
				{
					TrackFlag = Yes;
					WriteTrackStatus();
				}
			}
			/* else either microstep or halfstep move */
			else
			{
				/* align motors to fullstep in case halfstepping chosen */
				AlignMs();
				SetCurrentAltazToAccumMs();
				/* if microstep switch selection on */
				if( MsSpeed)
				{
					StepsToMove.A = MsTick.A;
					StepsToMove.Z = MsTick.Z;
				}
				/* else halfstep */
				else
					StepsToMove.A = StepsToMove.Z = MaxHs;
					Steps.A = Steps.Z = 0;
				switch( Buttons)
				{
					case UpKey:
						Steps.A = StepsToMove.A;
						Dir.A = CW;
						break;
					case DownKey:
						Steps.A = StepsToMove.A;
						Dir.A = CCW;
						break;
					case CCWKey:
						Steps.Z = StepsToMove.Z;
						Dir.Z = CCW;
						break;
					case CWKey:
						Steps.Z = StepsToMove.Z;
						Dir.Z = CW;
				}
				if( MsSpeed)
					/* keeps control until Ms mvmt ends */
					AltazMoveMs();
				else
				{
					KBEventMoveHs();
					PauseUntilNewSidTime();
					HPEventGetEquat();
				}
			}
	}
	/* else no valid direction buttons so look at mode switch */
	else
		switch( HandpadFlag)
		{
			case HandpadOff:
				CheckMiscEvents();
				break;
			case InitAutoOn:
				if( (Buttons==LeftKey || Buttons==RightKey) && !InitTimer)
				{
					InitTimer = StartTimer;
					/* use Current altaz and In equat coordinates to init with */
					Current.Ra = In.Ra;
					Current.Dec = In.Dec;
					if( Three.Init)
						/* replace previous closest init with new init */
						KBEventInitMatrix( FindClosestInit());
					else
						if( Two.Init)
							KBEventInitMatrix( 3);
						else
							if( One.Init)
								KBEventInitMatrix( 2);
							else
								KBEventInitMatrix( 1);
				}
				else
					CheckMiscEvents();
				break;
			case Init1On:
				if( (Buttons==LeftKey || Buttons==RightKey) && !InitTimer)
				{
					InitTimer = StartTimer;
					/* use Current altaz and In equat coordinates to init with */
					Current.Ra = In.Ra;
					Current.Dec = In.Dec;
					KBEventInitMatrix( 1);
				}
				else
					CheckMiscEvents();
				break;
			case Init2On:
				if( (Buttons==LeftKey || Buttons==RightKey) && !InitTimer)
				{
					if( One.Init)
					{
						InitTimer = StartTimer;
						/* use Current altaz and In equat coordinates to init with */
						Current.Ra = In.Ra;
						Current.Dec = In.Dec;
						KBEventInitMatrix( 2);
					}
					else
						PressKeyToContMsg( "Must init 1 first");
				}
				else
					CheckMiscEvents();
				break;
			case Init3On:
				if( (Buttons==LeftKey || Buttons==RightKey) && !InitTimer)
				{
					if( Two.Init)
					{
						InitTimer = StartTimer;
						/* use Current altaz and In equat coordinates to init with */
						Current.Ra = In.Ra;
						Current.Dec = In.Dec;
						KBEventInitMatrix( 3);
					}
					else
						PressKeyToContMsg( "Must init 2 first");
				}
				else
					CheckMiscEvents();
				break;
			case GuideOn:
				if( !GuideFlag && Buttons==LeftKey && Two.Init)
				{
					StartDriftT = Current.SidT;
					InitGuide();
					WriteHandpadStatus();
				}
				else
					if( GuideFlag && Buttons==RightKey)
					{
						SetEndDriftT();
						UpdateDriftCalculatedFromGuide();
						GuideFlag = Off;
						AccumGuide.A = AccumGuide.Z = 0;
						DisplayDrift();
						WriteHandpadStatus();
					}
					else
						CheckMiscEvents();
				break;
			case GuideStayOn:
				if( !GuideFlag && Buttons==LeftKey && Two.Init)
				{
					StartDriftT = Current.SidT;
					InitGuide();
					WriteHandpadStatus();
				}
				else
					if( GuideFlag && Buttons==RightKey)
					{
						AlignMs();
						/* add accum guide, drift to current position */
						SetCurrentAltazToAccumMs();
						HPEventGetEquat();
						SetEncoderAZandEncoderOffset();
						SetEndDriftT();
						UpdateDriftCalculatedFromGuide();
						GuideFlag = Off;
						AccumGuide.A = AccumGuide.Z = 0;
						/* AccumMs = new altaz that includes accum guide=0, drift */
						SetAccumMsToCurrentAltaz();
						DisplayDrift();
						WriteHandpadStatus();
					}
					else
						CheckMiscEvents();
				break;
			case GuideStaySaveOn:
				/* guide with save on can be ended by handpad or by filling
				up the guide array in WriteToGuideArray(); WriteToGuideArray() only
				called when GuideArrayFlag == WritingToGuideArray;	*/
				if( GuideArrayFlag == ReadyToSaveGuideArray)
				{
					AlignMs();
					/* add accum guide, drift to current position */
					SetCurrentAltazToAccumMs();
					HPEventGetEquat();
					SetEncoderAZandEncoderOffset();
					SetEndDriftT();
					UpdateDriftCalculatedFromGuide();
					GuideFlag = Off;
					AccumGuide.A = AccumGuide.Z = 0;
					/* AccumMs = new altaz that includes accum guide=0, drift */
					SetAccumMsToCurrentAltaz();
					DisplayDrift();
					WriteHandpadStatus();
					SaveGuideAlt();
					SaveGuideAz();
					GuideArrayFlag = No;
				}
				else
					if( !GuideFlag && Buttons==LeftKey && Two.Init && PECFlag)
					{
						StartDriftT = Current.SidT;
						InitGuide();
						GuideArrayFlag = WritingToGuideArray;
						WriteHandpadStatus();
					}
					else
						if( GuideFlag && Buttons==RightKey)
							GuideArrayFlag = ReadyToSaveGuideArray;
						else
							CheckMiscEvents();
				break;
			case GuideDragOn:
				/* adds in drag drift from config.dat, then removes it */
				/* if drift to be updated, then follow this algorithm (remember to
				work only with altaz drift as driftdrag does all 4 axes):
				if current drift = 10, and dragdrift = 20, then drift will be 30,
				at end of guide cycle, drift calculated from guide will = -20,
				take the difference between dragdrift and calculated drift (here
				20-20=0) and add it to the drift of 30, then remove dragdrift of 20
				for final current drift of 10; if drift should really be 5, then
				drift calculated from guide would be -25, amount to subtract would
				be -5, and after subtracting dragdrift of 20, result would be 5 */
				if( !GuideFlag && Buttons==LeftKey && Two.Init)
				{
					InitGuide();
					AddDragToDrift();
					DisplayDrift();
					WriteHandpadStatus();
				}
				else
					if( GuideFlag && Buttons==RightKey)
					{
						AlignMs();
						/* add accum guide, drift to current position */
						SetCurrentAltazToAccumMs();
						HPEventGetEquat();
						SetEncoderAZandEncoderOffset();
						GuideFlag = Off;
						AccumGuide.A = AccumGuide.Z = 0;
						/* AccumMs = new altaz that includes accum guide=0, drift */
						SetAccumMsToCurrentAltaz();
						RemoveDragFromDrift();
						DisplayDrift();
						WriteHandpadStatus();
					}
					else
						CheckMiscEvents();
				break;
			case GrandTour:
				/* sets flag, then continues tracking, flag set to no in
				ProcessGrandTour() */
				if( Two.Init && (Buttons==LeftKey || Buttons==RightKey))
					GrandTourFlag = Yes;
				CheckMiscEvents();
				break;
			case ScrollTour:
				/* sets flag, then continues tracking */
				if( Two.Init && (Buttons==LeftKey || Buttons==RightKey))
					ScrollFlag = Yes;
				CheckMiscEvents();
				break;
			case RecordOn:
				if( Two.Init && (Buttons==LeftKey || Buttons==RightKey)
				&& !RecordEquatTimer)
				{
					RecordEquatTimer = StartTimer;
					RecordEquat();
				}
				CheckMiscEvents();
				break;
			case ToggleTrack:
				if( Buttons==LeftKey)
				{
					TrackFlag = On;
					WriteTrackStatus();
				}
				else
					if( Buttons==RightKey)
					{
						TrackFlag = Off;
						WriteTrackStatus();
					}
				CheckMiscEvents();
				break;
			case HandpadFR:
				if( Buttons==LeftKey)
					HandpadFRMotorControlOnFlag = On;
				else
					if( Buttons==RightKey)
						HandpadFRMotorControlOnFlag = Off;
				CheckMiscEvents();
				break;
			default:
				CheckMiscEvents();
		}
}

void Track( void)
{
	int IxA;
	double MsPerSec;
	double MsAccel = 0;
	double AccumMsAccel = 0;
	Flag ShowMicrostepFlag;
	Flag MakeSoundFlag;
	Flag AdjustPWMFlag;
	Flag TrackingFlag;
	int ShowMsY;
	int MaxMsPerSec = PWMRepsTick * MsPerHs * ClockTicksSec;

	Steps.A = Steps.Z = 0;
	HoldMsTick.A = HoldMsTick.Z = 0;

	_wscroll = No;
	clrscr();
	TextAttr = WHITE + (BLACK << 4);
	VidMemXY.Y = 0;
	VidMemXY.X = 0;
	sprintf( StrBuf, "Tracking function and test of single (altitude) motor");
	WriteStrBufToScreen();

	VidMemXY.Y = 2;
	VidMemXY.X = 0;
	sprintf( StrBuf, "enter microsteps per second (max=%d) ", MaxMsPerSec);
	WriteStrBufToScreen();
	gotoxy( VidMemXY.X+1, VidMemXY.Y+1);
	GetDouble( &MsPerSec);
	if( MsPerSec < 0)
	{
		MsPerSec = -MsPerSec;
		Dir.A = Dir.Z = CCW;
	}
	MsTick.A = MsPerSec / ClockTicksSec;

	VidMemXY.Y = 3;
	VidMemXY.X = 0;
	sprintf( StrBuf, "show microstep # (y/n)? ");
	WriteStrBufToScreen();
	gotoxy( VidMemXY.X+1, VidMemXY.Y+1);
	Response = getch();
	sprintf( StrBuf, "%c", Response);
	WriteStrBufToScreen();
	if( Response == 'Y' || Response == 'y')
		ShowMicrostepFlag = Yes;
	else
		ShowMicrostepFlag = No;

	VidMemXY.Y = 4;
	VidMemXY.X = 0;
	sprintf( StrBuf, "make sound when microstep index = zero (y/n)? ");
	WriteStrBufToScreen();
	gotoxy( VidMemXY.X+1, VidMemXY.Y+1);
	Response = getch();
	sprintf( StrBuf, "%c", Response);
	WriteStrBufToScreen();
	if( Response == 'Y' || Response == 'y')
		MakeSoundFlag = Yes;
	else
		MakeSoundFlag = No;

	VidMemXY.Y = 5;
	VidMemXY.X = 0;
	sprintf( StrBuf, "display and adjust PWMs (y/n)? ");
	WriteStrBufToScreen();
	gotoxy( VidMemXY.X+1, VidMemXY.Y+1);
	Response = getch();
	sprintf( StrBuf, "%c", Response);
	WriteStrBufToScreen();
	if( Response == 'Y' || Response == 'y')
		AdjustPWMFlag = Yes;
	else
		AdjustPWMFlag = No;

	VidMemXY.Y = 6;
	if( AdjustPWMFlag)
	{
		for( Ix = 0; Ix < Ms; Ix++)
		{
			sprintf( StrBuf, "PWM[%1d]:%3d", Ix, PWM[Ix]);
			VidMemXY.X = 0;
			WriteStrBufToScreen();
			VidMemXY.Y++;
		}
		sprintf( StrBuf, "MsPause:%3d", MsPause);
		VidMemXY.X = 0;
		WriteStrBufToScreen();
		VidMemXY.Y++;
		sprintf( StrBuf, "MsDelayX:%3d", MsDelayX);
		VidMemXY.X = 0;
		WriteStrBufToScreen();
		VidMemXY.Y++;

		sprintf( StrBuf, "PWM[0-9]: use abcdefghij keys to lower, CAPS to raise");
		VidMemXY.Y++;
		VidMemXY.X = 0;
		WriteStrBufToScreen();
		sprintf( StrBuf, "MsPause: use p key to lower, CAPS to raise");
		VidMemXY.Y++;
		VidMemXY.X = 0;
		WriteStrBufToScreen();
		sprintf( StrBuf, "MsDelayX: use x key to lower, CAPS to raise");
		VidMemXY.Y++;
		VidMemXY.X = 0;
		WriteStrBufToScreen();
	}
	VidMemXY.Y++;
	VidMemXY.X = 0;
	sprintf( StrBuf, "press 'q' or 'Q' to stop tracking...");
	WriteStrBufToScreen();

	ShowMsY = VidMemXY.Y + 2;
	if( ShowMicrostepFlag)
	{
		VidMemXY.Y = ShowMsY;
		VidMemXY.X = 0;
		sprintf( StrBuf, "microstep # ");
		WriteStrBufToScreen();
	}
	/* to position cursor when function ends */
	gotoxy( 40, VidMemXY.Y + 1);

	TrackingFlag = Yes;
	while( TrackingFlag)
	{
		if( ShowMicrostepFlag)
		{
			VidMemXY.Y = ShowMsY;
			VidMemXY.X = 13;
			sprintf( StrBuf, "%1d PWM %4d ",(int) AccumMs.A%Ms, ActualPWMRepsTick);
			WriteStrBufToScreen();
		}
		if( MakeSoundFlag)
			sound( (unsigned) (200 + (AccumMs.A%Ms) * 200));

		if( KeyStroke)
		{
			Response = getch();
			switch( Response)
			{
				case 'q': case 'Q':
					TrackingFlag = No;
					break;
				case 'p':
					MsPause--;
					if(MsPause < 0)
						MsPause = 0;
					sprintf( StrBuf, "%3d", MsPause);
					VidMemXY.X = 8;
					VidMemXY.Y = 16;
					WriteStrBufToScreen();
					break;
				case 'P':
					MsPause++;
					sprintf( StrBuf, "%3d", MsPause);
					VidMemXY.X = 8;
					VidMemXY.Y = 16;
					WriteStrBufToScreen();
					break;
				case 'x':
					MsDelayX--;
					if(MsDelayX < 0)
						MsDelayX = 0;
					sprintf( StrBuf, "%3d", MsDelayX);
					VidMemXY.X = 9;
					VidMemXY.Y = 17;
					WriteStrBufToScreen();
					break;
				case 'X':
					MsDelayX++;
					sprintf( StrBuf, "%3d", MsDelayX);
					VidMemXY.X = 9;
					VidMemXY.Y = 17;
					WriteStrBufToScreen();
					break;
				case 'a': case 'b': case 'c': case 'd': case 'e': case 'f':
				case 'g': case 'h': case 'i': case 'j':
					Ix = Response - 'a';
					PWM[Ix]--;
					FreeMsArrays();
					CreateMsArrays();
					InitMsArrays();
					VidMemXY.Y = 6;
					for( IxA = 0; IxA < Ms; IxA++)
					{
						sprintf( StrBuf, "%3d", PWM[IxA]);
						VidMemXY.X = 7;
						WriteStrBufToScreen();
						VidMemXY.Y++;
					}
					break;
				case 'A': case 'B': case 'C': case 'D': case 'E': case 'F':
				case 'G': case 'H': case 'I': case 'J':
					Ix = Response - 'A';
					PWM[Ix]++;
					FreeMsArrays();
					CreateMsArrays();
					InitMsArrays();
					VidMemXY.Y = 6;
					for( IxA = 0; IxA < Ms; IxA++)
					{
						sprintf( StrBuf, "%3d",PWM[IxA]);
						VidMemXY.X = 7;
						WriteStrBufToScreen();
						VidMemXY.Y++;
					}
			}
		}
		/* add microsteps (double) to do for this clock tick */
		HoldMsTick.A += MsTick.A;
		/* acceleration: a way to smoothly increase # of microsteps per tick so as
		to accelerate through a range of speeds: not presently used and thus set
		to 0 */
		AccumMsAccel += MsAccel;
		HoldMsTick.A += AccumMsAccel;
		/* set (long) steps to move */
		Steps.A = Steps.Z = HoldMsTick.A;
		/* subtract (long) steps to move, preserving fractional steps to move
		in HoldMsTick */
		HoldMsTick.A -= Steps.A;
		/* BegSteps = (int) Steps.A; */
		MoveMs();
		/* gotoxy( X, Y);
		printf( "%d", BegSteps - Steps.A); */
		/* add steps not moved */
		HoldMsTick.A += Steps.A;
	}
	if( MakeSoundFlag)
		nosound();
	NewLine;
}

/* keyboard event... */

void InitKBEvent( void)
{
	double MaxHsRad;

	QuitFlag = No;
	MsParmsAllowedFlag = No;
   MsParmsTitlesWritten = No;
	LX200DisplayFlag = No;
	FirstScroll = NULL;
	LastScroll = NULL;
	CurrentScroll = NULL;
	ScrollLoaded = No;
	ScrollUnderway = No;

	strcpy( FullyQualifiedSlewFile,InterfacePath);
	strcat( FullyQualifiedSlewFile, SlewFile);
	strcpy( FullyQualifiedSlewOutFile,InterfacePath);
	strcat( FullyQualifiedSlewOutFile, SlewOutFile);

	OutGuideFilePtr = fopen( OutGuideFile, "w");
	if( OutGuideFilePtr == NULL)
		BadExit( strcat( "Could not open ", OutGuideFile));

	EncoderErrorThreshold = EncoderErrorThresholdDeg / RadToDeg;
	TrackEncoderErrorThreshold = TrackEncoderErrorThresholdDeg / RadToDeg;
	if( ResetEncoderBox)
		SetEncoderAZandEncoderOffset();
	else
	{
		LoadEncoderOffset();
		CalcEncoderAZ();
	}

	/* GuideDrag from config.dat */
	/* altaz drag is in radians per minute */
	Drag.Alt = GuideDragAltArcsecPerMin / RadToArcsec / ArcsecPerDeg;
	Drag.Az= GuideDragAzArcsecPerMin / RadToArcsec / ArcsecPerDeg;
	/* equat drag is in radians per hour */
	Drag.Ra = GuideDragRaArcsecPerMin * 60. / RadToArcsec;
	Drag.Dec = GuideDragDecArcsecPerMin * 60. / RadToArcsec;
	/* drag per bios clock tick */
	DragTick.Alt = Drag.Alt/ClockTicksMin;
	DragTick.Az = Drag.Az/ClockTicksMin;
	DragTick.Ra = Drag.Ra/ClockTicksHr;
	DragTick.Dec = Drag.Dec/ClockTicksHr;

	/* set halfsteps to move that triggers confirming msg */
	if( HsRad.A > HsRad.Z)
		MaxHsRad = HsRad.A;
	else
		MaxHsRad = HsRad.Z;
	MoveHsMsgSteps = (long) (MoveHsMsgDeg/RadToDeg/MaxHsRad);

	if( DisplayOpeningMsgs)
		PrelimMsg();

	/* set attributes */
	MenuText = MenuColor + (DefaultBackground << 4);
	SelectText = SelectColor + (SelectBackground << 4);
	CurrentText = CurrentColor + (DefaultBackground << 4);
	DisplayText = DisplayColor + (DefaultBackground << 4);
	DefaultText = DefaultColor + (DefaultBackground << 4);
	BorderText = BorderColor + (DefaultBackground << 4);
	TitleText = TitleColor + (DefaultBackground << 4);

	/* setup screen */
	_wscroll = No;
	_setcursortype( _NOCURSOR);
	clrscr();

	/* write main window */
	DrawBorder( MainFrame);

	/* write display titles */
	TextAttr = DefaultText;
	VidMemXY.X = MenuStartX;
	VidMemXY.Y = MenuCoordTitleY;
	sprintf( StrBuf, "%s", MainStr_9);
	WriteStrBufToScreen();
	VidMemXY.X = MenuStartX;
	VidMemXY.Y = MenuAltY;
	sprintf( StrBuf, "%s", MainStr_10);
	WriteStrBufToScreen();
	VidMemXY.X = MenuStartX;
	VidMemXY.Y = MenuAzY;
	sprintf( StrBuf, "%s", MainStr_11);
	WriteStrBufToScreen();
	VidMemXY.X = MenuStartX;
	VidMemXY.Y = MenuRaY;
	sprintf( StrBuf, "%s", MainStr_13);
	WriteStrBufToScreen();
	VidMemXY.X = MenuStartX;
	VidMemXY.Y = MenuDecY;
	sprintf( StrBuf, "%s", MainStr_14);
	WriteStrBufToScreen();
	VidMemXY.X = MenuStartX;
	VidMemXY.Y = MenuInitY;
	sprintf( StrBuf, "%s", MainStr_15);
	WriteStrBufToScreen();
	VidMemXY.X = MenuStartX;
	VidMemXY.Y = MenuFileY;
	sprintf( StrBuf, "%s", MainStr_16);
	WriteStrBufToScreen();
	VidMemXY.X = MenuStartX;
	VidMemXY.Y = MenuObjectY;
	sprintf( StrBuf, "%s", MainStr_17);
	WriteStrBufToScreen();
	VidMemXY.X = MenuStartX;
	VidMemXY.Y = MenuSidTY;
	sprintf( StrBuf, "%s", MainStr_18);
	WriteStrBufToScreen();
	VidMemXY.X = MenuStartX;
	VidMemXY.Y = MenuDateTimeY;
	sprintf( StrBuf, "%s", MainStr_19);
	WriteStrBufToScreen();
	VidMemXY.X = MenuStartX;
	VidMemXY.Y = MenuLX200Y;
	sprintf( StrBuf, "%s", MainStr_20);
	WriteStrBufToScreen();
	VidMemXY.X = MenuStartX;
	VidMemXY.Y = MenuSlewY;
	sprintf( StrBuf, "%s", MainStr_22);
	WriteStrBufToScreen();
	VidMemXY.X = MenuStartX;
	VidMemXY.Y = MenuMsParmsY;
	sprintf( StrBuf, "%s", MainStr_23);
	WriteStrBufToScreen();

	WriteHandpadStatus();
	WriteTrackStatus();
	WritePECStatus();
	WriteMsArcsecSec();
	WriteGuideArcsecSec();
	DisplayIn( NameBlanks, NameBlanks);
	DisplayDrift();
	DisplayInitStatusOnScreen();

	/* fill out the array of menu category video memory X values */
	for( Ix = 0; Ix < MaxMenuCats; Ix++)
		MenuCatX[Ix] = MenuStartX + Ix*(MenuEndX-MenuStartX)/MaxMenuCats;
	/* fill out the array of menu subtitle video memory X values */
	for( Ix = 0; Ix < MaxMenuSubs; Ix++)
		MenuSubX[Ix] = MenuStartX + Ix*(MenuEndX-MenuStartX)/MaxMenuSubs;
	/* start program with first category and first subtitle of that category */
	CurrentMenuCat = 0;
	CurrentMenuSub = 0;
	NewMenuCat = 0;
	NewMenuSub = 0;
	WriteMainMenu();
}

void CloseKBEvent( void)
{
	if( EncoderType)
	{
		QueryAndReadEncoders();
		if( EncoderState == Read)
			SaveEncoderOffset();
	}
	fclose( OutGuideFilePtr);
	FreeAllScroll();
	clrscr();
	_setcursortype( _NORMALCURSOR);
	if( DisplayOpeningMsgs)
	{
		printf( "\nPlease turn off motor power supply.\n");
		ContMsgRoutine();
	}
}

void PrelimMsg( void)
{
	printf( "\nWarning: to prevent overheating motors & electronics, ");
	printf( "\n         turn off the motor power supply if program not running");
	printf( "\n         and stop tracking before hot-keying to another program.");
	printf( "\nPlease turn on the motors' power supply now.");
	NewLine;
	ContMsgRoutine();
}

/* clears menu category and menu subtitle area */
void ClearMenuArea( void)
{
	window( 2, MenuCatsY+1, MaxX-1, MenuDescY+1);
	clrscr();
	window( 1, 1, MaxX, MaxY);
}

/* clears only menu subtitle area */
void ClearMenuSubArea( void)
{
	window( 2, MenuSubMenuY+1, MaxX-1, MenuDescY+1);
	clrscr();
	window( 1, 1, MaxX, MaxY);
}

void WriteMainMenu( void)
{
	ClearMenuArea();
	WriteMenuCats();
	SelectTextAttrMenuCat( CurrentMenuCat);
	WriteSubMenus();
	SelectTextAttrMenuSub( CurrentMenuSub);
	WriteSubMenuDesc( CurrentMenuCat, CurrentMenuSub);

	/* draw a line separating the menu category from the menu subtitle area */
	TextAttr = BorderText;
	VidMemXY.Y = MenuSubLine1Y;
	for( VidMemXY.X = 1; VidMemXY.X < MaxX-1; VidMemXY.X++)
		WriteCharToScreen( HorizBorder);
	VidMemXY.X = 0;
	WriteCharToScreen( LeftIntersect);
	VidMemXY.X = MaxX-1;
	WriteCharToScreen( RightIntersect);

	/* draw a line separating the menu subtitle area from the menu description */
	VidMemXY.Y = MenuSubLine2Y;
	for( VidMemXY.X = 1; VidMemXY.X < MaxX-1; VidMemXY.X++)
		WriteCharToScreen( HorizBorder);
	VidMemXY.X = 0;
	WriteCharToScreen( LeftIntersect);
	VidMemXY.X = MaxX-1;
	WriteCharToScreen( RightIntersect);
}

void WriteMenuCats( void)
{
	TextAttr = DefaultText;
	VidMemXY.Y = MenuCatsY;
	for( Ix = 0; Ix < MaxMenuCats; Ix++)
	{
		sprintf( StrBuf, "%s", MenuArray[Ix].Title);
		VidMemXY.X = MenuCatX[Ix];
		WriteStrBufToScreen();
	}
}

void SelectTextAttrMenuCat( const int MenuCat)
{
	TextAttr = SelectText;
	ChangeTextAttrMenuCat( MenuCat);
}

void DefaultTextAttrMenuCat( const int MenuCat)
{
	TextAttr = DefaultText;
	ChangeTextAttrMenuCat( MenuCat);
}

/* changes the attributes of the displayed text */
void ChangeTextAttrMenuCat( const int MenuCat)
{
	int StartX, EndX;

	VidMemXY.Y = MenuCatsY;
	StartX = MenuCatX[MenuCat];
	if( MenuCat+1 == MaxMenuCats)
		EndX = MenuEndX;
	else
		EndX = MenuCatX[MenuCat+1]-1;
	for( VidMemXY.X = StartX; VidMemXY.X < EndX;	VidMemXY.X++)
		Screen[VidMemXY.Y][VidMemXY.X].Attr = TextAttr;
}

void WriteSubMenus( void)
{
	TextAttr = MenuText;
	for( Ix = 0; Ix < MenuArray[CurrentMenuCat].NumSubTitles; Ix++)
	{
		TextAttr = MenuText;
		VidMemXY.Y = MenuSubMenuY + Ix/MaxMenuSubs;
		VidMemXY.X = MenuSubX[Ix%MaxMenuSubs];
		sprintf( StrBuf, "%s", MenuArray[CurrentMenuCat].SubTitles[Ix].Title);
		WriteStrBufToScreen();
	}
}

void WriteSubMenuDesc( const int MenuCat, const int SubMenu)
{
	TextAttr = DefaultText;
	VidMemXY.Y = MenuDescY;
	for( VidMemXY.X = MenuStartX; VidMemXY.X < MenuEndX; VidMemXY.X++)
		WriteCharToScreen( Blank);
	VidMemXY.X = MenuStartX;
	sprintf( StrBuf, "--> ");
	WriteStrBufToScreen();
	sprintf( StrBuf, "%s", MenuArray[MenuCat].SubTitles[SubMenu].Desc);
	WriteStrBufToScreen();
}

void SelectTextAttrMenuSub( const int MenuSub)
{
	TextAttr = SelectText;
	ChangeTextAttrMenuSub( MenuSub);
}

void MenuTextAttrMenuSub( const int MenuSub)
{
	TextAttr = MenuText;
	ChangeTextAttrMenuSub( MenuSub);
}

/* changes the attributes of the displayed text */
void ChangeTextAttrMenuSub( const int MenuSub)
{
	int StartX, EndX;

	VidMemXY.Y = MenuSubMenuY + MenuSub/MaxMenuSubs;
	StartX = MenuSubX[MenuSub%MaxMenuSubs];
	if( MenuSub+1 == MaxMenuSubs)
		EndX = MenuEndX-1;
	else
	{
		EndX = MenuSubX[(MenuSub+1)%MaxMenuSubs]-1;
		if( EndX < StartX)
			EndX = MenuEndX-1;
	}
	for( VidMemXY.X = StartX; VidMemXY.X < EndX;	VidMemXY.X++)
		Screen[VidMemXY.Y][VidMemXY.X].Attr = TextAttr;
}

void UpdateMenuCatSub( void)
{
	/* new menu category and therefore new menu subtitle of that category */
	if( NewMenuCat != CurrentMenuCat)
	{
		DefaultTextAttrMenuCat( CurrentMenuCat);
		SelectTextAttrMenuCat( NewMenuCat);
		CurrentMenuCat = NewMenuCat;
		ClearMenuSubArea();
		WriteSubMenus();
		SelectTextAttrMenuSub( NewMenuSub);
		WriteSubMenuDesc( CurrentMenuCat, NewMenuSub);
		CurrentMenuSub = NewMenuSub;
	}
	else
		/* same menu category but new menu subtitle of that category */
		if( NewMenuSub != CurrentMenuSub)
		{
			MenuTextAttrMenuSub( CurrentMenuSub);
			SelectTextAttrMenuSub( NewMenuSub);
			WriteSubMenuDesc( CurrentMenuCat, NewMenuSub);
			CurrentMenuSub = NewMenuSub;
		}
}

void WriteMsParmsMenu( void)
{
	ClearMenuArea();
	gotoxy( MenuStartX+5, MenuCatsY+2);
	printf( "increase PWM[0-9]: alt-f1 - alt-f10");
	gotoxy( MenuStartX+5, MenuCatsY+3);
	printf( "decrease PWM[0-9]: ctrl-f1 - ctrl-f10");
	gotoxy( MenuStartX+5, MenuCatsY+4);
	printf( "incr. MsPause: shift-f1, decr. MsPause: f1");
	gotoxy( MenuStartX+5, MenuCatsY+5);
	printf( "incr. MsDelayX: shift-f2, decr. MsDelayX: f2");
	gotoxy( MenuStartX+5, MenuCatsY+6);
	printf( "q to quit");
}

void SaveEncoderOffset( void)
{
	Output = fopen( EncoderOffsetFile, "w");
	if( Output == NULL)
		BadExit( strcat( "Could not open ", EncoderOffsetFile));
	fprintf( Output, "%f %f\n", EncoderOffset.A, EncoderOffset.Z);
	fclose( Output);
}

void LoadEncoderOffset( void)
{
	Input = fopen( EncoderOffsetFile, "r");
	if( Input == NULL)
		printf( "\nDid not find %s", EncoderOffsetFile);
	else
	{
		ReadDouble( Input, &EncoderOffset.A);
		ReadDouble( Input, &EncoderOffset.Z);
	}
	fclose( Input);
}

void SetEncoderAZandEncoderOffset( void)
{
	if( EncoderState > NotInitialized)
	{
		EncoderAZ.A = Current.Alt;
		EncoderAZ.Z = Current.Az;
		EncoderOffset.A = EncoderAZ.A - OneRev * (double) EncoderCount.A /
		(double) AltEncoderCountsPerRev;
		EncoderOffset.Z = EncoderAZ.Z - OneRev * (double) EncoderCount.Z /
		(double) AzEncoderCountsPerRev;
	}
}

Flag ConfirmHsMove( void)
{
	double MaxMoveDeg;
	int X = MsgFrame.Left + 5;
	int Y = MsgFrame.Top + 2;

	if( Steps.A > MoveHsMsgSteps || Steps.Z > MoveHsMsgSteps)
	{
		if( Steps.A > Steps.Z)
			MaxMoveDeg = (double) Steps.A*HsRad.A*RadToDeg;
		else
			MaxMoveDeg = (double) Steps.Z*HsRad.Z*RadToDeg;

		WriteWindow( MsgFrame);
		gotoxy( X, Y);
		printf( "Halfstep move of %3.0f deg, ", MaxMoveDeg);
		Y += 2;
		gotoxy( X, Y);
		HoldAZ.A = (double) Steps.A*HsRad.A;
		if( Dir.A == CCW)
			HoldAZ.A = -HoldAZ.A;
		HoldAZ.A += Current.Alt;
		HoldAZ.Z = (double) Steps.Z*HsRad.Z;
		if( Dir.Z == CCW)
			HoldAZ.Z = -HoldAZ.Z;
		HoldAZ.Z += Current.Az;
		if( HoldAZ.Z > OneRev)
			HoldAZ.Z -= OneRev;
		if( HoldAZ.Z < 0)
			HoldAZ.Z += OneRev;
		printf( "   destination alt = %2.0f, az = %3.0f", HoldAZ.A*RadToDeg,
		HoldAZ.Z*RadToDeg);
		Y += 2;
		gotoxy( X, Y);
		printf( "      Please confirm by pressing 'Y'");
		Response = getch();
		RemoveWindow( MsgFrame);
		PauseUntilNewSidTime();
		if( Response == 'Y' || Response == 'y' || Response == '`')
			return Yes;
		else
			return No;
	}
	else
		return Yes;
}

/* called by either:
a. SetDirDistanceStepsThenMove() which is called from
	MoveToCurrentRaDec() for equat moves and
	ProcessMenuSelection() for altaz moves, or,
b. ProcessHPEvents() */
void KBEventMoveHs( void)
{
	/* HsTimerFlag halfstep displays done in DoAProcessTimedToBiosClockTick():
	DoAProcessTimedToBiosClockTick() called from MoveHsUsingIRQTimer() */
	if( !HsTimerFlag)
	{
		TextAttr = DisplayText;
		VidMemXY = DisplayXY[DisplayHsSlew];
		sprintf( StrBuf, "On ");
		WriteStrBufToScreen();
	}
	HPEventMoveHs();
	/* don't call HPEventGetEquat() at this point in case KBEventMoveHs() being
	called from SetDirDistanceStepsThenMove(): this changes Current.Ra, Dec
	when Current.Ra, Dec should stay unchanged so as to continue slewing or
	resume tracking to */
	if( MoveToCurrentRaDecFlag && AbortState)
	{
		PauseUntilNewSidTime();
		HPEventGetEquat();
	}
	if( !HsTimerFlag)
	{
		TextAttr = DisplayText;
		VidMemXY = DisplayXY[DisplayHsSlew];
		sprintf( StrBuf, "Off");
		WriteStrBufToScreen();
		if( AbortState)
		{
			TextAttr = DisplayText;
			VidMemXY = DisplayXY[DisplayHsAbort];
			sprintf( StrBuf, "%s", AbortText[AbortState]);
			WriteStrBufToScreen();
		}
	}
	/* read encoders at end of slew */
	if( EncoderState > NotInitialized)
	{
		if( EncoderState == ReadReady)
			ReadEncoders_f_ptr();
		else
			QueryAndReadEncoders();
		if( EncoderState == Read)
		{
			ProcessEncoders();
			/* if encoder error threshold exceeded: */
			if( Threshold)
			{
				/* not StrBuf as it's used in DisplayIn() */
				sprintf( StrBuf2, "EncResSlew%2d", EncoderSlewResetCount++);
				DisplayIn( StrBuf2, NameBlanks);
			}
		}
	}
}

/* draws border around inside edge of window */
void DrawBorder( const struct Frame P)
{
	TextAttr = BorderText;
	/* write top */
	VidMemXY.Y = P.Top - 1;
	for( VidMemXY.X = P.Left; VidMemXY.X < P.Right-1; VidMemXY.X++)
		WriteCharToScreen( HorizBorder);
	/* write bottom */
	VidMemXY.Y = P.Bottom - 1;
	for( VidMemXY.X = P.Left; VidMemXY.X < P.Right-1; VidMemXY.X++)
		WriteCharToScreen( HorizBorder);
	/* write left */
	VidMemXY.X = P.Left - 1;
	for( VidMemXY.Y = P.Top; VidMemXY.Y < P.Bottom-1; VidMemXY.Y++)
		WriteCharToScreen( VertBorder);
	/* write right */
	VidMemXY.X = P.Right - 1;
	for( VidMemXY.Y = P.Top; VidMemXY.Y < P.Bottom-1; VidMemXY.Y++)
		WriteCharToScreen( VertBorder);
	/* write corners */
	VidMemXY.X = P.Left - 1;
	VidMemXY.Y = P.Top - 1;
	WriteCharToScreen( TopLeftCorner);
	VidMemXY.X = P.Right - 1;
	WriteCharToScreen( TopRightCorner);
	VidMemXY.Y = P.Bottom - 1;
	WriteCharToScreen( BottomRightCorner);
	VidMemXY.X = P.Left - 1;
	WriteCharToScreen( BottomLeftCorner);

	/* write title */
	TextAttr = TitleText;
	VidMemXY.X = (P.Left + P.Right + 1)/2 - strlen( P.Title)/2 - 1;
	VidMemXY.Y = P.Top - 1;
	sprintf( StrBuf, "%s", P.Title);
	WriteStrBufToScreen();
}

void KBEventInitMatrix( const int Init)
{
	InitMatrix( Init);
	DisplayInitStatusOnScreen();
}

void	DisplayInitStatusOnScreen( void)
{
	if( Three.Init)
		sprintf( StrBuf, "3 init'ed");
	else
		if( Two.Init)
			sprintf( StrBuf, "2 init'ed");
		else
			if( One.Init)
				sprintf( StrBuf, "1 init'ed");
			else
				sprintf( StrBuf, "no inits ");
	VidMemXY = DisplayXY[DisplayInitStatus];
	TextAttr = DisplayText;
	WriteStrBufToScreen();
}

void DisplayInit( void)
{
	int StartX = InitFrame.Left + 5;
	int StartY = InitFrame.Top + 1;
	int AltX, AzX, RaX, DecX, SidTX;

	AltX = StartX + 3;
	AzX = AltX + SizeofDegX + 1;
	RaX = AzX + SizeofDegX + 1;
	DecX = RaX + SizeofHMSX + 1;
	SidTX = DecX + SizeofDMSX + 1;

	WriteWindow( InitFrame);

	TextAttr = DefaultText;
	VidMemXY.Y = StartY;
	VidMemXY.X = AltX;
	sprintf( StrBuf, "Alt");
	WriteStrBufToScreen();
	VidMemXY.X = AzX;
	sprintf( StrBuf, "Az");
	WriteStrBufToScreen();
	VidMemXY.X = RaX;
	sprintf( StrBuf, "Ra");
	WriteStrBufToScreen();
	VidMemXY.X = DecX;
	sprintf( StrBuf, "Dec");
	WriteStrBufToScreen();
	VidMemXY.X = SidTX;
	sprintf( StrBuf, "SidT");
	WriteStrBufToScreen();

	if( One.Init)
	{
		VidMemXY.Y++;
		VidMemXY.X = StartX;
		sprintf( StrBuf, "1:");
		WriteStrBufToScreen();
		VidMemXY.X = AltX;
		VidMemDeg( One.Alt);
		VidMemXY.X = AzX;
		VidMemDeg( One.Az);
		VidMemXY.X = RaX;
		VidMemRaHMS( &One);
		VidMemXY.X = DecX;
		VidMemDecDMS( &One);
		VidMemXY.X = SidTX;
		VidMemSidT( &One);
	}
	if( Two.Init)
	{
		VidMemXY.Y++;
		VidMemXY.X = StartX;
		sprintf( StrBuf, "2:");
		WriteStrBufToScreen();
		VidMemXY.X = AltX;
		VidMemDeg( Two.Alt);
		VidMemXY.X = AzX;
		VidMemDeg( Two.Az);
		VidMemXY.X = RaX;
		VidMemRaHMS( &Two);
		VidMemXY.X = DecX;
		VidMemDecDMS( &Two);
		VidMemXY.X = SidTX;
		VidMemSidT( &Two);
	}
	if( Three.Init)
	{
		VidMemXY.Y++;
		VidMemXY.X = StartX;
		sprintf( StrBuf, "2:");
		WriteStrBufToScreen();
		VidMemXY.X = AltX;
		VidMemDeg( Three.Alt);
		VidMemXY.X = AzX;
		VidMemDeg( Three.Az);
		VidMemXY.X = RaX;
		VidMemRaHMS( &Three);
		VidMemXY.X = DecX;
		VidMemDecDMS( &Three);
		VidMemXY.X = SidTX;
		VidMemSidT( &Three);                 
	}
	if( Two.Init)
	{
		VidMemXY.Y += 2;
		VidMemXY.X = StartX;
		sprintf( StrBuf, "Lat: ");
		WriteStrBufToScreen();
		VidMemDeg( Lat);

		sprintf( StrBuf, " Long: ");
		WriteStrBufToScreen();
		VidMemDeg( LongitudeRad);

		VidMemXY.Y++;
		VidMemXY.X = StartX;
		sprintf( StrBuf, "AltOff: ");
		WriteStrBufToScreen();
		if( AltOffset != MAXDOUBLE)
			VidMemDeg( AltOffset);

		sprintf( StrBuf, " AzOff: ");
		WriteStrBufToScreen();
		VidMemDeg( AzOff);

		sprintf( StrBuf, " HAOff: ");
		WriteStrBufToScreen();
		GetHMSH( RadToHundSec*HAOff + 0.5, &HAOffHMSH);
		StrBufSHMS( HAOffHMSH);
		WriteStrBufToScreen();
	}

	gotoxy( StartX + 6, VidMemXY.Y += 3);
	ContMsgRoutine();
	RemoveWindow( InitFrame);
}

void WriteWindow( struct Frame P)
{
	gettext( P.Left, P.Top, P.Right, P.Bottom, WinBuffer);
	window( P.Left, P.Top, P.Right, P.Bottom);
	clrscr();
	window( 1, 1, MaxX, MaxY);
	DrawBorder( P);
	_setcursortype( _NORMALCURSOR);
}

void RemoveWindow( struct Frame P)
{
	puttext( P.Left, P.Top, P.Right, P.Bottom, WinBuffer);
	_setcursortype( _NOCURSOR);
}

/* after keyboard key is pressed, waits until next clock tick */
void PressKeyToContMsg( const char* Msg)
{
	WriteWindow( MsgFrame);
	gotoxy( MsgFrame.Left + 2, MsgFrame.Top + 2);
	printf( "%s", Msg);
	sound( 500);
	delay( 100);
	nosound();
	gotoxy( MsgFrame.Left + 2, MsgFrame.Top + 4);
	ContMsgRoutine();
	RemoveWindow( MsgFrame);
	PauseUntilNewSidTime();
	HPEventGetEquat();
}

void WriteHandpadStatus( void)
{
	TextAttr = DisplayText;
	VidMemXY = DisplayXY[DisplayHandpad];
	switch( HandpadFlag)
	{
		case HandpadOff:
				sprintf( StrBuf, "Off              ");
			break;
		case InitAutoOn:
				sprintf( StrBuf, "Init Auto On     ");
			break;
		case Init1On:
				sprintf( StrBuf, "Init 1 On        ");
			break;
		case Init2On:
				sprintf( StrBuf, "Init 2 On        ");
			break;
		case Init3On:
				sprintf( StrBuf, "Init 3 On        ");
			break;
		case GuideOn:
			if( GuideFlag)
				sprintf( StrBuf, "Guide Active     ");
			else
				sprintf( StrBuf, "Guide            ");
			break;
		case GuideStayOn:
			if( GuideFlag)
				sprintf( StrBuf, "Guide+Stay Active");
			else
				sprintf( StrBuf, "Guide+Stay       ");
			break;
		case GuideStaySaveOn:
			if( GuideArrayFlag == No)
				sprintf( StrBuf, "Guide+Save       ");
			else if( GuideArrayFlag == WritingToGuideArray)
				sprintf( StrBuf, "Guide+Save Active");
			else
				sprintf( StrBuf, "Guide+Save Finish");
			break;
		case GuideDragOn:
			if( GuideFlag)
				sprintf( StrBuf, "Guide+Drag Active");
			else
				sprintf( StrBuf, "Guide+Drag       ");
			break;
		case GrandTour:
				sprintf( StrBuf, "Grand Tour       ");
			break;
		case ScrollTour:
			if( ScrollUnderway)
				sprintf( StrBuf, "ScrollTour Active");
			else
				sprintf( StrBuf, "ScrollTour       ");
			break;
		case RecordOn:
				sprintf( StrBuf, "Record Equat     ");
			break;
		case ToggleTrack:
				sprintf( StrBuf, "Toggle Tracking  ");
			break;
		case HandpadFR:
				sprintf( StrBuf, "FR Motor Control ");
	}
	WriteStrBufToScreen();
}

void WriteTrackStatus( void)
{
	VidMemXY = DisplayXY[DisplayTrack];
	if( TrackFlag)
	{
		TextAttr = DisplayText;
		sprintf( StrBuf, "On "); 
	}
	else
	{
		TextAttr = DisplayText; 
		sprintf( StrBuf, "Off");
	}
	WriteStrBufToScreen(); 
}

void WritePECStatus( void)
{
	if( PECFlag)
	{
		if( AutoAltPECSyncOnFlag && AutoAltPECSyncSignal)
			sprintf( StrBuf, "AltSync");
		else
			sprintf( StrBuf, "On     ");
		if( AutoAzPECSyncOnFlag && AutoAzPECSyncSignal)
			sprintf( StrBuf, "AzSync ");
		else
			sprintf( StrBuf, "On     ");
	}
	else
		sprintf( StrBuf, "Off    ");

	TextAttr = DisplayText;
	VidMemXY = DisplayXY[DisplayPEC];
	WriteStrBufToScreen();
}

void WriteMsArcsecSec( void)
{
	TextAttr = DisplayText;
	VidMemXY = DisplayXY[DisplayMsSpeed];
	sprintf( StrBuf, "%4d", MsArcsecSec);
	WriteStrBufToScreen();
}

void WriteGuideArcsecSec( void)
{
	TextAttr = DisplayText;
	VidMemXY = DisplayXY[DisplayGuideSpeed];
	sprintf( StrBuf, "%4d", GuideArcsecSec); 
	WriteStrBufToScreen();
}

Flag InputAltaz( struct Position* P, int X, int Y)
{
	struct Position Hold;

	Hold.Alt = P->Alt;
	Hold.Az = P->Az; 
	gotoxy( X, Y++);
	printf( "Alt "); 
	if( !GetDouble( &P->Alt))
	{
		P->Alt = Hold.Alt;
		return False;
	}
	gotoxy( X, Y++);
	printf( "Az  ");
	if( !GetDouble( &P->Az))
	{
		P->Alt = Hold.Alt;
		P->Az = Hold.Az;
		return False;
	}
	P->Alt /= RadToDeg;
	P->Az /= RadToDeg;
	return True;
}

Flag InputEquat( struct Position* P, int X, int Y)
{
	gotoxy( X, Y++);
	printf( "RaHr   ");
	if( !GetInt( &P->RaHMSH.Hr))
		return False;
	gotoxy( X, Y++);
	printf( "RaMin  ");
	if( !GetInt( &P->RaHMSH.Min))
		return False;
	gotoxy( X, Y++);
	printf( "RaSec  "); 
	if( !GetInt( &P->RaHMSH.Sec))
		return False;
	gotoxy( X, Y++); 
	printf( "DecDeg ");
	if( !GetInt( &P->DecDMS.Deg))
		return False; 
	gotoxy( X, Y++);
	printf( "DecMin ");
	if( !GetInt( &P->DecDMS.Min))
		return False;
	gotoxy( X, Y++);
	printf( "DecSec ");
	if( !GetInt( &P->DecDMS.Sec))
		return False;

	P->RaHMSH.Sign = Plus;
	if( P->RaHMSH.Hr < 0)
	{
		P->RaHMSH.Sign = Minus;
		P->RaHMSH.Hr = -P->RaHMSH.Hr;
	}
	if( P->RaHMSH.Min < 0)
	{
		P->RaHMSH.Sign = Minus;
		P->RaHMSH.Min = -P->RaHMSH.Min;
	}
	if( P->RaHMSH.Sec < 0)
	{
		P->RaHMSH.Sign = Minus;
		P->RaHMSH.Sec = -P->RaHMSH.Sec;
	}
	P->RaHMSH.HundSec = 0;

	P->DecDMS.Sign = Plus;
	if( P->DecDMS.Deg < 0)
	{
		P->DecDMS.Sign = Minus;
		P->DecDMS.Deg = -P->DecDMS.Deg; 
	}
	if( P->DecDMS.Min < 0)
	{
		P->DecDMS.Sign = Minus;
		P->DecDMS.Min = -P->DecDMS.Min;
	}
	if( P->DecDMS.Sec < 0)
	{
		P->DecDMS.Sign = Minus;
		P->DecDMS.Sec = -P->DecDMS.Sec;
	}

	CalcRadFromHMSH( &P->Ra, P->RaHMSH);
	CalcRadFromDMS( &P->Dec, P->DecDMS);
	return True;
}

void GetFileName( char* Name)
{
	Flag ValidName = False;

	FoundFile = True;
	while( FoundFile && !ValidName)
	{
		if( FindFirst)
		{
			FindFirst = False;
			/* returns 0 if successful */
			FoundFile = !findfirst( Name, &Ffblk, 0);
		}
		else
			FoundFile = !findnext( &Ffblk);
		if( FoundFile)
			if( strcmpi( CfgFile, Ffblk.ff_name) != 0
			&& strcmpi( CurrentFile, Ffblk.ff_name) != 0
			&& strcmpi( AlignFile, Ffblk.ff_name) != 0
			&& strcmpi( InitFile, Ffblk.ff_name) != 0
			&& strcmpi( PECFile, Ffblk.ff_name) != 0
			&& strcmpi( GuideAltFile, Ffblk.ff_name) != 0
			&& strcmpi( GuideAzFile, Ffblk.ff_name) != 0
			&& strcmpi( OutGuideFile, Ffblk.ff_name) != 0
			&& strcmpi( EncoderOffsetFile, Ffblk.ff_name) != 0
			&& strcmpi( RecordEquatFile, Ffblk.ff_name) != 0)
				ValidName = True;
	}
}

Flag SelectDataFilename( char* Name)
{
	struct FilenameArray N[MaxNameArray];
	int Left, Top;
	int Menu;

	ValidResponseFlag = No;
	FindFirst = True;
	GetFileName( Name);
	if( FoundFile)
		while( True)
		{
			Menu = 'a';
			WriteWindow( DataFileFrame);
			Left = DataFileFrame.Left + 2;
			Top = DataFileFrame.Top + 2;
			while( FoundFile && (Menu-'a') < MaxNameArray)
			{
				gotoxy( Left, Top);
				printf( "%c. %s\n", Menu, Ffblk.ff_name);
				strcpy( N[Menu-'a'].Name, Ffblk.ff_name);
				Menu++;
				/* if remainder, that is, not reached bottom of column... */
				if( (Menu-'a') % 8)
					Top++;
				else
				{
					Top -= 7;
					Left += 21;
				}
				GetFileName( Name);
			}
			gotoxy( DataFileFrame.Left + 4, DataFileFrame.Bottom - 3);
			printf( " >>> select a-%c or any other key to escape <<< ", Menu-1);
			if( FoundFile)
			{
				gotoxy( DataFileFrame.Left + 16, DataFileFrame.Bottom - 2);
				printf( "<Space Bar> for more");
			}
			Response = getch();
			Response = tolower( Response);
			RemoveWindow( DataFileFrame);
			/* exit loop if valid response */
			if( Response >= 'a' && Response < Menu)
			{
				ValidResponseFlag = Yes;
				Ix = Response - (int) 'a';
				break;
			}
			/* read in more if space bar was pressed */
			else if( FoundFile && Response == ' ')
				Menu = 'a';
			else
				break;
		}
	else
		PressKeyToContMsg( "No data files found");
	if( ValidResponseFlag)
	{
		strcpy( Filename, N[Response-'a'].Name);
		return True;
	}
	else
	{
		PressKeyToContMsg( "No data file selected");
		return False;
	}
}

void MenuCoordFile( void)
{
	struct Object O[MaxCoord];
	int Left, Top;
	int Ix;
	char Menu;
	int Count;
	char LookAheadChar = ' ';
	Flag LookAheadCharRead = No;


	if( SelectDataFilename( DataFile))
	{
		Input = fopen( Filename, "r");
		if( Input == NULL)
			BadExit( strcat( "Could not open ", Filename));

		GrandTourLoaded = Yes;
		GrandTourRecNum = 0;
		strcpy( GrandTourFilename, Filename);
		if( !feof( Input))
		{
			/* while there are objects in the input file */
			while( FillObjects( O, &Count))
			{
				/* Restore char read while determining eof on previous screen? */
				/* each line in the data files starts with a blank, so char will
				always be ' ' so no need to restore char at this time */
				if( LookAheadCharRead)
				{
				}
				/* save screen & draw border */
				WriteWindow( CoordFrame);
				/* write objects and instructions */
				Left = CoordFrame.Left + 3;
				Top = CoordFrame.Top + 2;
				gotoxy( Left, Top);
				Menu = 'a';
				for( Ix = 1; Ix <= Count; Ix++)
				{
					gotoxy( Left, Top);
					printf( "%c. %s ", Menu++, O[Ix-1].Name);
					if( Ix%8)
						Top++;
					else
					{
						Top -= 7;
						Left += 23;
					}
				}
				gotoxy( CoordFrame.Left + 13, CoordFrame.Bottom - 2);
				printf( " >>> select a-%c or any other key to escape <<< ",
				(char) ('a' + Count - 1));
				/* look ahead to see if file is finished */
				FReadChar( Input, &LookAheadChar);
				LookAheadCharRead = Yes;
				if( !feof( Input))
				{
					gotoxy( CoordFrame.Left + 26, CoordFrame.Bottom - 1);
					printf( "<Space Bar> for more");
				}
				Response = getch();
				Response = tolower( Response);
				/* restore screen */
				RemoveWindow( CoordFrame);
				/* exit loop if valid response */
				ValidResponseFlag = No;
				if( Response >= 'a' && Response < ('a' + Count))
				{
					ValidResponseFlag = Yes;
					Ix = Response - (int) 'a';
					break;
				}
				/* read in more if space bar was pressed */
				else
					if( !feof( Input) && Response == ' ')
						continue;
					else
						break;
			}
			/* if valid input, process input */
			if( ValidResponseFlag)
			{
				In.RaHMSH = O[Ix].RaHMSH;
				In.DecDMS = O[Ix].DecDMS;
				CalcRadFromHMSH( &In.Ra, In.RaHMSH);
				CalcRadFromDMS( &In.Dec, In.DecDMS);
				DisplayIn( Filename, O[Ix].Name);
			}
			else
			{
				WriteWindow( MsgFrame);
				gotoxy( MsgFrame.Left + 5, MsgFrame.Top + 2);
				printf( "No object inputed");
				gotoxy( MsgFrame.Left + 5, MsgFrame.Top + 4);
				ContMsgRoutine();
				RemoveWindow( MsgFrame);
				DisplayIn( Filename, NameBlanks);
			}
		}
		fclose( Input);
	}
}

void ReadRa( FILE* File, struct HMSH* V)
{
	fscanf( File, "%d", &V->Hr);
	fscanf( File, "%d", &V->Min);
	fscanf( File, "%d", &V->Sec);
	V->Sign = Plus;
	V->HundSec = 0;
}

void ReadDec( FILE* File, struct DMS* V)
{
	fscanf( File, "%d", &V->Deg);
	fscanf( File, "%d", &V->Min);
	fscanf( File, "%d", &V->Sec);
	V->Sign = Plus;
	if( V->Deg < 0)
	{
		V->Sign = Minus;
		V->Deg = -V->Deg;
	}
	if( V->Min < 0)
	{
		V->Sign = Minus;
		V->Min = -V->Min;
	}
	if( V->Sec < 0)
	{
		V->Sign = Minus;
		V->Sec = -V->Sec;
	}
}

/* ability to page down through lists of unlimited size courtesy Dale Eason */
/* used by MenuCoordFile() to fill window until out of data from file */
Flag FillObjects( struct Object O[], int* Count)
{
		int Ix = 0;

		while( !feof( Input) && Ix < MaxCoord)
		{
			ReadRa( Input, &O[Ix].RaHMSH);
			if( !feof( Input))
				ReadDec( Input, &O[Ix].DecDMS);
			if( !feof( Input))
				ReadString( Input, O[Ix].Name);

			Ix++;
			*Count = Ix;
		}
		if( feof( Input))
			(*Count)--;
		for( ; Ix < MaxCoord; Ix++)
		{
			strcpy( O[Ix].Name, " ");
			O[Ix].RaHMSH.Hr = O[Ix].RaHMSH.Min = O[Ix].RaHMSH.Sec = 0;
			O[Ix].RaHMSH.HundSec = 0;
			O[Ix].DecDMS.Deg = O[Ix].DecDMS.Min = O[Ix].DecDMS.Sec = 0;
			O[Ix].RaHMSH.Sign = O[Ix].DecDMS.Sign = Plus;
		}
		if( *Count)
			return True;
		else
			return False;
}

void AddScroll( struct SCROLL* Scroll)
{
	if( FirstScroll == NULL)
	{
		Scroll->PrevScroll = NULL;
		Scroll->NextScroll = NULL;
		FirstScroll = Scroll;
		LastScroll = Scroll;
	}
	else
	{
		Scroll->PrevScroll = LastScroll;
		Scroll->NextScroll = NULL;
		/* set next to last Scroll in linked list to current Scroll */
		LastScroll->NextScroll = Scroll;
		/* current Scroll also LastScroll */
		LastScroll = Scroll;
	}
}

void FreeAllScroll( void)
{
	struct SCROLL* Scroll;

	Scroll = LastScroll;
	while( Scroll != NULL)
	{
		/* set LastScroll to next to last in linked list */
		LastScroll = Scroll->PrevScroll;
		/* now free last in linked list */
		free( Scroll);
		Scroll = LastScroll;
	}
	FirstScroll = NULL;
	ScrollLoaded = No;
}

struct SCROLL* InitScroll( void)
{
	struct SCROLL* Scroll;

	Scroll = (struct SCROLL*) malloc( sizeof (struct SCROLL));
	if( Scroll == NULL)
		BadExit( "Problem with malloc of Scroll");
	Scroll->CoordType = no_type;
	Scroll->PrevScroll = NULL;
	Scroll->NextScroll = NULL;
	Scroll->Ra = Scroll->Dec = Scroll->Sec = 0;
	Scroll->RaHMSH.Sign = Scroll->RaHMSH.Hr = Scroll->RaHMSH.Min =
	Scroll->RaHMSH.Sec =	Scroll->RaHMSH.HundSec = 0;
	Scroll->DecDMS.Sign = Scroll->DecDMS.Deg = Scroll->DecDMS.Min =
	Scroll->DecDMS.Sec;
	strcpy( Scroll->Note, NameBlanks);

	return Scroll;
}


void MenuScrollFile( void)
{
	struct SCROLL* Scroll;
	COORD_TYPE CoordType;

	if( SelectDataFilename( ScrollFile))
	{
		strcpy( ScrollFilename, Filename);
		Input = fopen( ScrollFilename, "r");
		if( Input == NULL)
			BadExit( strcat( "Could not open ", ScrollFilename));

		DisplayIn( ScrollFilename, NameBlanks );
		FreeAllScroll();
		while( !feof( Input))
		{
			CoordType = no_type;
			strcpy( Name, "");
			fscanf( Input, "%s", Name);
			/* if 1st char is ';' then goto next line */
			if( Name[0] == ';')
				FReadToNewLine( Input);
			else if( (strncmpi( Name, "a", sizeof( Name))) == 0)
				CoordType = equat_abs;
			else if( (strncmpi( Name, "o", sizeof( Name))) == 0)
				CoordType = equat_off;
			if( CoordType == equat_abs || CoordType == equat_off)
			{
				Scroll = InitScroll();
				Scroll->CoordType = CoordType;
				ReadRa( Input, &Scroll->RaHMSH);
				CalcRadFromHMSH( &Scroll->Ra, Scroll->RaHMSH);
				ReadDec( Input, &Scroll->DecDMS);
				CalcRadFromDMS( &Scroll->Dec, Scroll->DecDMS);
				ReadDouble( Input, &Scroll->Sec);
				if( Scroll->Sec == 0)
					BadExit( strcat( "Sec must be > 0 in ", ScrollFile));
				ReadString( Input, Scroll->Note);
				AddScroll( Scroll);
			}
		}
		fclose( Input);
		ScrollLoaded = Yes;
	}
}

/* use to enter init's with different SidT's */
void EnterInit( const int InitToDo)
{
	struct XY HoldXY;
	/* temporary coordinates */
	struct Position Temp;

	WriteWindow( MsgFrame);

	HoldXY.X = MsgFrame.Left + 2;
	HoldXY.Y = MsgFrame.Top + 1;
	Temp = Current;
	gotoxy( HoldXY.X, HoldXY.Y);
	printf( "Please enter init %1d ", InitToDo);
	HoldXY.X = wherex();
	gotoxy( HoldXY.X, HoldXY.Y);
	if( InputEquat( &Current, HoldXY.X, HoldXY.Y))
	{
		gotoxy( HoldXY.X += 17, HoldXY.Y);
		if( InputAltaz( &Current, HoldXY.X, HoldXY.Y))
		{
			HoldXY.Y += 3;
			gotoxy( HoldXY.X, HoldXY.Y++);
			printf( "SidHr  ");
			if( GetInt( &Current.SidTimeHMSH.Hr))
			{
				gotoxy( HoldXY.X, HoldXY.Y++);
				printf( "SidMin ");
				if( GetInt( &Current.SidTimeHMSH.Min))
				{
					gotoxy( HoldXY.X, HoldXY.Y++);
					printf( "SidSec ");
					if( GetInt( &Current.SidTimeHMSH.Sec))
					{
						Current.SidTimeHMSH.HundSec = 0;
						Current.SidTimeHMSH.Sign = Plus;
						CalcRadFromHMSH( &Current.SidT, Current.SidTimeHMSH);
						/* KBEventInitMatrix calls InitMatrix() then calls
						DisplayInitStatusOnScreen(), but this window covers up
						the init display on the screen, so wait until window
                  removed before displaying init status on screen */
						InitMatrix( InitToDo);
					}
				}
			}
		}
	}
	/* restore Alt, Az */
	Current.Alt = Temp.Alt;
	Current.Az = Temp.Az;

	RemoveWindow( MsgFrame);
	DisplayInitStatusOnScreen();
}

void DisplayDrift( void)
{
	TextAttr = DisplayText;
	VidMemXY = DisplayXY[DisplayDriftAlt];
	VidMemDeg( Drift.Alt*ArcsecPerDeg);
	VidMemXY = DisplayXY[DisplayDriftAz];
	VidMemDeg( Drift.Az*ArcsecPerDeg);
	VidMemXY = DisplayXY[DisplayDriftRa];
	VidMemRaHMS( &Drift);
	VidMemXY = DisplayXY[DisplayDriftDec];
	VidMemDecDMS( &Drift);
}

void DisplayIn( char* FileName, char* ObjectName)
{
	TextAttr = DisplayText;
	VidMemXY = DisplayXY[DisplayInputAlt];
	VidMemDeg( In.Alt);
	VidMemXY = DisplayXY[DisplayInputAz];
	VidMemDeg( In.Az);
	VidMemXY = DisplayXY[DisplayInputRa];
	VidMemRaHMS( &In);
	VidMemXY = DisplayXY[DisplayInputDec];
	VidMemDecDMS( &In);

	TextAttr = DisplayText;
	VidMemXY = DisplayXY[DisplayFile];
	sprintf( StrBuf, "%s", NameBlanks);
	WriteStrBufToScreen();
	VidMemXY = DisplayXY[DisplayFile];
	sprintf( StrBuf, "%s", FileName);
	WriteStrBufToScreen();
	VidMemXY = DisplayXY[DisplayObject];
	sprintf( StrBuf, NameBlanks);
	WriteStrBufToScreen();
	VidMemXY = DisplayXY[DisplayObject];
	sprintf( StrBuf, "%s", ObjectName);
	WriteStrBufToScreen();
}

void DisplayEncodersNotAvailable( void)
{
	VidMemXY = DisplayXY[DisplayEncoderAlt];
	TextAttr = DisplayText;
	sprintf( StrBuf, "%s ", NotAvailableStr);
	WriteStrBufToScreen();
	VidMemXY = DisplayXY[DisplayEncoderAz];
	sprintf( StrBuf, "%s ", NotAvailableStr);
	WriteStrBufToScreen();
	VidMemXY = DisplayXY[DisplayEncoderCountAlt];
	TextAttr = DisplayText;
	sprintf( StrBuf, "%s", NotAvailableStr);
	WriteStrBufToScreen();
	VidMemXY = DisplayXY[DisplayEncoderCountAz];
	sprintf( StrBuf, "%s", NotAvailableStr);
	WriteStrBufToScreen();
}

void DoAProcessTimedToBiosClockTick( void)
{
	static int Tick;
	static int HoldSlewState, HoldAbortState, HoldPWMReps;
	static double HoldRa, HoldDec = -9999;
	static double HoldFRMotorAngle;
	static struct Position TempA, TempB;

	/* MoveFR() needs this calculation every bios clock tick */
	if( Two.Init && (Tick==0 || DoFR))
		CalcFieldR();

	/* add non-zero equatorial drift */
	if( Two.Init && DriftEquatFlag)
	{
		Current.Ra += DriftTick.Ra;
		Current.Dec += DriftTick.Dec;
	}

	/* write PWMRepsTick */
	if( HoldPWMReps != ActualPWMRepsTick)
	{
		TextAttr = DisplayText;
		VidMemXY = DisplayXY[DisplayPWMReps];
		sprintf( StrBuf, "%3d", ActualPWMRepsTick);
		WriteStrBufToScreen();
		HoldPWMReps = ActualPWMRepsTick;
	}

	switch( Tick)
	{
		/* the statements just above occupy the case 0: time slot */
		case 1:
			if( HsTimerFlag && (HoldSlewState != SlewState))
			{
				TextAttr = DisplayText;
				VidMemXY = DisplayXY[DisplayHsSlew];
				sprintf( StrBuf, "%s", SlewText[SlewState]);
				WriteStrBufToScreen();
				HoldSlewState = SlewState;
				break;
			}
			/* fall through if no print */
		case 2:
			if( HsTimerFlag && (HoldAbortState != AbortState))
			{
				TextAttr = DisplayText;
				VidMemXY = DisplayXY[DisplayHsAbort];
				sprintf( StrBuf, "%s", AbortText[AbortState]);
				WriteStrBufToScreen();
				HoldAbortState = AbortState;
				break;
			}
			/* fall through if no print */
		case 3:
			if( HsTimerFlag && (SlewState != SlewDone))
			{
				TextAttr = DisplayText;
				VidMemXY = DisplayXY[DisplayHsSteps];

				sprintf( StrBuf, "%12ld/%8ld/%8ld/%8ld/%8ld/%4d", RampHs,
				RampUpSteps, MaxSlewUpSteps, MaxSlewDownSteps, RampDownSteps,
				HsRepsIx);

				WriteStrBufToScreen();
				break;
			}
		case 4:
			getdate( &d);
			gettime( &t);
			sprintf( StrBuf, "%2d/%02d %2d:%02d:%02d", d.da_mon, d.da_day,
			t.ti_hour, t.ti_min, t.ti_sec);
			VidMemXY = DisplayXY[DisplayDateTime];
			TextAttr = DisplayText;
			WriteStrBufToScreen();
			break;
		case 5:
			VidMemXY = DisplayXY[DisplaySidT];
			TextAttr = DisplayText;
			VidMemSidT( &Current);
			break;
		case 6:
			CalcRefractScopeToSky( Current.Alt);
			sprintf( StrBuf, "%5.3f", Refract*RadToDeg);
			VidMemXY = DisplayXY[DisplayRefract];
			TextAttr = DisplayText;
			WriteStrBufToScreen();
			break;
		case 7:
			if( SlewState != SlewDone)
				/* if middle of slew, update Current.A, Z */
				SetCurrentAltazToAccumMs();
			VidMemXY = DisplayXY[DisplayCurrentAlt];
			TextAttr = CurrentText;
			VidMemDeg( Current.Alt);
			break;
		case 8:
			/* previous case statement calls SetCurrentAltazToAccumMs() */
			VidMemXY = DisplayXY[DisplayCurrentAz];
			TextAttr = CurrentText;
			VidMemDeg( Current.Az);
			break;
		case 9:
			if( Two.Init)
			{
				sprintf( StrBuf, "%7.3f", FieldR*RadToDeg);
				TextAttr = DisplayText;
				VidMemXY = DisplayXY[DisplayFR];
				WriteStrBufToScreen();
				/* displays actual field rotation angle of the motor */
				if( DoFR && HoldFRMotorAngle != FRMotorAngle)
				{
					HoldFRMotorAngle = FRMotorAngle;
					sprintf( StrBuf, "%6.2f", FRMotorAngle*RadToDeg);
					VidMemXY.X = DisplayXY[DisplayFR].X;
					VidMemXY.Y = DisplayXY[DisplayFR].Y+1;
					WriteStrBufToScreen();
					sprintf( StrBuf, "%2d %2d", FRDiagPulseHigh%100, FRDiagReset%100);
					VidMemXY.X = DisplayXY[DisplayFR].X;
					VidMemXY.Y = DisplayXY[DisplayFR].Y+2;
					WriteStrBufToScreen();

				}
			}
			break;
		case 10:
			if( Two.Init)
				if( SlewState != SlewDone)
				{
					TempA = Current;
					HPEventGetEquat();
					TempB = Current;
					Current = TempA;
					VidMemXY = DisplayXY[DisplayCurrentRa];
					TextAttr = CurrentText;
					VidMemRaHMS( &TempB);
				}
				else if( Current.Ra != HoldRa)
				{
					VidMemXY = DisplayXY[DisplayCurrentRa];
					TextAttr = CurrentText;
					VidMemRaHMS( &Current);
					HoldRa = Current.Ra;
					PUT_SCOPE;
				}
			break;
		case 11:
			if( Two.Init)
				if( SlewState != SlewDone)
				{
					/* TempB set in previous case statement */
					VidMemXY = DisplayXY[DisplayCurrentDec];
					TextAttr = CurrentText;
					VidMemDecDMS( &TempB);
				}
				else if( Current.Dec != HoldDec)
				{
					VidMemXY = DisplayXY[DisplayCurrentDec];
					TextAttr = CurrentText;
					VidMemDecDMS( &Current);
					HoldDec = Current.Dec;
					PUT_SCOPE;
				}
				break;
		case 12:
			if( SlewState == SlewDone && EncoderState > NotInitialized
			&& EncoderState != ReadReady)
				QueryEncoders_f_ptr();
			break;
		case 13:
			if( SlewState == SlewDone && EncoderState == ReadReady)
			{
				ReadEncoders_f_ptr();
				if( EncoderState == Read)
				{
					ProcessEncoders();
					/* if encoder error threshold exceeded: */
					if( Threshold)
						/* if tracking on, it's assumed that user wishes scope to
						continue	moving to Ra/Dec, ie, scope bumped accidently;
						if tracking off, it's assumed that user is moving scope
						manually	and wishes Ra/Dec to be reset based on encoders */
						if( TrackFlag)
						{
							/* not StrBuf as it's used in DisplayIn() */
							sprintf( StrBuf2, "EncResOn%2d",
							EncoderTrackOnResetCount++);
							DisplayIn( StrBuf2, NameBlanks);
						}
						else
						{
							sprintf( StrBuf2, "EncResOff%2d",
							EncoderTrackOffResetCount++);
							DisplayIn( StrBuf2, NameBlanks);
							HPEventGetEquat();
						}
				}
			}
			break;
		case 14:
			if( SlewState == SlewDone && EncoderState == Read)
			{
				/* display encoder counts */
				VidMemXY = DisplayXY[DisplayEncoderCountAlt];
				TextAttr = DisplayText;
				sprintf( StrBuf, "%6ld", EncoderCount.A);
				WriteStrBufToScreen();

				VidMemXY = DisplayXY[DisplayEncoderCountAz];
				TextAttr = DisplayText;
				sprintf( StrBuf, "%6ld", EncoderCount.Z);
				WriteStrBufToScreen();
			}
			break;
		case 15:
			if( SlewState == SlewDone && EncoderState == Read)
			{
				/* display encoder alt, az */
				VidMemXY = DisplayXY[DisplayEncoderAlt];
				TextAttr = DisplayText;
				VidMemDeg( EncoderAZ.A);

				VidMemXY = DisplayXY[DisplayEncoderAz];
				TextAttr = DisplayText;
				VidMemDeg( EncoderAZ.Z);
			}
			else
				DisplayEncodersNotAvailable();
			break;
		case 16:
			if( LX200ComPort && LX200DisplayFlag)
			{
				for( Ix = 0; Ix < LX200_Cmd_Array_Size; Ix++)
					sprintf( StrBuf+Ix*LX200_CMD_STR_SIZE, " %s",
					LX200_Cmd_Str[LX200_Cmd_Array[Ix].LX200_Cmd_Type]);
				VidMemXY = DisplayXY[DisplayLX200];
				TextAttr = DisplayText;
				WriteStrBufToScreen();

				sprintf( StrBuf, " %02d", LX200_Cmd_Count);
				TextAttr = DisplayText;
				WriteStrBufToScreen();

				VidMemXY.Y = DisplayXY[DisplayLX200].Y;
				VidMemXY.X = DisplayXY[DisplayLX200].X +
				LX200_CMD_STR_SIZE * LX200_Cmd_Array_Ix;
				sprintf( StrBuf, "*");
				TextAttr = DisplayText;
				WriteStrBufToScreen();

				for( Ix = 0; Ix < LX200QueueSize; Ix++)
					sprintf( StrBuf+Ix, "%c", (char) LX200Queue[Ix]);
				VidMemXY.Y = DisplayXY[DisplayLX200].Y+1;
				VidMemXY.X = 2;
				TextAttr = DisplayText;
				WriteStrBufToScreen();
			}
			break;
		case 17:
			if( PECFlag)
			{
				sprintf( StrBuf, "%03d:%03.0f", PECIx.A, PECToAdd.A);
				VidMemXY.Y = DisplayXY[DisplayPEC].Y;
				VidMemXY.X = DisplayXY[DisplayPEC].X + 8;
				TextAttr = DisplayText;
				WriteStrBufToScreen();
			}
			break;
		case 18:
			if( PECFlag)
			{
				sprintf( StrBuf, "%03d:%03.0f", PECIx.Z, PECToAdd.Z);
				VidMemXY.Y = DisplayXY[DisplayPEC].Y;
				VidMemXY.X = DisplayXY[DisplayPEC].X + 18;
				TextAttr = DisplayText;
				WriteStrBufToScreen();
			}
			break;
		case 19:
			sprintf( StrBuf, "%c%c%c%c%c%c%c", MsSpeed?'M':'H',
			Buttons==LeftKey?'L':' ', Buttons==RightKey?'R':' ',
			Buttons==UpKey?'U':' ', Buttons==DownKey?'D':' ',
			Buttons==CWKey?'C':' ', Buttons==CCWKey?'W':' ');
			VidMemXY = DisplayXY[DisplayButtons];
			TextAttr = DisplayText;
			WriteStrBufToScreen();
			/* leave out last break; so that there are no empty ticks */
		case 20:
			Tick = -1;
	}
	Tick++;
}

void CalcEncoderAZ( void)
{
	EncoderAZ.A = EncoderOffset.A + OneRev * (double) EncoderCount.A
	/ (double) AltEncoderCountsPerRev;
	while( EncoderAZ.A < -M_PI)
		EncoderAZ.A += OneRev;
	while( EncoderAZ.A > M_PI)
		EncoderAZ.A -= OneRev;

	EncoderAZ.Z = EncoderOffset.Z + OneRev * (double) EncoderCount.Z
	/ (double) AzEncoderCountsPerRev;
	while( EncoderAZ.Z < 0)
		EncoderAZ.Z += OneRev;
	while( EncoderAZ.Z > OneRev)
		EncoderAZ.Z -= OneRev;
}

void ProcessEncoders( void)
{
	double AbsAltError, AbsAzError;

	CalcEncoderAZ();
	Threshold = No;

	/* reset current if encoder vs current discrepancy */
	if( EncoderErrorThreshold > 0)
	{
		/* get alt discrepancy */
		AbsAltError = Current.Alt - EncoderAZ.A;
		if( AbsAltError < 0)
			AbsAltError = -AbsAltError;
		if( (TrackFlag && AbsAltError > TrackEncoderErrorThreshold)
		|| (!TrackFlag && AbsAltError > EncoderErrorThreshold))
		{
			Current.Alt = EncoderAZ.A;
			Threshold = Yes;
		}
		/* get az discrepancy */
		AbsAzError = Current.Az - EncoderAZ.Z;
		if( AbsAzError < 0)
			AbsAzError = -AbsAzError;
		if( AbsAzError > M_PI)
			AbsAzError = OneRev - AbsAzError;
		if( (TrackFlag && AbsAzError > TrackEncoderErrorThreshold)
		|| (!TrackFlag && AbsAzError > EncoderErrorThreshold))
		{
			Current.Az = EncoderAZ.Z;
			Threshold = Yes;
		}
		/* if error */
		if( Threshold)
		{
			AlignMs();
			SetAccumMsToCurrentAltaz();
			if( MakeEncoderResetLogFile)
				fprintf( EncoderOutput, "\nAlt %f, Az %f, Track %d\n",
				Current.Alt*RadToDeg - EncoderAZ.A*RadToDeg,
				Current.Az*RadToDeg - EncoderAZ.Z*RadToDeg, TrackFlag);
		}
	}
}

Flag WriteGuideStartup( void)
{
	char B[3];
	int Ix;

	/* read in file, saving lines from third on */
	Input = fopen( GuideStartupMarFile, "r");
	if( Input == NULL)
	{
		PressKeyToContMsg( "Guide not found");
		return False;
	}
	else
	{
		Output = fopen( ScopeStartupMarFile, "w");
		if( Output == NULL)
			BadExit( strcat( "Could not open ", ScopeStartupMarFile));

		/* fill Buffer */
		for( Ix = 0; Ix < 3; Ix++)
			fread( &B[Ix], 1, 1, Input);

		/* read/write until 'ra ' by writing out left most char of buffer,
		then left shifting buffer, then reading in right most char of buffer */
		while( B[0] != 'r' || B[1] != 'a' || B[2] != ' ')
		{
			fprintf( Output, "%c", B[0]);
			B[0] = B[1];
			B[1] = B[2];
			fread( &B[2], 1, 1, Input);
		}
		/* write Ra, Dec */
		fprintf( Output, "ra       %f\n", 360. - Current.Ra*RadToDeg);
		fprintf( Output, "2  dec      %f\n", Current.Dec*RadToDeg);
		/* throw away these two lines since these lines have been replaced
		with new coordinates */
		FReadToNewLine( Input);
		FReadToNewLine( Input);
		/* read/write until eof */
		while( !feof( Input))
		{
			fread( &B[0], 1, 1, Input);
			fprintf( Output, "%c", B[0]);
		}
		fclose( Output);
		fclose( Input);
		return True;
	}
}

void ReadGuideStartup( void)
{
	double RaDeg, DecDeg;
	struct HMSH RaHMSH;
	struct DMS DecDMS;
	Flag RaFlag = No;
	Flag DecFlag = No;


	Input = fopen( GuideStartupMarFile, "r");
	if( Input == NULL)
		BadExit( strcat( "Could not open ", GuideStartupMarFile));

	fscanf( Input, "%s", Name);
	while( !feof( Input) && !RaFlag || !DecFlag)
	{
		if( (strncmpi( Name, "ra", sizeof( Name))) == 0)
		{
			ReadDouble( Input, &RaDeg);
			RaDeg = 360. - RaDeg;
			RaFlag = Yes;
		}
		else if( (strncmpi( Name, "dec", sizeof( Name))) == 0)
		{
			ReadDouble( Input, &DecDeg);
			DecFlag = Yes;
		}
		fscanf( Input, "%s", Name);
	}
	fclose( Input);
	if( RaFlag && DecFlag)
	{
		In.Ra = RaDeg/RadToDeg;
		In.Dec = DecDeg/RadToDeg;
		DisplayIn( "from Guide", NameBlanks);

		/* write to OutGuideFile, preserving a record of all positions
		returned from Guide */
		GetHMSH( In.Ra*RadToHundSec + .5, &RaHMSH);
		GetDMS( In.Dec*RadToArcsec + .5, &DecDMS);
		if( In.Dec < 0)
			if( DecDMS.Deg > 0)
				DecDMS.Deg = -DecDMS.Deg;
			else
				if( DecDMS.Min > 0)
					DecDMS.Min = -DecDMS.Min;
				else
					DecDMS.Sec = -DecDMS.Sec;

		fprintf( OutGuideFilePtr, "%3d %3d %3d   %3d %3d %3d   from_guide\n",
		RaHMSH.Hr, RaHMSH.Min, RaHMSH.Sec, DecDMS.Deg, DecDMS.Min, DecDMS.Sec);
	}
}

void GetCurDir( void)
{
	/* fill string with "X:\" */
	strcpy( CurDir, "X:\\");
	/* change the 'X' to the current drive */
	CurDir[0] = 'A' + getdisk();
	/* fill rest of string with path */
	getcurdir( 0, CurDir + 3);
}

void OptimizeInit( void)
{
	int FieldToRead;
	struct Position Temp;

	/* read through InitFile */

	Input = fopen( InitFile, "r");
	if( Input == NULL)
		printf( "\nDid not find %s", InitFile);
	else
	{
		FieldToRead = 1;
		while( !feof( Input))
		{
			/* read 5 fields sequentially: Ra, Dec, Alt, Az, SidT */
			switch( FieldToRead)
			{
				case 1:
					ReadDouble( Input, &Temp.Ra);
					Temp.Ra /= RadToDeg;
					break;
				case 2:
					ReadDouble( Input, &Temp.Dec);
					Temp.Dec /= RadToDeg;
					break;
				case 3:
					ReadDouble( Input, &Temp.Alt);
					Temp.Alt /= RadToDeg;
					break;
				case 4:
					ReadDouble( Input, &Temp.Az);
					Temp.Az /= RadToDeg;
					break;
				case 5:
					ReadDouble( Input, &Temp.SidT);
					Temp.SidT /= RadToDeg;
			}
			FieldToRead++;
			if( FieldToRead > 5)
			{
				FieldToRead = 1;
				BubbleSortPositions( &Temp);
			}
		}
		if( FieldToRead == 5)
			BubbleSortPositions( &Temp);
		fclose( Input);
	}
}

/* sorts Position, making 'A' the closest to Current */

void SortPosition( struct Position* A, struct Position* B, const double Diff)
{
	double InitADistance, InitBDistance;
	struct Position Temp;

	InitADistance = CalcEquatAngularSep( Current, *A);
	InitBDistance = CalcEquatAngularSep( Current, *B);
	if( InitADistance > InitBDistance + Diff)
	{
		Temp = *B;
		*B = *A;
		*A = Temp;
	}
}

/* bubble sort One, Two, Three, Temp, with One being the minimum distance
from Current and Temp being the maximum distance from Current */

void BubbleSortPositions( struct Position* Temp)
{
	Flag Duplicate = No;
	struct Position Hold;

	if( Temp->Ra == One.Ra && Temp->Dec == One.Dec && Temp->Alt == One.Alt &&
	Temp->Az == One.Az && Temp->SidT == One.SidT)
		Duplicate = Yes;
	if( Temp->Ra == Two.Ra && Temp->Dec == Two.Dec && Temp->Alt == Two.Alt &&
	Temp->Az == Two.Az && Temp->SidT == Two.SidT)
		Duplicate = Yes;
	if( Temp->Ra == Three.Ra && Temp->Dec == Three.Dec && Temp->Alt == Three.Alt &&
	Temp->Az == Three.Az && Temp->SidT == Three.SidT)
		Duplicate = Yes;

	if( !Duplicate)
	{
		SortPosition( &One, &Two, 1/RadToArcmin);
		SortPosition( &Two, &Three, 1/RadToArcmin);
		SortPosition( &Three, Temp, 1/RadToArcmin);

		SortPosition( &One, &Two, 1/RadToArcmin);
		SortPosition( &Two, &Three, 1/RadToArcmin);

		SortPosition( &One, &Two, 1/RadToArcmin);

		Hold = Current;
		Current = Three;
		SaveInitFlag = No;
		KBEventInitMatrix( 3);
		Current = Hold;
		SaveInitFlag = Yes;
	}
}

void DisplayHotkeys( void)
{
	struct XY HoldXY;

	WriteWindow( HotkeyFrame);
	TextAttr = DefaultText;
	HoldXY.X = HotkeyFrame.Left+1;
	HoldXY.Y = HotkeyFrame.Top;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "` (left apostrophe) or g : Guide.bat");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "1 : move to equat");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "2 or t : toggles tracking on/off");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "3 : saves current equatorial coordinates");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "4 : retrieve saved equatorial coordinates into the input fields");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "5 : saves current #2 equatorial coordinates");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "6 : retrieves saved #2 equatorial coordinates into the input fields");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "7 : read external slew file       8 : write external slew file");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "9 : input altaz                   0 : reset to input altaz");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "a : add in altitude offset and re-init");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "c : display current pec data");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "e : average alt pec files         f : average az pec files");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "p : toggles PEC on/off            l : reload PEC.DAT file");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "u : show alt guiding -> pec       v : show az guiding -> pec");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "y : zero out alt PEC              z : zero out az PEC");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "d : data file");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "h : hand paddle, toggling through handpad modes");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "i : display initializations       k : kill all initializations");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "m : microstepping speed");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "q : quits the program");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "r : resets to input equat coord");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "s : selects scroll file");
	WriteStrBufToScreen();
	HoldXY.Y++;
	VidMemXY = HoldXY;
	sprintf( StrBuf, "microstepping : F1-up, F2-down, F3-CCW, F4-CW");
	WriteStrBufToScreen();
	gotoxy( HoldXY.X+20, HoldXY.Y+2);
	ContMsgRoutine();
	RemoveWindow( HotkeyFrame);
}

Flag EnterHsParms( void)
{
	int X, Y;

	X = MsgFrame.Left + 5;
	Y = MsgFrame.Top + 1;

	gotoxy( X, Y++);
	printf( "HsTimerFlag [%1d] ", HsTimerFlag);
	if( !GetInt( &HsTimerFlag))
		return False;
	gotoxy( X, Y++);
	printf( "MaxDelay [%d] ", MaxDelay);
	if( !GetInt( &MaxDelay))
		return False;
	gotoxy( X, Y++);
	printf( "MinDelay [%d] ", MinDelay);
	if( !GetInt( &MinDelay))
		return False;
	gotoxy( X, Y++);
	printf( "HsDelayX [%d] ", HsDelayX);
	if( !GetInt( &HsDelayX))
		return False;
	gotoxy( X, Y++);
	printf( "HsRampX [%d] ", HsRampX);
	if( !GetInt( &HsRampX))
		return False;
	gotoxy( X, Y++);
	printf( "InterruptHs [%d] ", InterruptHs);
	if( !GetInt( &InterruptHs))
		return False;
	gotoxy( X, Y++);
	printf( "HoldReps [%d] ", HoldReps);
	if( !GetInt( &HoldReps))
		return False;
	return True;
}

void DisplayMsParmsTitles( void)
{
	if( !MsParmsTitlesWritten)
	{
		TextAttr = DefaultText;
		VidMemXY = DisplayXY[DisplayMsPWMs];
		sprintf( StrBuf,
		"0:    1:    2:    3:    4:    5:    6:    7:    8:    9:    X:    P:    ");
		WriteStrBufToScreen();
	}
}

void DisplayMsParmsValues( void)
{
	TextAttr = DisplayText;
	VidMemXY = DisplayXY[DisplayMsPWMs];
	VidMemXY.X--;
	for( Ix = 0; Ix < MaxMs; Ix++)
	{
		VidMemXY.X += 3;
		sprintf( StrBuf, "%3d", PWM[Ix]);
		WriteStrBufToScreen();
	}
	VidMemXY.X += 3;
	sprintf( StrBuf, "%3d", MsDelayX);
	WriteStrBufToScreen();
	VidMemXY.X += 3;
	sprintf( StrBuf, "%3d", MsPause);
	WriteStrBufToScreen();
}
void ProcessMenuSelection( void)
{
	struct XY HoldXY;

	ConsecutiveSlews = 0;
	AlignMs();
	SetCurrentAltazToAccumMs();
	switch( Response)
	{
		case MenuQuit:
			QuitFlag = Yes;
			break;
		case MenuDataFile:
			MenuCoordFile();
			break;
		case MenuScrollTour:
			MenuScrollFile();
			break;
		case MenuDosShell:
			/* shells to DOS */
			gettext( 1, 1, 80, 25, WinBuffer);
			clrscr();
			_setcursortype( _NORMALCURSOR);
			GetCurDir();
			SpawnReturn = spawnl( P_WAIT, "c:\\command.com", "", NULL);
			if( SpawnReturn == -1)
				BadExit( "Error from spawnl");
			chdir( CurDir);
			_setcursortype( _NOCURSOR);
			clrscr();
			puttext( 1, 1, 80, 25, WinBuffer);
			break;
		case MenuGuide:
			if( WriteGuideStartup())
			{
				gettext( 1, 1, 80, 25, WinBuffer);
				clrscr();
				_setcursortype( _NORMALCURSOR);
				GetCurDir();
				system( "guide.bat");
				chdir( CurDir);
				_setcursortype( _NOCURSOR);
				clrscr();
				puttext( 1, 1, 80, 25, WinBuffer);
				ReadGuideStartup();
				/* if tracking on, scope will slew to the new Current Ra and Dec via
				next call of ProcessHPEvents() which calls MoveToCurrentRaDec() */
				if( TrackFlag && Two.Init)
				{
					Current.Ra = In.Ra;
					Current.Dec = In.Dec;
				}
			}
			break;
		case MenuHotkeys:
			DisplayHotkeys();
			break;
		case MenuHandPad:
			HandpadFlag++;
			if( HandpadFlag == MaxHandpadFlag)
				HandpadFlag = HandpadOff;
			WriteHandpadStatus();
			break;
		case MenuTrack:
			TrackFlag = !TrackFlag;
			WriteTrackStatus();
			/* if tracking being turned off, save current to input so
			that upon resumption of tracking, scope can slew to last
			tracking position */
			if( !TrackFlag && Two.Init)
			{
				In = Current;
				DisplayIn( "last Track", NameBlanks);
			}
			break;
		case MenuMsSpeed:
			WriteWindow( MsgFrame);
			VidMemXY.X = MsgFrame.Left + 5;
			VidMemXY.Y = MsgFrame.Top + 2;
			gotoxy( VidMemXY.X+=5, VidMemXY.Y);
			printf( "Please enter new MsArcsecSec,");
			gotoxy( VidMemXY.X+=5, VidMemXY.Y+=2);
			printf( "(max = %5d)", MaxMsSpeed);
			gotoxy( VidMemXY.X+=17, VidMemXY.Y);
			GetInt( &MsArcsecSec);
			if( MsArcsecSec > MaxMsSpeed)
				MsArcsecSec = MaxMsSpeed;
			RemoveWindow( MsgFrame);
			InitMsTickVars( MsArcsecSec);
			WriteMsArcsecSec();
			break;
		case MenuGuideSpeed:
			WriteWindow( MsgFrame);
			VidMemXY.X = MsgFrame.Left + 3;
			VidMemXY.Y = MsgFrame.Top + 2;
			gotoxy( VidMemXY.X, VidMemXY.Y);
			printf( "Please enter new GuideArcsecSec");
			gotoxy( VidMemXY.X += 33, VidMemXY.Y);
			GetInt( &GuideArcsecSec);
			RemoveWindow( MsgFrame);
			WriteGuideArcsecSec();
			break;
		case MenuReadSlew:
			InputEquatSlewDat();
			ProcessHPEvents();
			break;
		case MenuWriteSlew:
			WriteEquatSlewOutFile();
			ProcessHPEvents();
			break;
		case MenuLX200Display:
			if( LX200ComPort)
			{
				LX200DisplayFlag = !LX200DisplayFlag;
				if( !LX200DisplayFlag)
				{
					for( Ix = 0;
					Ix < LX200_Cmd_Array_Size * (LX200_CMD_STR_SIZE + 1) + 3; Ix++)
						sprintf( StrBuf+Ix, "%c", Blank);
					VidMemXY = DisplayXY[DisplayLX200];
					TextAttr = DisplayText;
					WriteStrBufToScreen();

					for( Ix = 0; Ix < LX200QueueSize; Ix++)
						sprintf( StrBuf+Ix, "%c", Blank);
					VidMemXY.Y = DisplayXY[DisplayLX200].Y+1;
					VidMemXY.X = 2;
					TextAttr = DisplayText;
					WriteStrBufToScreen();
				}
			}
			else
				PressKeyToContMsg( "no LX200 comm port defined");
			break;
		case MenuChangeHsParms:
			WriteWindow( MsgFrame);
			EnterHsParms();
			RemoveWindow( MsgFrame);
			FreeHsArrays();
			CreateHsArrays();
			InitHsArrays();
			break;
		case MenuChangeMsParms:
			MsParmsAllowedFlag = !MsParmsAllowedFlag;
			TextAttr = DisplayText;
			VidMemXY = DisplayXY[DisplayMsParmsAllowed];
			sprintf( StrBuf, "%c", MsParmsAllowedFlag? 'Y':'N');
			WriteStrBufToScreen();
			if( MsParmsAllowedFlag)
			{
				WriteMsParmsMenu();
				if( !MsParmsTitlesWritten)
				{
					DisplayMsParmsTitles();
					MsParmsTitlesWritten = Yes;
					DisplayMsParmsValues();
				}
			}
			else
				WriteMainMenu();
			break;
		case MenuPECOnOff:
			PECFlag = !PECFlag;
			if( PECFlag)
			{
				if( AutoAltPECSyncOnFlag)
				{
					/* to prevent auto synch of PEC while in middle of microswitch
					range - PEC should only be auto sync'd at beginning of
					microswitch range when moving in CW direction */
					READ_AUTO_ALT_PEC_SYNC;
					if( AutoAltPECSyncLowHighFlag)
						AutoAltPECSyncSignal = !AutoAltPECSyncSignal;
					LastAutoAltPECSyncSignal = AutoAltPECSyncSignal;
				}
				else
					SynchAltPEC();
				if( AutoAzPECSyncOnFlag)
				{
					/* to prevent auto synch of PEC while in middle of microswitch
					range - PEC should only be auto sync'd at beginning of
					microswitch range when moving in CW direction */
					READ_AUTO_AZ_PEC_SYNC;
					if( AutoAzPECSyncLowHighFlag)
						AutoAzPECSyncSignal = !AutoAzPECSyncSignal;
					LastAutoAzPECSyncSignal = AutoAzPECSyncSignal;
				}
				else
					SynchAzPEC();
			}
			WritePECStatus();
			break;
		case MenuPECReload:
			DisplayOpeningMsgs = False;
			LoadPEC();
			break;
		case MenuPECDisplay:
			DisplayPECgraphically();
			break;
		case MenuPECAverageFiles:
			if( !AveragePECAnalysisFiles( altaxis))
				PressKeyToContMsg( "no pecalt**.txt files found");
			if( !AveragePECAnalysisFiles( azaxis))
				PressKeyToContMsg( "no pecaz**.txt files found");
			break;
		case MenuPECGuidingDisplay:
			AnalyzeGuideAltArray();
			AnalyzeGuideAzArray();
			break;
		case MenuPECZeroOut:
			ZeroAltPEC();
			ZeroAzPEC();
			PressKeyToContMsg( "Zeroed out Altitude and Azimuth PEC");
			break;
		case MenuInit1:
			EnterInit( 1);
			break;
		case MenuInit2:
			if( One.Init)
				EnterInit( 2);
			else
				PressKeyToContMsg( "Must enter init 1 first");
			break;
		case MenuInit3:
			if( Two.Init)
				EnterInit( 3);
			else
				PressKeyToContMsg( "Must enter init 2 first");
			break;
		case MenuAltOffset:
			ProcessAltOffset();
			break;
		case MenuDisplayInit:
			DisplayInit();
			break;
		case MenuOptimizeInit:
			if( Three.Init)
				OptimizeInit();
			else
				PressKeyToContMsg( "Must enter at least 3 inits");
			break;
		case MenuInitEncoders:
			if( EncoderType)
			{
				InitRingBuffer( EncoderComPort);
				ResetEncoders_f_ptr();
				if( EncoderState == Read)
				{
					QueryAndReadEncoders();
					if( EncoderState == Read)
						SetEncoderAZandEncoderOffset();
					else
						PressKeyToContMsg( "Could not read encoders");
				}
				else
					PressKeyToContMsg( "Could not reset encoders");
			}
			else
				PressKeyToContMsg( "Encoders not available");
			break;
		case MenuInputEquat:
			WriteWindow( MsgFrame);
			HoldXY.X = MsgFrame.Left + 5;
			HoldXY.Y = MsgFrame.Top + 2;
			gotoxy( HoldXY.X, HoldXY.Y);
			printf( "Please enter Input ");
			HoldXY.X = wherex();
			gotoxy( HoldXY.X, HoldXY.Y);
			InputEquat( &In, HoldXY.X, HoldXY.Y);
			RemoveWindow( MsgFrame);
			DisplayIn( "input equat", NameBlanks);
			break;
		case MenuOffsetEquat:
			WriteWindow( MsgFrame);
			HoldXY.X = MsgFrame.Left + 3;
			HoldXY.Y = MsgFrame.Top + 2;
			gotoxy( HoldXY.X, HoldXY.Y);
			printf( "Enter Offset from Current ");
			HoldXY.X = wherex();
			gotoxy( HoldXY.X, HoldXY.Y);
			InputEquat( &Offset, HoldXY.X, HoldXY.Y);
			RemoveWindow( MsgFrame);
			In.Ra = Current.Ra + Offset.Ra;
			In.Dec = Current.Dec + Offset.Dec;
			/* limit In.Ra and In.Dec to valid values */
			ValidRa( &In);
			ValidDec( &In);
			GetHMSH( In.Ra*RadToHundSec + .5, &In.RaHMSH);
			GetDMS( In.Dec*RadToArcsec + .5, &In.DecDMS);
			DisplayIn( "offset equat", NameBlanks);
			break;
		case MenuDriftEquat:
			WriteWindow( MsgFrame);
			HoldXY.X = MsgFrame.Left + 3;
			HoldXY.Y = MsgFrame.Top + 2;
			gotoxy( HoldXY.X, HoldXY.Y);
			printf( "Please enter Drift /hr ");
			HoldXY.X = wherex();
			gotoxy( HoldXY.X, HoldXY.Y);
			InputEquat( &Drift, HoldXY.X, HoldXY.Y);
			/*Drift entered in degrees converted to radians by InputAltaz */
			RemoveWindow( MsgFrame);
			DisplayDrift();
			Drift.RaHMSH.HundSec = 0;
			Drift.RaHMSH.Sign = Plus;
			CalcRadFromHMSH( &Drift.Ra, Drift.RaHMSH);
			CalcCommonDriftVars();
			break;
		case MenuInputAltaz:
			WriteWindow( MsgFrame);
			HoldXY.X = MsgFrame.Left + 5;
			HoldXY.Y = MsgFrame.Top + 2;
			gotoxy( HoldXY.X, HoldXY.Y);
			printf( "Please enter Input ");
			HoldXY.X = wherex();
			gotoxy( HoldXY.X, HoldXY.Y);
			InputAltaz( &In, HoldXY.X, HoldXY.Y);
			RemoveWindow( MsgFrame);
			DisplayIn( "input altaz", NameBlanks);
			break;
		case MenuOffsetAltaz:
			WriteWindow( MsgFrame);
			HoldXY.X = MsgFrame.Left + 3;
			HoldXY.Y = MsgFrame.Top + 2;
			gotoxy( HoldXY.X, HoldXY.Y);
			printf( "Enter Offset from Current ");
			HoldXY.X = wherex();
			gotoxy( HoldXY.X, HoldXY.Y);
			InputAltaz( &Offset, HoldXY.X, HoldXY.Y);
			RemoveWindow( MsgFrame);
			In.Alt = Current.Alt + Offset.Alt;
			In.Az = Current.Az + Offset.Az;
			DisplayIn( "offset altaz", NameBlanks);
			break;
		case MenuDriftAltaz:
			WriteWindow( MsgFrame);
			HoldXY.X = MsgFrame.Left + 3;
			HoldXY.Y = MsgFrame.Top + 2;
			gotoxy( HoldXY.X, HoldXY.Y);
			printf( "Please enter Drift \"/min ");
			HoldXY.X = wherex();
			gotoxy( HoldXY.X, HoldXY.Y);
			InputAltaz( &Drift, HoldXY.X, HoldXY.Y);
			/*Drift entered in degrees converted to radians by InputAltaz */
			Drift.Alt /= 3600.;
			Drift.Az /= 3600.;
			RemoveWindow( MsgFrame);
			DisplayDrift();
			/* "/min */
			CalcCommonDriftVars();
			break;
		case MenuMoveEquat:
			/* scope will slew or track to the new Current Ra and Dec
			next time through function via ProcessHPEvents() then
			MoveToCurrentRaDec() */
			if( Two.Init)
			{
				if( !TrackFlag)
				{
					TrackFlag = Yes;
					WriteTrackStatus();
				}
				Current.Ra = In.Ra;
				Current.Dec = In.Dec;
			}
			break;
		case MenuMoveAltaz:
			/* Delta = new - old */
			Delta.A = In.Alt - Current.Alt;
			Delta.Z = In.Az - Current.Az;
			SetDirDistanceStepsThenMove();
			PauseUntilNewSidTime();
			HPEventGetEquat();
			break;
		case MenuMoveHome:
			/* Delta = new - old */
			Delta.A = HomeAltDeg/RadToDeg - Current.Alt;
			Delta.Z = HomeAzDeg/RadToDeg - Current.Az;
			SetDirDistanceStepsThenMove();
			PauseUntilNewSidTime();
			HPEventGetEquat();
			break;
		case MenuSav1:
			ProcessSav1();
			break;
		case MenuRes1:
			ProcessRes1();
			break;
		case MenuSav2:
			ProcessSav2();
			break;
		case MenuRes2:
			ProcessRes2();
			break;
		case MenuResetEquat:
			/* set current equat to input equat */
			Current.Ra = In.Ra;
			Current.Dec = In.Dec;
			/* get current altaz */
			GetAltaz();
			CheckSiderostatAltaz();
			/* set scope to current altaz */
			SetAccumMsToCurrentAltaz();
			/* get new current equat */
			HPEventGetEquat();
			/* redo encoder vars */
			SetEncoderAZandEncoderOffset();
			break;
		case MenuResetAltaz:
			Current.Alt = In.Alt;
			Current.Az = In.Az;
			SetAccumMsToCurrentAltaz();
			HPEventGetEquat();
			SetEncoderAZandEncoderOffset();
			break;
		case MenuResetHome:
			Current.Alt = HomeAltDeg/RadToDeg;
			Current.Az = HomeAzDeg/RadToDeg;
			SetAccumMsToCurrentAltaz();
			HPEventGetEquat();
			SetEncoderAZandEncoderOffset();
			break;
		case MenuResetToEncoders:
			if( EncoderState == Read)
			{
				Current.Alt = EncoderAZ.A;
				Current.Alt = EncoderAZ.A;
				SetAccumMsToCurrentAltaz();
				DisplayIn( "encoder reset", NameBlanks);
				HPEventGetEquat();
			}
			else
				PressKeyToContMsg( "Encoders not readable");
			break;
		case MenuGEMMeridianFlip:
			if( TrackFlag)
				TrackFlag = No;

			/* flip a german equatorial mount across the meridian:
			the Ra tracking movement will continue to move in the same direction
			but the Dec movement will be reversed, this is accomplished by: */
			InitConvertEquatMeridianFlip();

			/* if Ra, Dec are to be kept the same then flip Azimuth by 180 and
			flip Altitude across the pole */
			if( Current.Alt >= 0)
				Current.Alt = Current.Alt - HalfRev;
			else
				Current.Alt = HalfRev + Current.Alt;
			ValidAlt( &Current);
			Current.Az += HalfRev;
			ValidAz( &Current);
			SetAccumMsToCurrentAltaz();

			/* take care of the altitude encoder direction change */
			AltEncoderDir = !AltEncoderDir;
			SetEncoderAZandEncoderOffset();

			PressKeyToContMsg( "Now flip the scope across the meridian");
			break;
		case MenuFRReset:
			if( DoFR && Two.Init)
			{
				CalcFieldR();
				FRMotorAngle = FieldR;
			}
			break;
		default:
			ProcessHPEvents();
	}
}

void SetNewMenuCatSub( void)
{
	switch( Response)
	{
		case DownCursor:
			if( CurrentMenuSub < MenuArray[CurrentMenuCat].NumSubTitles - 1)
				NewMenuSub = CurrentMenuSub + 1;
			break;
		case UpCursor:
			if( CurrentMenuSub > 0)
				NewMenuSub = CurrentMenuSub - 1;
			break;
		case RightCursor:
			if( NewMenuCat < MaxMenuCats - 1)
			{
				NewMenuCat = CurrentMenuCat + 1;
				NewMenuSub = 0;
			}
			break;
		case LeftCursor:
			if( NewMenuCat > 0)
			{
				NewMenuCat = CurrentMenuCat - 1;
				NewMenuSub = 0;
			}
			break;
		case Tab:
			break;
		case Shift_Tab:
			break;
	}
}

void GetNewMenuCatSubFromResponse( void)
{
	NewMenuCat = NewMenuSub = 0;

	while( Response != MenuArray[NewMenuCat].SubTitles[NewMenuSub].MenuItem)
	{
		NewMenuSub++;
		if( NewMenuSub == MaxMenuSubs)
		{
			NewMenuSub = 0;
			NewMenuCat++;
			if( NewMenuCat == MaxMenuCats)
				BadExit( "couldn't match Response in GetNewMenuCatSubFromResponse()");
		}
	}
}

void GetGrandTourRec( void)
{
	struct Object O;
	int RecNum = 1;

	/* scan through file, ending with read of desired record */
	while( !feof( Input))
	{
		ReadRa( Input, &O.RaHMSH);
		if( !feof( Input))
			ReadDec( Input, &O.DecDMS);
		if( !feof( Input))
			ReadString( Input, O.Name);

		if( RecNum == GrandTourRecNum)
			break;
		else
			RecNum++;
	}
	if( !feof( Input) && RecNum == GrandTourRecNum)
	{
		CalcRadFromHMSH( &Current.Ra, O.RaHMSH);
		CalcRadFromDMS( &Current.Dec, O.DecDMS);
		In = Current;
		DisplayIn( GrandTourFilename, O.Name);
	}
	else
	{
		GrandTourRecNum--;
		PressKeyToContMsg( "grand tour: at end of data file");
	}
}

void ProcessGrandTour( void)
{
	/* time to reset handpad key */
	delay( 1000);
	Input = fopen( GrandTourFilename, "r");
	if( Input == NULL)
		BadExit( strcat( "Could not open ", GrandTourFilename));

	if( Buttons == LeftKey)
	{
		GrandTourRecNum++;
		GetGrandTourRec();
	}
	/* Buttons == RightKey */
	else
	{
		if( GrandTourRecNum == 0)
		{
			PressKeyToContMsg( "Grand Tour: first object not moved to yet");
			DisplayIn( GrandTourFilename, NameBlanks);
		}
		else
		{
			GrandTourRecNum--;
			if( GrandTourRecNum < 1)
			{
				PressKeyToContMsg( "Grand Tour: at first object");
				GrandTourRecNum = 1;
			}
			else
				GetGrandTourRec();
		}
	}
	fclose( Input);
	/* set to yes in ProcessHPEvents() */
	GrandTourFlag = No;
}

void Move_Update_Handpad_Subr( void)
{
	MoveToCurrentRaDec();
	DoAProcessTimedToBiosClockTick();
	ReadHandPad_f_ptr();
	/* subtract MsKey if it is on */
	Buttons = HandPad - (HandPad & MsKey);
	/* if RightKey or KeyStoke, finished with all Scroll */
	if( Buttons == RightKey || KeyStroke)
		ScrollFlag = No;
}

void ProcessAltOffset( void)
{
	struct Position Temp;

	if( AltOffset != MAXDOUBLE)
	{
		WriteWindow( MsgFrame);
		VidMemXY.X = MsgFrame.Left + 3;
		VidMemXY.Y = MsgFrame.Top + 2;
		gotoxy( VidMemXY.X, VidMemXY.Y);
		printf( "Add in altitude offset and re-init? ");
		Response = getch();
		if( Response == 'y' || Response == 'Y')
		{
			Current.Alt += AltOffset;
			SetAccumMsToCurrentAltaz();
			SetEncoderAZandEncoderOffset();
			if( Three.Init)
				Three.Alt += AltOffset;
			if( Two.Init)
			{
				Two.Alt += AltOffset;
				One.Alt += AltOffset;
				AltOffset = 0;
			}
			if( Three.Init)
			{
				Temp = Current;
				Current = Three;
				KBEventInitMatrix( 3);
				Current = Temp;
			}
			else
				if( Two.Init)
				{
					Temp = Current;
					Current = Two;
					KBEventInitMatrix( 2);
					Current = Temp;
				}
			HPEventGetEquat();
		}
		RemoveWindow( MsgFrame);
	}
}

void ProcessSav1( void)
{
	/* saves current coordinates to SavedIn */
	SavedIn = Current;
	ProcessHPEvents();
}

void ProcessRes1( void)
{
	/* retrieves SavedIn coordinates and puts them in Input fields */
	In = SavedIn;
	DisplayIn( "saved input #1", NameBlanks);
	ProcessHPEvents();
}

void ProcessSav2( void)
{
	/* saves current coordinates to SavedIn2 */
	SavedIn2 = Current;
	ProcessHPEvents();
}

void ProcessRes2( void)
{
	/* retrieves SavedIn2 coordinates and puts them in Input fields */
	In = SavedIn2;
	DisplayIn( "saved input #2", NameBlanks);
	ProcessHPEvents();
}

void KillInits( void)
{
	WriteWindow( MsgFrame);
	VidMemXY.X = MsgFrame.Left + 3;
	VidMemXY.Y = MsgFrame.Top + 2;
	gotoxy( VidMemXY.X, VidMemXY.Y);
	printf( "Sure you want to kill all initializations? ");
	Response = getch();
	if( Response == 'y' || Response == 'Y')
		One.Init = Two.Init = Three.Init = No;
	RemoveWindow( MsgFrame);
	DisplayInitStatusOnScreen();
}

void ProcessScroll( void)
{
	int TicksForMove;
	int TickCount;
	double RaPerTick, DecPerTick;

	ScrollUnderway = Yes;
	WriteHandpadStatus();
	TrackFlag = Yes;
	CurrentScroll = NULL;
	while( ScrollFlag)
	{
		/* get the next Scroll */
		if( CurrentScroll == NULL)
			CurrentScroll = FirstScroll;
		else
			CurrentScroll = CurrentScroll->NextScroll;
		if( CurrentScroll == NULL)
			ScrollFlag = No;
		else
		{
			DisplayIn( ScrollFilename, CurrentScroll->Note);
			/* give 1/2 sec to move hand pad mode switch back to center position,
			otherwise moving hand paddle switch during slew will result in slew
			being cancelled
			sound( 100);
			delay( 500);
			nosound(); */
			ReadHandPad_f_ptr();
			/* subtract MsKey if it is on */
			Buttons = HandPad - (HandPad & MsKey);
			/* spread move over CurrentScroll->Sec time, calc # of ticks to use */
			TicksForMove = CurrentScroll->Sec * ClockTicksSec;
			/* if offset equatorial coordinates */
			if( CurrentScroll->CoordType == equat_off)
			{
				RaPerTick = CurrentScroll->Ra / (double) TicksForMove;
				DecPerTick = CurrentScroll->Dec / (double) TicksForMove;
			}
			/* else absolute equatorial coordinates */
			else
			{
				RaPerTick = (CurrentScroll->Ra - Current.Ra) / (double) TicksForMove;
				DecPerTick = (CurrentScroll->Dec - Current.Dec) / (double) TicksForMove;
			}
			CurrentScrollFlag = Yes;
			TickCount = 0;
			/* move to 'scroll to' position */
			while( TickCount < TicksForMove && CurrentScrollFlag && ScrollFlag)
			{
				TickCount++;
				Current.Ra += RaPerTick;
				Current.Dec += DecPerTick;
				Move_Update_Handpad_Subr();
				if( !CurrentScrollFlag)
					CurrentScrollFlag = Yes;
			}
			/* after 'scroll to' finished, mark time by tracking */
			while( CurrentScrollFlag && ScrollFlag)
			{
				Move_Update_Handpad_Subr();
				/* if LeftKey, start next scroll */
				if( Buttons == LeftKey)
					CurrentScrollFlag = No;
			}
		}
	}
	if( KeyStroke)
		getch();
	TextAttr = DisplayText;
	VidMemXY = DisplayXY[DisplayObject];
	sprintf( StrBuf, NameBlanks);
	WriteStrBufToScreen();
	ScrollUnderway = No;
	WriteHandpadStatus();
}

/* Keyboard events checked every bios clock tick */
void ProcessKBEvents( void)
{
	Response = getch();

	/* handle response based on which menu is active and displayed */
	if( MsParmsAllowedFlag)
		ProcessMsParmsResponse();
	else
		ProcessMenuResponse();
}

void ProcessMsParmsResponse( void)
{
	int Ix;

	switch( Response)
	{
		case 'q': case 'Q':
			Response = MenuChangeMsParms;
			ProcessMenuSelection();
			break;
		case ExtendedKeyboardStroke:
			TextAttr = DisplayText;
			VidMemXY.Y = DisplayXY[DisplayMsPWMs].Y;
			Response = getch();
			switch( Response)
			{
				case Shift_F1:
					MsPause++;
					sprintf( StrBuf, "%3d", MsPause);
					VidMemXY.X = DisplayXY[DisplayMsPWMs].X + 68;
					WriteStrBufToScreen();
					break;
				case F1:
					MsPause--;
					if(MsPause < 0)
						MsPause = 0;
					sprintf( StrBuf, "%3d", MsPause);
					VidMemXY.X = DisplayXY[DisplayMsPWMs].X + 68;
					WriteStrBufToScreen();
					break;
				case Shift_F2:
					MsDelayX++;
					sprintf( StrBuf, "%3d", MsDelayX);
					VidMemXY.X = DisplayXY[DisplayMsPWMs].X + 62;
					WriteStrBufToScreen();
					break;
				case F2:
					MsDelayX--;
					if(MsDelayX < 0)
						MsDelayX = 0;
					sprintf( StrBuf, "%3d", MsDelayX);
					VidMemXY.X = DisplayXY[DisplayMsPWMs].X + 62;
					WriteStrBufToScreen();
					break;
			}
			if( Response >= Alt_F1 && Response <= Alt_F10)
			{
				Ix = Response - Alt_F1;
				PWM[Ix]++;
				FreeMsArrays();
				CreateMsArrays();
				InitMsArrays();
				sprintf( StrBuf, "%3d", PWM[Ix]);
				VidMemXY.X = DisplayXY[DisplayMsPWMs].X + Ix*6 + 2;
				WriteStrBufToScreen();
			}
			else
				if( Response >= Ctrl_F1 && Response <= Ctrl_F10)
				{
					Ix = Response - Ctrl_F1;
					PWM[Ix]--;
					FreeMsArrays();
					CreateMsArrays();
					InitMsArrays();
					sprintf( StrBuf, "%3d", PWM[Ix]);
					VidMemXY.X = DisplayXY[DisplayMsPWMs].X + Ix*6 + 2;
					WriteStrBufToScreen();
				}
	}
}

void ProcessVirtualHandpad( void)
{
	struct AZLong HoldSteps;

	Steps.A = Steps.Z = 0;

	switch( Response)
	{
		case F1:
			Steps.A = MsTick.A;
			Dir.A = CW;
			break;
		case F2:
			Steps.A = MsTick.A;
			Dir.A = CCW;
			break;
		case F3:
			Steps.Z = MsTick.Z;
			Dir.Z = CCW;
			break;
		case F4:
			Steps.Z = MsTick.Z;
			Dir.Z = CW;
	}
	HoldSteps = Steps;
	while( True)
	{
		HPEventMoveMs();
		/* add undone steps to steps to do for next clock tick */
		Steps.A += HoldSteps.A;
		Steps.Z += HoldSteps.Z;
		if( KeyStroke)
			getch();
		else
			break;
	}
	while( KeyStroke)
		getch();
	AlignMs();
	SetCurrentAltazToAccumMs();
	HPEventGetEquat();
}

void ProcessMenuResponse( void)
{
	switch( Response)
	{
		/* here each case ends in a break: these are responses that do not involve
		menu item selection processing by ProcessMenuSelection() */
		case Tab:
			SetNewMenuCatSub();
			UpdateMenuCatSub();
			ProcessHPEvents();
			break;
		case ExtendedKeyboardStroke:
			Response = getch();
			if( Response == F1 || Response == F2
			|| Response == F3 || Response == F4)
				ProcessVirtualHandpad();
			else
				if( Response == DownCursor || Response == UpCursor
				|| Response == RightCursor || Response == LeftCursor
				|| Response == Shift_Tab)
				{
					SetNewMenuCatSub();
					UpdateMenuCatSub();
				}
				ProcessHPEvents();
			break;
		case 'e': case 'E':
			if( !AveragePECAnalysisFiles( altaxis))
				PressKeyToContMsg( "no pecalt**.txt files found");
			break;
		case 'f': case 'F':
			if( !AveragePECAnalysisFiles( azaxis))
				PressKeyToContMsg( "no pecaz**.txt files found");
			break;
		case 'k': case 'K':
			KillInits();
			break;
		case 'u': case 'U':
			AnalyzeGuideAltArray();
			break;
		case 'v': case 'V':
			AnalyzeGuideAzArray();
			break;
		case 'y': case 'Y':
			ZeroAltPEC();
			PressKeyToContMsg( "Zeroed out Altitude PEC");
			break;
		case 'z': case 'Z':
			ZeroAzPEC();
			PressKeyToContMsg( "Zeroed out Azimuth PEC");
			break;
		case Return:
			Response = MenuArray[CurrentMenuCat].SubTitles[CurrentMenuSub].MenuItem;
			ProcessMenuSelection();
			break;
		/* no breaks so as to fall through */
		case Left_Apostrophe:
			if( Response == Left_Apostrophe)
				Response = MenuGuide;
		case '1':
			if( Response == '1')
				Response = MenuMoveEquat;
		case '2':
			if( Response == '2')
				Response = MenuTrack;
		case '3':
			if( Response == '3')
				Response = MenuSav1;
		case '4':
			if( Response == '4')
				Response = MenuRes1;
		case '5':
			if( Response == '5')
				Response = MenuSav2;
		case '6':
			if( Response == '6')
				Response = MenuRes2;
		case '7':
			if( Response == '7')
				Response = MenuReadSlew;
		case '8':
			if( Response == '8')
				Response = MenuWriteSlew;
		case '9':
			if( Response == '9')
				Response = MenuInputAltaz;
		case '0':
			if( Response == '0')
				Response = MenuResetAltaz;
		case 'a': case 'A':
			if( Response == 'a' || Response == 'A')
				Response = MenuAltOffset;
		case 'c': case 'C':
			if( Response == 'c' || Response == 'C')
				Response = MenuPECDisplay;
		case 'd': case 'D':
			if( Response == 'd' || Response == 'D')
				Response = MenuDataFile;
		case 'g': case 'G':
			if( Response == 'g' || Response == 'G')
				Response = MenuGuide;
		case 'h': case 'H':
			if( Response == 'h' || Response == 'H')
				Response = MenuHandPad;
		case 'i': case 'I':
			if( Response == 'i' || Response == 'I')
				Response = MenuDisplayInit;
		case 'l': case 'L':
			if( Response == 'l' || Response == 'L')
				Response = MenuPECReload;
		case 'm': case 'M':
			if( Response == 'm' || Response == 'M')
				Response = MenuMsSpeed;
		case 'p': case 'P':
			if( Response == 'p' || Response == 'P')
				Response = MenuPECOnOff;
		case 'q': case 'Q':
			if( Response == 'q' || Response == 'Q')
				Response = MenuQuit;
		case 'r': case 'R':
			if( Response == 'r' || Response == 'R')
				Response = MenuResetEquat;
		case 's': case 'S':
			if( Response == 's' || Response == 'S')
				Response = MenuScrollTour;
		case 't': case 'T':
			if( Response == 't' || Response == 'T')
				Response = MenuTrack;
			/* all fall through to here... */
			GetNewMenuCatSubFromResponse();
			UpdateMenuCatSub();
			ProcessMenuSelection();
			break;
		default:
			ProcessHPEvents();
	}
}

void InputEquatSlewDat( void)
{
	/* read (rb) slew.dat where:
	R <Ra degrees>
	D <Dec degrees>
	p <Alt degrees>
	q <Az degrees>
	...
	t <time()> <JD>
	L <lat> <long> */
	Input = fopen( FullyQualifiedSlewFile, "r");
	if( Input == NULL)
		PressKeyToContMsg( "Could not read slew file");
	else
	{
		do
			fscanf( Input, "%s", Name);
		while( strcmpi( Name, "R") != 0);
		ReadDouble( Input, &In.Ra);
		In.Ra /= RadToDeg;
		do
			fscanf( Input, "%s", Name);
		while( strcmpi( Name, "D") != 0);
		ReadDouble( Input, &In.Dec);
		In.Dec /= RadToDeg;
		fclose( Input);
		DisplayIn( "from guide (Ra, Dec)", NameBlanks);
	}
}

void WriteEquatSlewOutFile( void)
{
	Output = fopen( FullyQualifiedSlewOutFile, "w");
	if( Output == NULL)
		PressKeyToContMsg( "Could not write slew out file");
	else
	{
		/* az, then alt */
		fprintf( Output, "R %f %f", Current.Ra*RadToDeg, Current.Dec*RadToDeg);
		fclose( Output);
	}
}

void WriteAltazSlewOutFile( void)
{
	Output = fopen( FullyQualifiedSlewOutFile, "w");
	if( Output == NULL)
		PressKeyToContMsg( "Could not write slew out file");
	/* az, then alt */
	fprintf( Output, "%f %f", Current.Az*RadToDeg, Current.Alt*RadToDeg);
	fclose( Output);
}

void BadExit( const char* Msg)
{
	FRMotorOff();
	CloseSteppers();
   CloseEncoderResetLogFile();
	CloseSerial( EncoderComPort);
	CloseSerial( LX200ComPort);
	BadMsgExit( Msg);
}

void main( int argc, char** argv)
{
	int Ix;

	BaudRate = 9600;
	Parity = NoneParity;
	DataBits = 8;
	StopBits = 1;

	CalledByGuideFlag = No;
	KeepGoingFlag = No;
	ReadSlewFlag = No;

	/* if '-k' and '-s' (after full init): slew to Ra, Dec in slew.dat and
	keep going, exiting when desired, writing slew_out.dat file;
	if '-k' (before full init): (no slew.dat), keep going until centered on
	init position, write slew_out.dat file and exit;
	if '-s': slew to Ra, Dec in slew.dat and exit, writing slew_out.dat file;
	if no '-k' and no '-s': write slew_out.dat file and exit */

	/* argv[0] is name of executing program */
	for( Ix = 1; Ix < argc; Ix++)
		if( argv[Ix][0] == '-')
			if( strcmpi( &argv[Ix][1], "GUIDE") == 0)
				CalledByGuideFlag = Yes;
			else if( argv[Ix][1] == 'k')
				KeepGoingFlag = Yes;
			else if( argv[Ix][1] == 's')
				ReadSlewFlag = Yes;

	InitCommonVars();
	ReadConfig();
	if( DisplayOpeningMsgs)
		printf( "\ncalled by guide: %d, keep_going: %d, read slew.dat file %d",
		CalledByGuideFlag, KeepGoingFlag, ReadSlewFlag);

	if( strcmpi( TestString, "TestSerial") == 0)
	{
		InitSerial( EncoderComPort, BaudRate, Parity, DataBits, StopBits);
		TestSerial( EncoderComPort);
	}
	else if( strcmpi( TestString, "TestVideo") == 0)
	{
		InitVideo( DisplayOpeningMsgs);
		TestVideo();
	}
	else if( strcmpi( TestString, "TestATimes") == 0)
	{
		InitTimes( DisplayOpeningMsgs, Tz, DST, LongitudeDeg);
		TestTimes();
	}
	else if( strcmpi( TestString, "TestParallelPort") == 0)
	{
		InitPPort();
		TestPPort();
	}
	else if( strcmpi( TestString, "TestMouse") == 0)
	{
		TestMouse();
	}
	else if( strcmpi( TestString, "TestEncoders") == 0)
	{
		InitSerial( EncoderComPort, BaudRate, Parity, DataBits, StopBits);
		InitEncoders();
		TestEncoders();
	}
	else if( strcmpi( TestString, "TestHandpad") == 0)
	{
		InitPPort();
		InitHandpad();
		TestHandpad();
	}
	else if( strcmpi( TestString, "TestConversion") == 0)
	{
		InitTimes( DisplayOpeningMsgs, Tz, DST, LongitudeDeg);
		InitCoord( DisplayOpeningMsgs);
		InitConvert();
		TestConvert();
	}
	else if( strcmpi( TestString, "TestAltOffset") == 0)
	{
		InitTimes( DisplayOpeningMsgs, Tz, DST, LongitudeDeg);
		InitCoord( DisplayOpeningMsgs);
		InitConvert();
		TestAltOffset();
	}
	else if( strcmpi( TestString, "TestIACA") == 0)
	{
		InitTimes( DisplayOpeningMsgs, Tz, DST, LongitudeDeg);
		InitCoord( DisplayOpeningMsgs);
		TestIACA();
		InitIACA();
	}
	else if( strcmpi( TestString, "Track") == 0)
	{
		InitTimes( DisplayOpeningMsgs, Tz, DST, LongitudeDeg);
		InitVideo( DisplayOpeningMsgs);
		InitPPort();
		InitSteppers();
		Track();
	}
	else if( strcmpi( TestString, "PreloadGuidexx.dat") == 0
	|| strcmpi( TestString, "NoTest") == 0)
	{
		InitSerial( EncoderComPort, BaudRate, Parity, DataBits, StopBits);
		InitEncoders();
		InitTimes( DisplayOpeningMsgs, Tz, DST, LongitudeDeg);
		InitVideo( DisplayOpeningMsgs);
		InitPPort();
		InitHandpad();
		InitSteppers();
		InitCoord( DisplayOpeningMsgs);
		InitConvert();
		InitRefract();
		InitPEC();
		InitGuide();
		if( strcmpi( TestString, "PreloadGuidexx.dat") == 0)
		{
			LoadGuideAlts();
			LoadGuideAzs();
		}
		InitIACA();
		InitLX200Input();
		InitHPEvent();

		if( !CalledByGuideFlag ||
		(CalledByGuideFlag && (KeepGoingFlag || ReadSlewFlag)))
		{
			InitKBEvent();
			if( ReadSlewFlag)
				InputEquatSlewDat();
			while( !QuitFlag)
			{
				DoAProcessTimedToBiosClockTick();
				if( GrandTourLoaded && GrandTourFlag)
					ProcessGrandTour();
				else
					if( ScrollLoaded && ScrollFlag)
						ProcessScroll();
					else
						if( KeyStroke)
							ProcessKBEvents();
						else
							ProcessHPEvents();
			}
			CloseKBEvent();
		}
	}
	else
		BadExit( strcat( "Invalid TestString: ", TestString));

	FRMotorOff();
	CloseSteppers();
	CloseEncoderResetLogFile();
	CloseSerial( EncoderComPort);
	CloseSerial( LX200ComPort);
	SaveCurrentAltaz();
	if( CalledByGuideFlag)
		WriteAltazSlewOutFile();
}

